'From etoys2.2 of 1 October 2007 [latest update: #1675] on 8 December 2007 at 12:41:38 am'!
"Change Set:		Sokoban
Date:			13 May 2007
Author:			Robert Hirschfeld
Author:			Robert Hirschfeld (hirschfeld@acm.org)
Version:			0.5.4
Prerequisites:	none

Acknowledgments:
--
Robert Krahn [rkrk]
	* Port to OLPC image
	* Squeak theme
Andreas Junghanns (http://www.cs.ualberta.ca/~games/Sokoban/)
David W. Skinner (http://users.bentonrea.com/~sasquatch/sokoban/)

doIt: [SokobanMorph random openInWorld]
doIt: [(SokobanMorph forIndex: 1) openInWorld]

doIt: [SokobanTheme current: (SokobanTheme themesAt: 'Simple')]
doIt: [SokobanTheme current: (SokobanTheme themesAt: 'Mouse')]

The game was apparently invented in the early 1980s by Thinking Rabbit, a computer games company in the town of Takarazuka, Japan. The game design is said to have won first prize in a computer games contest. Because of the simplicity and elegance of the rules, and the intellectually challenging complexity of the composed problems, Sokoban quickly became a popular pastime. The object of Sokoban is to push all stones (or boxes) in a maze, such as the one to the right, to the designated goal areas. The player controls the man and the man can only push stones and only one at a time. The restriction of only being able to push the stones makes this game challenging: One can create unsolvable positions. Players will soon learn that this is the main obstacle in solving problems. Advanced players also try to find shorter and shorter solutions, measured in stone pushes and man moves. (Andreas Junghanns)

Key mappings:
---
Cursor left => move left
Cursor right => move right
Cursor up => move up
Cursor down => move down
Shift w/ cursor key => moves as far as possible without pushing boxes
Control w/ cursor key => moves as far as possible including pushing boxes

a => again (same maze)
h => help
n => next (another maze, next in line)
p => previous (another maze, previous in line)
r => random (another maze, random selection)
t => theme (another theme)

q => quit

Comments or suggestions?
--
Hasso-Plattner-Institut
Software Architecture Group

http://www.hpi.uni-potsdam.de/swa/

Robert Hirschfeld <hirschfeld@acm.org>"!

ImageMorph subclass: #SokobanBlock
	instanceVariableNames: 'location sworld blockSize'
	classVariableNames: 'DefaultImage'
	poolDictionaries: ''
	category: 'Games-Sokoban'!
TestCase subclass: #SokobanBlockTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-Sokoban-Test'!
SokobanBlock subclass: #SokobanBox
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-Sokoban'!
Object subclass: #SokobanField
	instanceVariableNames: 'rows'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-Sokoban'!
SokobanBlock subclass: #SokobanGoal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-Sokoban'!
Morph subclass: #SokobanMorph
	instanceVariableNames: 'sworld score'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-Sokoban'!
SokobanBlock subclass: #SokobanPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-Sokoban'!
Object subclass: #SokobanTheme
	instanceVariableNames: 'name images'
	classVariableNames: 'Current Themes'
	poolDictionaries: ''
	category: 'Games-Sokoban'!
SokobanBlock subclass: #SokobanWall
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-Sokoban'!
Object subclass: #SokobanWorld
	instanceVariableNames: 'index fixed movable range player boxes moves pushes'
	classVariableNames: 'MazeSetName Mazes'
	poolDictionaries: ''
	category: 'Games-Sokoban'!

!Object methodsFor: '*Games-Sokoban' stamp: 'rhi 7/17/2003 13:35'!
isSokobanBlock

	^ false! !

!Object methodsFor: '*Games-Sokoban' stamp: 'rhi 7/17/2003 10:34'!
isSokobanBox

	^ false! !

!Object methodsFor: '*Games-Sokoban' stamp: 'rhi 7/17/2003 10:34'!
isSokobanGoal

	^ false! !

!Object methodsFor: '*Games-Sokoban' stamp: 'rhi 7/17/2003 10:34'!
isSokobanPlayer

	^ false! !

!Object methodsFor: '*Games-Sokoban' stamp: 'rhi 10/26/2005 18:22'!
isSokobanTheme

	^ false! !

!Object methodsFor: '*Games-Sokoban' stamp: 'rhi 7/17/2003 10:34'!
isSokobanWall

	^ false! !


!SokobanBlock methodsFor: 'accessing' stamp: 'rkrk 5/13/2007 12:37'!
blockSize

	^ blockSize! !

!SokobanBlock methodsFor: 'accessing' stamp: 'rkrk 5/13/2007 12:37'!
blockSize: newSize

	blockSize := newSize.! !

!SokobanBlock methodsFor: 'accessing' stamp: 'rkrk 5/13/2007 16:20'!
fitIntoWorld

	| oldSizeX columns worldX oldSizeY rows worldY fitX fitY additionalHeight |
	oldSizeX := self blockSize x.
	columns := self sworld range x.
	worldX := World extent x.
	oldSizeY := self blockSize y.
	rows := self sworld range y.
	worldY := World extent y.
	additionalHeight := SokobanMorph titleHeight + SokobanMorph controlsHeight.
	((oldSizeX * columns) > worldX or: [(oldSizeY * rows + additionalHeight) > worldY])
		ifTrue: [
				fitX := (worldX / columns) floor.
				fitY := (worldY - additionalHeight / rows ) floor.
				self blockSize: (fitX min: fitY) asPoint.
				self newForm: (self form scaledToSize: self blockSize).
				self extent: self blockSize].! !

!SokobanBlock methodsFor: 'accessing' stamp: 'rkrk 5/13/2007 12:40'!
image: aForm

	super image: (aForm scaledToSize: self blockSize).! !

!SokobanBlock methodsFor: 'accessing' stamp: 'rhi 7/16/2003 22:52'!
location
	"^ <Point>"

	^ location! !

!SokobanBlock methodsFor: 'accessing' stamp: 'rhi 7/17/2003 13:07'!
location: aPoint

	location := aPoint.! !

!SokobanBlock methodsFor: 'accessing' stamp: 'rhi 7/17/2003 11:23'!
sworld
	"^ <SokobanWorld>"

	^ sworld! !

!SokobanBlock methodsFor: 'accessing' stamp: 'rkrk 5/13/2007 12:43'!
sworld: aSokobanWorld

	sworld := aSokobanWorld.! !

!SokobanBlock methodsFor: 'images' stamp: 'rhi 10/26/2005 19:14'!
blockImage

	^ self class blockImage! !

!SokobanBlock methodsFor: 'initialization' stamp: 'rkrk 5/13/2007 12:41'!
initialize

	blockSize := self class blockSize.
	self flag: #rhi. "Move super-call up in sequence?!!"
	super initialize.
	self
		extent: self blockSize;
		image: self blockImage.! !

!SokobanBlock methodsFor: 'testing' stamp: 'rhi 7/17/2003 13:35'!
isSokobanBlock

	^ true! !


!SokobanBlock class methodsFor: 'accessing' stamp: 'rhi 10/26/2005 19:07'!
defaultImage
	"^ <Form>"

	^ DefaultImage! !

!SokobanBlock class methodsFor: 'accessing' stamp: 'rhi 10/26/2005 19:07'!
defaultImage: aForm

	DefaultImage := aForm! !

!SokobanBlock class methodsFor: 'class initialization' stamp: 'rhi 10/26/2005 19:09'!
initialize
	"doIt: [self initialize]"

	super initialize.
	self defaultImage: (Form extent: self blockSize).! !

!SokobanBlock class methodsFor: 'constants' stamp: 'rhi 10/26/2005 19:09'!
blockSize

	^ 32 @ 32! !

!SokobanBlock class methodsFor: 'images' stamp: 'rhi 10/26/2005 19:11'!
blockImage

	^ self defaultImage! !


!SokobanBlockTest methodsFor: 'running' stamp: 'rkrk 5/13/2007 12:44'!
testExtentSmallerThanWorld

	| sokoban |
	sokoban := SokobanMorph new.
	SokobanWorld mazeSets keysDo: [:worldName |
		sokoban sworld setMazesNamed: worldName.
		1 to: SokobanWorld mazes size do: [:index |
			sokoban initializeForIndex: index.
			self assert: World extent >= sokoban extent]].! !

!SokobanBlockTest methodsFor: 'running' stamp: 'rhi 5/13/2007 19:16'!
testMasMicrobanSmallerThanWorld

	| sokoban |
	sokoban := SokobanMorph new.
	sokoban sworld setMazesNamed: #mazesMasMicroban.
	self flag: #rhi. "Magic numbers?"
	sokoban initializeForIndex: 134.
	self assert: World extent >= sokoban extent.
	World extent <= (1200 @ 900) ifTrue: [
		self assert: ((sokoban sworld fixed rows first) at: 15)
			blockSize < SokobanBlock blockSize].! !


!SokobanBox methodsFor: 'testing' stamp: 'rhi 7/16/2003 19:07'!
isSokobanBox

	^ true! !

!SokobanBox methodsFor: 'private' stamp: 'rhi 7/17/2003 13:37'!
canMoveBy: aPoint

	| target |
	target := self location + aPoint.
	^ ((self sworld fixedAt: target) isSokobanBlock not
		or: [(self sworld fixedAt: target) isSokobanGoal])
			and: [(self sworld movableAt: target) isSokobanBlock not]! !

!SokobanBox methodsFor: 'private' stamp: 'rhi 10/26/2005 01:00'!
moveBy: aPoint

	| current new |
	current := self location.
	new := current + aPoint.
	(self sworld)
		movableAt: current put: nil;
		movableAt: new put: self.
	self
		location: new;
		position: self position + (self blockSize * aPoint).! !


!SokobanBox class methodsFor: 'images' stamp: 'rhi 10/26/2005 19:12'!
blockImage

	^ SokobanTheme current boxImage! !


!SokobanField methodsFor: 'accessing' stamp: 'rhi 7/16/2003 18:04'!
rows
	"^ <SequenceableCollection of: <SequenceableCollection of: SokobanBlock>>"

	^ rows! !

!SokobanField methodsFor: 'accessing' stamp: 'rhi 7/16/2003 18:04'!
rows: aSequenceableCollection

	rows := aSequenceableCollection.! !

!SokobanField methodsFor: 'derived accessing' stamp: 'rhi 5/13/2007 19:27'!
addRow: aSequenceableCollection

	self rows add: aSequenceableCollection.
	^ aSequenceableCollection! !

!SokobanField methodsFor: 'derived accessing' stamp: 'rhi 7/16/2003 18:06'!
at: aPoint

	^ (self rows at: aPoint y) at: aPoint x! !

!SokobanField methodsFor: 'derived accessing' stamp: 'rhi 7/16/2003 18:07'!
at: aPoint put: aSokobanBlock

	^ (self rows at: aPoint y) at: aPoint x put: aSokobanBlock! !

!SokobanField methodsFor: 'enumeration' stamp: 'rhi 7/17/2003 11:31'!
allBlocksDo: aBlockContext

	self rows do: [:row |
		row do: [:each |
			aBlockContext value: each]].! !

!SokobanField methodsFor: 'initialization' stamp: 'rhi 7/16/2003 21:24'!
initialize

	self rows: OrderedCollection new.! !


!SokobanGoal methodsFor: 'testing' stamp: 'rhi 7/16/2003 19:07'!
isSokobanGoal

	^ true! !


!SokobanGoal class methodsFor: 'images' stamp: 'rhi 10/26/2005 19:12'!
blockImage

	^ SokobanTheme current goalImage! !


!SokobanMorph methodsFor: 'accessing' stamp: 'rhi 7/17/2003 16:48'!
score
	"^ <TextMorph>"

	^ score! !

!SokobanMorph methodsFor: 'accessing' stamp: 'rhi 7/17/2003 16:48'!
score: aTextMorph

	score := aTextMorph.! !

!SokobanMorph methodsFor: 'accessing' stamp: 'rhi 7/17/2003 12:52'!
sworld
	"^ <SokobanWorld>"

	^ sworld! !

!SokobanMorph methodsFor: 'accessing' stamp: 'rhi 7/17/2003 12:52'!
sworld: aSokobanWorld

	sworld := aSokobanWorld.! !

!SokobanMorph methodsFor: 'event handling' stamp: 'rhi 7/17/2003 12:55'!
handlesKeyboard: aMorphicEvent

	^ true! !

!SokobanMorph methodsFor: 'event handling' stamp: 'rhi 7/17/2003 12:55'!
handlesMouseOver: aMorphicEvent

	^ true! !

!SokobanMorph methodsFor: 'event handling' stamp: 'rkrk 5/13/2007 13:04'!
keyStroke: aKeyboardEvent

	| char modifiers |
	char := aKeyboardEvent keyCharacter.
	modifiers := {
		aKeyboardEvent controlKeyPressed.
		aKeyboardEvent shiftPressed. }.

	char = Character arrowLeft ifTrue: [^ self moveLeftModifiers: modifiers].
	char = Character arrowRight ifTrue: [^ self moveRightModifiers: modifiers].
	char = Character arrowUp ifTrue: [^ self moveUpModifiers: modifiers].
	char = Character arrowDown ifTrue: [^ self moveDownModifiers: modifiers].

	char asLowercase = $a ifTrue: [^ self again].
	char asLowercase = $h ifTrue: [^ self help].
	char asLowercase = $n ifTrue: [^ self next].
	char asLowercase = $p ifTrue: [^ self previous].
	char asLowercase = $q ifTrue: [^ self quit].
	char asLowercase = $r ifTrue: [^ self random].
	char asLowercase = $t ifTrue: [^ self theme].

	^ super keyStroke: aKeyboardEvent! !

!SokobanMorph methodsFor: 'event handling' stamp: 'rhi 7/17/2003 12:55'!
mouseEnter: aMorphicEvent

        aMorphicEvent hand newKeyboardFocus: self.! !

!SokobanMorph methodsFor: 'initialization' stamp: 'rkrk 5/13/2007 12:56'!
blockSize

	^ self sworld
		ifNil: [SokobanBlock blockSize]
		ifNotNil: [sworld boxes someElement blockSize]! !

!SokobanMorph methodsFor: 'initialization' stamp: 'rhi 7/17/2003 13:15'!
initialize

	self initializeForIndex: 1.! !

!SokobanMorph methodsFor: 'initialization' stamp: 'rhi 7/17/2003 13:15'!
initializeForIndex: anInteger

	self initializeForWorld: (SokobanWorld fromIndex: anInteger).! !

!SokobanMorph methodsFor: 'initialization' stamp: 'rkrk 5/13/2007 13:02'!
initializeForWorld: aSokobanWorld

	super initialize.
	self
		sworld: aSokobanWorld;
		center: World center;
		clipSubmorphs: true;
		addTitleBoxesAndControls.! !

!SokobanMorph methodsFor: 'initialization' stamp: 'rhi 7/17/2003 13:14'!
initializeRandom

	self initializeForWorld: SokobanWorld random.! !

!SokobanMorph methodsFor: 'mazes menu' stamp: 'rhi 7/30/2003 17:48'!
mazesLoma

	self sworld setMazesNamed: #mazesLoma.
	self start.! !

!SokobanMorph methodsFor: 'mazes menu' stamp: 'rhi 7/30/2003 17:48'!
mazesMasMicroban

	self sworld setMazesNamed: #mazesMasMicroban.
	self start.! !

!SokobanMorph methodsFor: 'mazes menu' stamp: 'rhi 7/30/2003 17:48'!
mazesMasSasquatch

	self sworld setMazesNamed: #mazesMasSasquatch.
	self start.! !

!SokobanMorph methodsFor: 'mazes menu' stamp: 'rhi 7/30/2003 17:48'!
mazesMicroban

	self sworld setMazesNamed: #mazesMicroban.
	self start.! !

!SokobanMorph methodsFor: 'mazes menu' stamp: 'rhi 7/30/2003 17:48'!
mazesSasquatch

	self sworld setMazesNamed: #mazesSasquatch.
	self start.! !

!SokobanMorph methodsFor: 'mazes menu' stamp: 'rhi 7/30/2003 17:48'!
mazesSasquatchIII

	self sworld setMazesNamed: #mazesSasquatchIII.
	self start.! !

!SokobanMorph methodsFor: 'mazes menu' stamp: 'rhi 7/30/2003 17:48'!
mazesSasquatchIV

	self sworld setMazesNamed: #mazesSasquatchIV.
	self start.! !

!SokobanMorph methodsFor: 'mazes menu' stamp: 'rhi 7/30/2003 17:48'!
mazesSasquatchV

	self sworld setMazesNamed: #mazesSasquatchV.
	self start.! !

!SokobanMorph methodsFor: 'mazes menu' stamp: 'rhi 7/30/2003 17:48'!
mazesSasquatchVI

	self sworld setMazesNamed: #mazesSasquatchVI.
	self start.! !

!SokobanMorph methodsFor: 'mazes menu' stamp: 'rhi 12/21/2003 22:40'!
mazesSelectionMenu

	| menu |
	menu := MenuMorph new defaultTarget: self.
	self sworld mazeSetNames "asSortedCollection" do: [:each |
		menu add: each value action: each key].
	menu popUpInWorld.! !

!SokobanMorph methodsFor: 'mazes menu' stamp: 'rhi 7/30/2003 17:49'!
mazesUAlberta

	self sworld setMazesNamed: #mazesUAlberta.
	self start.! !

!SokobanMorph methodsFor: 'mazes menu' stamp: 'rhi 10/25/2005 20:26'!
start

	| position |
	position := self position.
	self
		delete;
		initializeForIndex: 1;
		position: position;
		openInWorld.! !

!SokobanMorph methodsFor: 'navigation' stamp: 'rhi 7/17/2003 12:58'!
again

	| position |
	position := self position.
	self
		delete;
		initializeForIndex: self sworld index;
		position: position;
		openInWorld.! !

!SokobanMorph methodsFor: 'navigation' stamp: 'rhi 10/26/2005 23:51'!
help

	((StringHolder new
		contents: 'The game was apparently invented in the early 1980s by Thinking Rabbit, a computer games company in the town of Takarazuka, Japan. The game design is said to have won first prize in a computer games contest. Because of the simplicity and elegance of the rules, and the intellectually challenging complexity of the composed problems, Sokoban quickly became a popular pastime. The object of Sokoban is to push all stones (or boxes) in a maze, such as the one to the right, to the designated goal areas. The player controls the man and the man can only push stones and only one at a time. The restriction of only being able to push the stones makes this game challenging: One can create unsolvable positions. Players will soon learn that this is the main obstacle in solving problems. Advanced players also try to find shorter and shorter solutions, measured in stone pushes and man moves. (Andreas Junghanns)

Key mappings:
---
Cursor left => move left
Cursor right => move right
Cursor up => move up
Cursor down => move down
Shift w/ cursor key => moves as far as possible without pushing boxes
Control w/ cursor key => moves as far as possible including pushing boxes

a => again (same maze)
h => help
n => next (another maze, next in line)
p => previous (another maze, previous in line)
r => random (another maze, random selection)
t => theme (another theme)

q => quit

Acknowledgments:
--
Andreas Junghanns (http://www.cs.ualberta.ca/~games/Sokoban/)
David W. Skinner (http://users.bentonrea.com/~sasquatch/sokoban/)

Comments or suggestions?
--
Robert Hirschfeld <hirschfeld@acm.org>')
		embeddedInMorphicWindowLabeled: 'About Sokoban')
			setWindowColor: Color veryLightGray;
			openInWorld! !

!SokobanMorph methodsFor: 'navigation' stamp: 'rhi 10/26/2005 01:24'!
moveDown

	self moveDownModifiers: { false. false. }.! !

!SokobanMorph methodsFor: 'navigation' stamp: 'rhi 10/25/2005 18:55'!
moveDownModifiers: anArray

	self splayer moveDownModifiers: anArray.
	self
		updateScore;
		announceIfFinished.! !

!SokobanMorph methodsFor: 'navigation' stamp: 'rhi 10/26/2005 01:24'!
moveLeft

	self moveLeftModifiers: { false. false. }.! !

!SokobanMorph methodsFor: 'navigation' stamp: 'rhi 10/25/2005 18:55'!
moveLeftModifiers: anArray

	self splayer moveLeftModifiers: anArray.
	self
		updateScore;
		announceIfFinished.! !

!SokobanMorph methodsFor: 'navigation' stamp: 'rhi 10/26/2005 01:24'!
moveRight

	self moveRightModifiers: { false. false. }.! !

!SokobanMorph methodsFor: 'navigation' stamp: 'rhi 10/25/2005 18:55'!
moveRightModifiers: anArray

	self splayer moveRightModifiers: anArray.
	self
		updateScore;
		announceIfFinished.! !

!SokobanMorph methodsFor: 'navigation' stamp: 'rhi 10/26/2005 01:25'!
moveUp

	self moveUpModifiers: { false. false. }.! !

!SokobanMorph methodsFor: 'navigation' stamp: 'rhi 10/25/2005 18:55'!
moveUpModifiers: anArray

	self splayer moveUpModifiers: anArray.
	self
		updateScore;
		announceIfFinished.! !

!SokobanMorph methodsFor: 'navigation' stamp: 'rhi 7/17/2003 15:02'!
next

	| position |
	position := self position.
	self
		delete;
		initializeForIndex: ((self sworld index + 1) min: self sworld class mazes size);
		position: position;
		openInWorld.! !

!SokobanMorph methodsFor: 'navigation' stamp: 'rhi 7/17/2003 15:02'!
previous

	| position |
	position := self position.
	self
		delete;
		initializeForIndex: ((self sworld index - 1) max: 1);
		position: position;
		openInWorld.! !

!SokobanMorph methodsFor: 'navigation' stamp: 'rhi 7/17/2003 12:57'!
quit

	self delete.! !

!SokobanMorph methodsFor: 'navigation' stamp: 'rhi 7/17/2003 15:02'!
random

	| position |
	position := self position.
	self
		delete;
		initializeRandom;
		position: position;
		openInWorld.! !

!SokobanMorph methodsFor: 'navigation' stamp: 'rhi 10/26/2005 23:47'!
theme

	SokobanTheme current: SokobanTheme next.
	SokobanBlock allSubInstancesDo: [:each | each image: each blockImage].! !

!SokobanMorph methodsFor: 'private' stamp: 'rkrk 5/13/2007 12:49'!
addBoxes

	| topLeftX topLeftY |
	self flag: #rhi. "Refactor!!"
	topLeftX := self topLeft x.
	topLeftY := self topLeft y.
	self sworld fixed rows do: [:row |
		row do: [:each | each isSokobanBlock
			ifTrue: [self addMorph: (each
				position: ((each location x - 1) * each blockSize x + topLeftX)
					@ ((each location y - 1) * each blockSize y
						+ self class titleHeight + topLeftY))]]].
	self sworld movable rows do: [:row |
		row do: [:each | each isSokobanBlock
			ifTrue: [self addMorph: (each
				position: ((each location x - 1) * each blockSize x + topLeftX)
					@ ((each location y - 1) * each blockSize y
						+ self class titleHeight + topLeftY))]]].
	self announceIfFinished.! !

!SokobanMorph methodsFor: 'private' stamp: 'rhi 5/13/2007 20:51'!
addControls

	self flag: #rhi. "Refactor!!"
	self score: self buildScore.
	self addMorph: (Morph new
		color: Color darkGray;
		borderWidth: 0;
		height: self class controlsHeight;
		width: self width;
		hResizing: #spaceFill;
		vResizing: #rigid;
		listDirection: #leftToRight;
		cellInset: 1;
		changeTableLayout;
		"addMorph: (Morph new
			color: Color black;
			height: self controlsHeight;
			hResizing: #spaceFill;
			vResizing: #rigid);"
		addMorph: self score;
		addMorph: (self
			buildButtonForm: self class rightArrow
			action: #moveRight
			target: self);
		addMorph: (self
			buildButtonForm: self class downArrow
			action: #moveDown
			target: self);
		addMorph: (self
			buildButtonForm: self class upArrow
			action: #moveUp
			target: self);
		addMorph: (self
			buildButtonForm: self class leftArrow
			action: #moveLeft
			target: self);
		addMorph: ((self
			buildButtonLabel: '?'
			action: #help
			target: self
			balloonText: 'Help')
				color: Color lightBlue);
		addMorph: ((self
			buildButtonLabel: 'X'
			action: #quit
			target: self
			balloonText: 'Quit')
				color: Color lightRed);
		position: self topLeft x @ (self bottomLeft y - self class controlsHeight);
		yourself).! !

!SokobanMorph methodsFor: 'private' stamp: 'rhi 5/13/2007 20:51'!
addTitle

	| title |
	(title := Morph new)
		color: Color darkGray;
		borderWidth: 0;
		height: self class titleHeight;
		width: self width;
		hResizing: #spaceFill;
		vResizing: #rigid;
		listDirection: #leftToRight;
		cellInset: 1;
		changeTableLayout;
		addMorph: self buildTitle;
		addMorph: ((self
			buildButtonForm: self class menuForm
			action: #mazesSelectionMenu
			target: self)
				color: Color veryDarkGray).
	self addMorph: (title position: self topLeft x @ self topLeft y).! !

!SokobanMorph methodsFor: 'private' stamp: 'rkrk 5/13/2007 12:55'!
addTitleBoxesAndControls

	self
		addBoxes;
		fitSubMorphs;
		addTitle;
		addControls.! !

!SokobanMorph methodsFor: 'private' stamp: 'rhi 7/17/2003 17:35'!
announceIfFinished

	self color: (self sworld isFinished
		ifTrue: [Color veryVeryLightGray]
		ifFalse: [Color lightGray]).! !

!SokobanMorph methodsFor: 'private' stamp: 'rkrk 5/13/2007 12:59'!
buildButtonForm: aForm action: aSymbol target: anObject

	^ IconicButton new
		labelGraphic: aForm;
		actionSelector: aSymbol;
		target: anObject;
		actWhen: #buttonDown;
		color: Color black;
		borderWidth: 0;
		height: self class controlsHeight;
		layoutInset: 3;
		hResizing: #rigid;
		vResizing: #rigid;
		cornerStyle: #square;
		changeTableLayout;
		yourself! !

!SokobanMorph methodsFor: 'private' stamp: 'rkrk 5/13/2007 13:01'!
buildButtonLabel: aString action: aSymbol target: anObject

	| button |
	(button := SimpleButtonMorph new)
		label: aString asText allBold;
		actionSelector: aSymbol;
		target: anObject;
		actWhen: #buttonDown;
		color: Color black;
		borderWidth: 0;
		height: self class controlsHeight;
		layoutInset: 3;
		hResizing: #rigid;
		vResizing: #rigid;
		cornerStyle: #square;
		changeTableLayout.
	(button findA: StringMorph) color: Color black.
	^ button! !

!SokobanMorph methodsFor: 'private' stamp: 'rhi 7/17/2003 14:52'!
buildButtonLabel: aString action: aSymbol target: anObject balloonText: anotherString

	^ (self buildButtonLabel: aString action: aSymbol target: anObject)
		setBalloonText: anotherString! !

!SokobanMorph methodsFor: 'private' stamp: 'rhi 5/13/2007 18:39'!
buildScore

	^ TextMorph new
		contents: self scoreString;
		color: Color white;
		backgroundColor: Color transparent;
		lock;
		yourself! !

!SokobanMorph methodsFor: 'private' stamp: 'rhi 5/13/2007 18:39'!
buildTitle

	^ TextMorph new
		contents: self titleString;
		color: Color white;
		backgroundColor: Color transparent;
		centered;
		lock;
		yourself! !

!SokobanMorph methodsFor: 'private' stamp: 'rkrk 5/13/2007 13:01'!
fitSubMorphs

	| extentX extentY |
	extentX := self blockSize x * self sworld range x.
	extentY := self blockSize y * self sworld range y
		+ self class controlsHeight + self class titleHeight.
	self extent: extentX @ extentY.! !

!SokobanMorph methodsFor: 'private' stamp: 'rhi 10/25/2005 22:16'!
scoreString

	self flag: #rhi. "File-out seems to be broken. Use #annotationSeparator for now..."
	^ ' ', self sworld moves printString, ' Move',
		(self sworld moves = 1 ifTrue: [''] ifFalse: ['s']),
		CodeHolder basicNew annotationSeparator, self sworld pushes printString, ' Push',
		(self sworld pushes = 1 ifTrue: [''] ifFalse: ['es'])! !

!SokobanMorph methodsFor: 'private' stamp: 'rhi 7/17/2003 15:34'!
splayer

	^ self sworld player! !

!SokobanMorph methodsFor: 'private' stamp: 'rhi 10/26/2005 10:14'!
titleString

	^ ' Maze #', self sworld index printString, ' (', self sworld mazeSetName, ')'! !

!SokobanMorph methodsFor: 'private' stamp: 'rhi 7/17/2003 16:58'!
updateScore

	self score contents: self scoreString.! !


!SokobanMorph class methodsFor: 'constants' stamp: 'rkrk 3/26/2007 19:51'!
blockSize

	^ SokobanBlock blockSize! !

!SokobanMorph class methodsFor: 'constants' stamp: 'rkrk 3/26/2007 19:51'!
controlsHeight

	^ self titleHeight! !

!SokobanMorph class methodsFor: 'constants' stamp: 'rkrk 3/26/2007 19:51'!
cross

	^ Form
		extent: 9@9
		depth: 16
		fromArray: #( 65537 0 0 1 65536 65537 65536 0 65537 65536 1 65537 1 65537 0 0 65537 65537 65536 0 0 1 65537 0 0 0 65537 65537 65536 0 1 65537 1 65537 0 65537 65536 0 65537 65536 65537 0 0 1 65536)
		offset: 0@0! !

!SokobanMorph class methodsFor: 'constants' stamp: 'rkrk 3/26/2007 19:51'!
downArrow

	^ Form
		extent: 9@9
		depth: 16
		fromArray: #( 14253 862794605 862794605 862729101 934150144 14221 724182793 654911241 654913323 931987456 0 793519881 722086698 652880586 862781440 0 931998474 654977834 648621835 0 0 12107 654911209 717895565 0 0 13164 654976681 789250048 0 0 14254 722085546 929890304 0 0 0 860630796 934150144 0 0 0 934098861 0 0)
		offset: 0@0! !

!SokobanMorph class methodsFor: 'constants' stamp: 'rkrk 3/26/2007 19:51'!
leftArrow

	^ Form
		extent: 9@11
		depth: 16
		fromArray: #( 0 0 0 0 934084608 0 0 0 934162252 864813056 0 0 14221 724249354 862715904 0 0 793520938 722021130 864813056 0 864824106 654977802 722086666 864813056 13164 722085641 722086666 722086666 864878592 12043 646523626 722086698 722086666 864878592 14254 858532522 648685290 722086666 864878592 0 14221 789260970 650717962 864878592 0 0 13132 717892331 934084608 0 0 0 932000621 0)
		offset: 8@0! !

!SokobanMorph class methodsFor: 'constants' stamp: 'rkrk 3/26/2007 19:52'!
menuForm

	^ (ColorForm
		extent: 11@10
		depth: 1
		fromArray: #( 4292870144 2149580800 2787115008 2149580800 3546284032 4292870144 2149580800 2996830208 2149580800 4292870144)
		offset: 0@0)
			colors: {Color transparent . Color white}! !

!SokobanMorph class methodsFor: 'constants' stamp: 'rkrk 3/26/2007 19:52'!
rightArrow

	^ Form
		extent: 9@11
		depth: 16
		fromArray: #( 934084608 0 0 0 0 864825164 934150144 0 0 0 862726922 724252557 0 0 0 864824074 722021162 793509888 0 0 864824074 722086666 654977834 864813056 0 864889610 722086666 722085641 722088812 0 864889610 722086698 722086634 646524683 0 864889610 722085610 648686250 858535854 0 864889610 650717866 789264269 0 0 934095595 717894476 0 0 0 13165 931987456 0 0 0)
		offset: 0@0! !

!SokobanMorph class methodsFor: 'constants' stamp: 'rkrk 3/26/2007 19:52'!
titleHeight

	^ 20! !

!SokobanMorph class methodsFor: 'constants' stamp: 'rkrk 3/26/2007 19:52'!
upArrow

	^ Form
		extent: 9@8
		depth: 16
		fromArray: #( 0 0 932001709 0 0 0 14254 793457484 0 0 0 13197 654912266 931987456 0 0 12107 654912266 862715904 0 0 931998474 722020105 724252557 0 0 793455401 724183850 724187021 0 14221 724182761 652879594 652816171 931987456 0 791422634 717892298 648686282 862781440)
		offset: 0@0! !

!SokobanMorph class methodsFor: 'instance creation' stamp: 'rhi 10/25/2005 19:30'!
forIndex: anInteger
	"doIt: [(self forIndex: 1) openInWorld]"

	^ self new initializeForIndex: anInteger! !

!SokobanMorph class methodsFor: 'instance creation' stamp: 'rhi 10/25/2005 19:30'!
forWorld: aSokobanWorld
	"doIt: [(self forWorld: (SokobanWorld fromFile: '.\Screens\screen.1')) openInWorld]"
	"doIt: [(self forWorld: (SokobanWorld fromIndex: 1)) openInWorld]"

	^ self new initializeForWorld: aSokobanWorld! !

!SokobanMorph class methodsFor: 'instance creation' stamp: 'rhi 10/25/2005 19:31'!
random
	"doIt: [self random openInWorld]"

	^ self new initializeRandom! !

!SokobanMorph class methodsFor: 'parts bin' stamp: 'rhi 10/25/2005 19:31'!
descriptionForPartsBin

	^ self
		partName: 'Sokoban'
		categories: #('Games')
		documentation: 'A logic puzzle, created by Hiroyuki Imabayashi in 1982.'! !


!SokobanPlayer methodsFor: 'navigation' stamp: 'rkrk 5/13/2007 13:05'!
moveDownModifiers: anArray

	self flag: #rhi. "Direction not intuitive!! See moveUp..."
	self
		moveBy: 0 @ 1 modifiers: anArray;
		image: self class blockImage.! !

!SokobanPlayer methodsFor: 'navigation' stamp: 'rkrk 5/13/2007 13:06'!
moveLeftModifiers: anArray

	self
		moveBy: -1 @ 0 modifiers: anArray;
		image: self class blockImageLeft.! !

!SokobanPlayer methodsFor: 'navigation' stamp: 'rkrk 5/13/2007 13:06'!
moveRightModifiers: anArray

	self
		moveBy: 1 @ 0 modifiers: anArray;
		image: self class blockImageRight.! !

!SokobanPlayer methodsFor: 'navigation' stamp: 'rkrk 5/13/2007 13:07'!
moveUpModifiers: anArray

	self flag: #rhi. "Direction not intuitive!! See moveDown..."
	self
		moveBy: 0 @ -1 modifiers: anArray;
		image: self class blockImage.! !

!SokobanPlayer methodsFor: 'testing' stamp: 'rhi 7/16/2003 19:06'!
isSokobanPlayer

	^ true! !

!SokobanPlayer methodsFor: 'private' stamp: 'rhi 7/17/2003 13:38'!
canMoveBy: aPoint

	| target |
	target := self location + aPoint.
	^ ((self sworld fixedAt: target) isSokobanBlock not
		or: [(self sworld fixedAt: target) isSokobanGoal])
			and: [(self sworld movableAt: target) isSokobanBlock not
				or: [(self sworld movableAt: target) canMoveBy: aPoint]]! !

!SokobanPlayer methodsFor: 'private' stamp: 'rhi 10/25/2005 18:44'!
canMoveWithoutPushingBy: aPoint

	| target |
	target := self location + aPoint.
	^ ((self sworld fixedAt: target) isSokobanBlock not
		or: [(self sworld fixedAt: target) isSokobanGoal])
			and: [(self sworld movableAt: target) isSokobanBlock not]! !

!SokobanPlayer methodsFor: 'private' stamp: 'rhi 10/25/2005 18:04'!
moveBy: aPoint

	(self canMoveBy: aPoint) ifTrue: [self moveSimplyBy: aPoint].! !

!SokobanPlayer methodsFor: 'private' stamp: 'rhi 10/25/2005 18:05'!
moveBy: aPoint modifiers: anArray

	anArray first ifTrue: [^ self moveFullBy: aPoint].
	anArray second ifTrue: [^ self moveFullWithoutPushingBy: aPoint].
	self moveBy: aPoint.! !

!SokobanPlayer methodsFor: 'private' stamp: 'rhi 10/25/2005 18:46'!
moveFullBy: aPoint

	[self canMoveBy: aPoint] whileTrue: [self moveSimplyBy: aPoint].! !

!SokobanPlayer methodsFor: 'private' stamp: 'rhi 10/25/2005 18:46'!
moveFullWithoutPushingBy: aPoint

	[self canMoveWithoutPushingBy: aPoint] whileTrue: [self moveSimplyBy: aPoint].! !

!SokobanPlayer methodsFor: 'private' stamp: 'rkrk 5/13/2007 13:07'!
moveSimplyBy: aPoint

	| current new |
	self sworld isFinished ifFalse: [
		current := self location.
		new := current + aPoint.
		(self sworld movableAt: new) isSokobanBlock
			ifTrue: [
				(self sworld movableAt: new) moveBy: aPoint.
				self sworld incrementPushes].
		self sworld
			movableAt: current put: nil;
			movableAt: new put: self;
			incrementMoves.
		self
			location: new;
			position: self position + (self blockSize * aPoint)].! !


!SokobanPlayer class methodsFor: 'images' stamp: 'rhi 10/26/2005 19:13'!
blockImage

	^ SokobanTheme current playerImage! !

!SokobanPlayer class methodsFor: 'images' stamp: 'rkrk 5/13/2007 13:07'!
blockImageLeft

	^ SokobanTheme current playerImageLeft! !

!SokobanPlayer class methodsFor: 'images' stamp: 'rkrk 5/13/2007 13:08'!
blockImageRight

	^ SokobanTheme current playerImageRight! !


!SokobanTheme methodsFor: 'accessing' stamp: 'rhi 10/26/2005 17:51'!
images
	"^ <IdentityDictionary key: Symbol value: Form>"

	^ images! !

!SokobanTheme methodsFor: 'accessing' stamp: 'rhi 10/26/2005 17:50'!
images: anIdentityDictionary

	images := anIdentityDictionary.! !

!SokobanTheme methodsFor: 'accessing' stamp: 'rhi 10/26/2005 17:53'!
name
	"^ <String>"

	^ name! !

!SokobanTheme methodsFor: 'accessing' stamp: 'rhi 10/26/2005 17:53'!
name: aString

	name := aString.! !

!SokobanTheme methodsFor: 'comparing' stamp: 'rhi 10/26/2005 18:25'!
hash

	^ self name hash! !

!SokobanTheme methodsFor: 'comparing' stamp: 'rhi 10/26/2005 18:22'!
= anObject

	self == anObject ifTrue: [^ true].
	anObject isSokobanTheme ifFalse: [^ false].
	^ self name = anObject name! !

!SokobanTheme methodsFor: 'derived accessing' stamp: 'rhi 5/13/2007 19:27'!
addImage: anAssociation

	self images add: anAssociation.
	^ anAssociation! !

!SokobanTheme methodsFor: 'derived accessing' stamp: 'rhi 10/26/2005 19:02'!
boxImage

	^ self imageAt: #box! !

!SokobanTheme methodsFor: 'derived accessing' stamp: 'rhi 10/26/2005 19:02'!
goalImage

	^ self imageAt: #goal! !

!SokobanTheme methodsFor: 'derived accessing' stamp: 'rhi 10/26/2005 18:08'!
imageAt: aSymbol

	^ self images at: aSymbol! !

!SokobanTheme methodsFor: 'derived accessing' stamp: 'rhi 10/26/2005 19:01'!
playerImage

	^ self imageAt: #player! !

!SokobanTheme methodsFor: 'derived accessing' stamp: 'rkrk 5/13/2007 13:08'!
playerImageLeft

	^ self images at: #playerLeft ifAbsent: [self playerImage]! !

!SokobanTheme methodsFor: 'derived accessing' stamp: 'rkrk 5/13/2007 13:08'!
playerImageRight

	^ self images at: #playerRight ifAbsent: [self playerImage]! !

!SokobanTheme methodsFor: 'derived accessing' stamp: 'rhi 10/26/2005 19:02'!
wallImage

	^ self imageAt: #wall! !

!SokobanTheme methodsFor: 'initialization' stamp: 'rhi 10/26/2005 18:29'!
initialize

	self images: IdentityDictionary new.! !

!SokobanTheme methodsFor: 'testing' stamp: 'rhi 10/26/2005 18:21'!
isSokobanTheme

	^ true! !


!SokobanTheme class methodsFor: 'accessing' stamp: 'rhi 10/26/2005 19:04'!
current
	"^ <SokobanTheme>"

	^ Current! !

!SokobanTheme class methodsFor: 'accessing' stamp: 'rhi 10/26/2005 17:57'!
current: aSokobanTheme

	Current := aSokobanTheme.! !

!SokobanTheme class methodsFor: 'accessing' stamp: 'rhi 10/26/2005 23:44'!
themes
	"^ <SequenceableCollection of: SokobanTheme>"

	^ Themes! !

!SokobanTheme class methodsFor: 'accessing' stamp: 'rhi 10/26/2005 23:44'!
themes: aSequenceableCollection

	Themes := aSequenceableCollection.! !

!SokobanTheme class methodsFor: 'class initialization' stamp: 'rhi 10/28/2005 10:23'!
initialize
	"doIt: [self initialize]"

	super initialize.
	self initThemes.! !

!SokobanTheme class methodsFor: 'class initialization' stamp: 'rhi 5/13/2007 19:15'!
initThemes

	self
		themes: (self themeSelectors collect: [:each | self perform: each]);
		current: (self themesAt: 'Mouse').! !

!SokobanTheme class methodsFor: 'class initialization' stamp: 'rhi 10/28/2005 11:18'!
themeSelectors

	self flag: #rgi. "Why does '#*Theme' work, but '**Theme' doesn't? <Seufz>"
	^ (self class selectors select: [:each | ('#*Theme' match: each) and: [each numArgs = 0]])
		asSortedCollection! !

!SokobanTheme class methodsFor: 'derived accessing' stamp: 'rkrk 5/13/2007 13:12'!
next

	^ self themes after: self current ifAbsent: [self themes first]! !

!SokobanTheme class methodsFor: 'derived accessing' stamp: 'rhi 10/26/2005 18:40'!
themesAt: aString

	^ self themes detect: [:each | each name = aString]! !

!SokobanTheme class methodsFor: 'images' stamp: 'rhi 10/26/2005 17:36'!
formBoxEllipse

	^ (ColorForm
	extent: 32@32
	depth: 8
	fromArray: #( 0 0 0 16843009 16843009 0 0 0 0 0 65793 33686018 33686018 16843008 0 0 0 1 16908802 33686018 33686018 33686017 16777216 0 0 258 33686018 33686018 33686018 33686018 33619968 0 0 16843266 33686018 33686018 33686018 33686018 33685761 0 0 16908802 33686018 33686018 33686018 33686018 33686017 0 1 33686018 33686018 33686018 33686018 33686018 33686018 16777216 258 33686018 33686018 33686018 33686018 33686018 33686018 33619968 258 33686018 33686018 33686018 33686018 33686018 33686018 33619968 66050 33686018 33686018 33686018 33686018 33686018 33686018 33685760 66050 33686018 33686018 33686018 33686018 33686018 33686018 33685760 66050 33686018 33686018 33686018 33686018 33686018 33686018 33685760 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 66050 33686018 33686018 33686018 33686018 33686018 33686018 33685760 66050 33686018 33686018 33686018 33686018 33686018 33686018 33685760 66050 33686018 33686018 33686018 33686018 33686018 33686018 33685760 258 33686018 33686018 33686018 33686018 33686018 33686018 33619968 258 33686018 33686018 33686018 33686018 33686018 33686018 33619968 1 33686018 33686018 33686018 33686018 33686018 33686018 16777216 0 16908802 33686018 33686018 33686018 33686018 33686017 0 0 16843266 33686018 33686018 33686018 33686018 33685761 0 0 258 33686018 33686018 33686018 33686018 33619968 0 0 1 16908802 33686018 33686018 33686017 16777216 0 0 0 65793 33686018 33686018 16843008 0 0 0 0 0 16843009 16843009 0 0 0)
	offset: 0@0)
	colorsFromArray: #(#( ) #(0.388 0.388 0.388) #(0.87 1.0 1.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0)  )! !

!SokobanTheme class methodsFor: 'images' stamp: 'rkrk 5/13/2007 13:09'!
formBricks

	^ Form
	extent: 32@32
	depth: 32
	fromArray: #( 4287914603 4287781475 4288106843 4287781475 4287388513 4287325285 4287519073 4287388251 4286872197 4286806904 4288430937 4287910747 4287322969 4287519071 4286866017 4287388259 4287386457 4287451481 4287516763 4287386460 4287388000 4287454052 4287320665 4287847268 4286350227 4287388010 4289088087 4287912537 4286667610 4287060324 4287388251 4287259745 4290058545 4289529894 4289462310 4289988905 4289005857 4289005344 4289464352 4289527842 4288369754 4288301400 4289595186 4289791787 4289005857 4289071135 4289071135 4289464352 4289005354 4288875039 4289006122 4288940064 4289071145 4288808743 4288481569 4289466408 4287918970 4287769153 4288874520 4289005593 4288549154 4288415786 4289070624 4290058545 4289079601 4288419624 4289138721 4288942369 4288354593 4288483361 4288876576 4289005593 4286276441 4286798675 4288419624 4288221216 4288549154 4288221216 4288549153 4289072675 4288616489 4288354344 4288419624 4287830563 4287895838 4287895584 4287959327 4288421928 4286219387 4286198074 4287957008 4288876568 4289206056 4288876840 4288941858 4289536049 4288553265 4287961128 4288483361 4288613931 4288548896 4288352545 4289138723 4288874787 4286995035 4286927700 4288352554 4288483614 4288548896 4288483363 4288352544 4288354346 4288354344 4288420139 4288616487 4288417835 4288548906 4287959083 4287762209 4288354609 4286217337 4286921027 4288352291 4289072926 4288419626 4288419888 4288354597 4288423985 4288487474 4288420139 4288942118 4288942633 4288876325 4289204265 4289597481 4289464352 4287390820 4287322460 4289007413 4289073195 4288286752 4288483363 4288417567 4289075497 4289073193 4289007915 4288942120 4288483113 4288417834 4288352041 4288418088 4288944178 4286940801 4287313994 4289007905 4289531937 4288944681 4288747825 4288419888 4289079347 4289077807 4288942120 4289072930 4288941607 4289073698 4288287009 4288876830 4289661217 4286866008 4286929492 4288287272 4288286752 4288483360 4288483361 4289072930 4289400862 4288417835 4288417567 4288483360 4288352545 4288482848 4288352544 4288090143 4289011763 4286872446 4286921027 4288349975 4289007386 4288944163 4288942122 4289269545 4290060591 4288944178 4288417834 4289136686 4289073193 4288352041 4288417834 4289204265 4289005090 4287517274 4287383898 4289138739 4288876840 4288286761 4288417835 4288418088 4288874536 4288548904 4288285481 4288417835 4288546600 4288352554 4288352552 4287826218 4288485427 4286999418 4287377730 4288352291 4288548641 4287893544 4287959337 4288286502 4289471023 4286937980 4286213227 4286802791 4286935668 4286215538 4286217077 4286282611 4286739563 4285170819 4286217077 4285827969 4285827971 4286282611 4286413427 4286217075 4286935923 4286804852 4286934130 4286868337 4286868586 4286935923 4286935923 4286213227 4287001201 4284124307 4286345851 4288506984 4287394668 4286280560 4286149491 4287001204 4286872436 4288891739 4285889139 4286215017 4287840843 4287843150 4286794321 4287449683 4286927423 4286794320 4287449683 4287253842 4287449683 4287449683 4287253331 4287449683 4287384401 4287316563 4285694833 4287580500 4287449681 4287316553 4286923339 4287517268 4287384139 4287382348 4287381580 4288039508 4287447625 4287384393 4287384139 4287449418 4287976025 4289014083 4286801002 4287975782 4288942382 4288548904 4288418098 4289529906 4289071137 4289597481 4289532201 4289597481 4289532199 4289662759 4289597479 4289532201 4289597481 4288940080 4287851371 4288946497 4288415786 4288417834 4287828520 4288417834 4288483111 4289073193 4288483881 4289007402 4288352554 4288417834 4288287272 4288352554 4289470522 4287834421 4286409066 4287325027 4288418348 4288548896 4288288818 4288485671 4288419626 4289072928 4289007651 4288941858 4288941858 4289204001 4288876576 4289007651 4289009192 4289136427 4286938221 4288424248 4288546851 4289009705 4287961128 4288813095 4289007915 4288483361 4288548641 4289007402 4288352291 4288483363 4288483361 4288417568 4288881458 4288426299 4286868324 4287454044 4287762207 4287960867 4288091688 4288485419 4288354334 4288942122 4289007913 4289007400 4288352552 4288352554 4288417834 4289007402 4289074987 4289005344 4285826403 4287902257 4288809503 4288419878 4287567397 4289009697 4288941858 4288286752 4288352291 4288420137 4288548896 4288286751 4288419875 4288221216 4288880688 4289081155 4286802793 4287322460 4288483627 4288223274 4287699504 4288417835 4288354082 4289007913 4288942120 4289007402 4288352554 4288352041 4288548906 4289007402 4288876838 4289532201 4286219361 4287967545 4289070883 4288616489 4287829793 4289007905 4289007905 4288548651 4288352041 4288878889 4288417568 4288483103 4288352545 4288417568 4289077808 4288358720 4286868077 4287781729 4288548904 4288548651 4288418096 4289466673 4289138472 4288483360 4288286752 4288745250 4288417568 4288417568 4288352544 4288483360 4288483360 4289005607 4286870628 4288555064 4289005855 4288942122 4288485417 4288876317 4288876578 4288548651 4288352554 4288548904 4288221995 4288286759 4288418094 4288352295 4289077304 4288885064 4286866284 4287388259 4289077304 4288487474 4288028987 4288419385 4287963434 4288356404 4288422195 4288945970 4288553265 4288356915 4288422195 4288356913 4289011761 4289142849 4286212964 4288491340 4287895612 4288487991 4287701303 4288158258 4287829807 4287963448 4288028987 4288028730 4287963195 4288028988 4287766583 4287832378 4288492102 4289096306 4285238405 4285828474 4287914857 4287984749 4286151282 4286805365 4286940264 4286872689 4286871925 4286872698 4286806905 4286937716 4286872176 4286872434 4286872438 4287392628 4284126331 4286870898 4287394417 4287261545 4287394679 4287394419 4287853428 4287525235 4287198321 4287394932 4287001455 4286935668 4286935923 4286935921 4287988861 4289540409 4289143084 4289077554 4289405233 4289667122 4289339950 4288878886 4289205801 4286872687 4288428100 4289534249 4288356905 4288489780 4288946479 4288419624 4288422179 4289012015 4289077554 4289142830 4289012272 4288946481 4288487721 4289011761 4289079599 4286937726 4287851369 4288489528 4288878896 4289601844 4289602095 4288553265 4289931586 4289601841 4288483109 4288876586 4289007400 4288942120 4289073195 4289204003 4288940064 4286217078 4287967298 4288942112 4288550432 4288291374 4288944178 4288550442 4288354342 4288289067 4288548651 4288418088 4288354344 4288354346 4287827499 4287764776 4288485419 4286212964 4287453785 4287764778 4288481571 4288417567 4288352545 4287830058 4289733178 4289405242 4289007921 4289007410 4289007661 4288876588 4289597489 4288942120 4288940329 4286806905 4287899971 4289070634 4289075250 4289138737 4289531696 4288941868 4288417835 4288420137 4288354346 4288548399 4288288816 4288483378 4288418096 4288418096 4288485170 4286213219 4287847258 4288485170 4289007911 4289072928 4289138468 4287830058 4289407030 4289143097 4288483113 4288548904 4288418088 4288287274 4288942118 4288417834 4288352041 4286413946 4287244596 4288942372 4288944165 4288352041 4288942631 4289073193 4288288800 4288352295 4288286759 4288485419 4288352295 4288417834 4288614186 4288483113 4288419885 4285885028 4287453785 4288026672 4289007400 4289204512 4288286751 4287764770 4289077556 4289470772 4288288802 4288485154 4288483614 4288548643 4288943912 4289138723 4289138721 4286282611 4287310385 4289072928 4289075236 4288354346 4289075238 4289075240 4289143074 4288354346 4288420129 4288092191 4288354092 4288550943 4287895584 4288420129 4288354346 4286215017 4286927449 4287240491 4288483361 4288221216 4288485419 4287961128 4289011761 4290058543 4289005857 4289138721 4289531939 4289399073 4289663022 4289595424 4289464353 4287394421 4288490041 4289005593 4287762709 4287893280 4288942122 4288942110 4289073179 4289204001 4289072930 4289138721 4289138721 4289007652 4288286498 4289007905 4289073447 4287392628 4288041048 4288485429 4288942122 4288418088 4288352041 4288550696 4289534257 4288491841 4287373629 4287244854 4287897653 4287898423 4287899704 4287832378 4288029241 4286215545 4287969355 4288487474 4287441201 4286851127 4287965507 4287897904 4287899951 4288356666 4288422459 4288488250 4288421944 4288487991 4287963184 4288421944 4288421946 4286341993 4287451748 4287899971 4287899971 4287441203 4287440944 4287506745 4288360512 4286937978 4286147434 4286346100 4286345843 4286280307 4286870128 4286933870 4286147434 4284190094 4286868083 4288504939 4286804584 4286280812 4286800491 4286866284 4287261291 4286346354 4286280561 4286280309 4286411636 4286280309 4285690731 4286346100 4286282611 4284581243 4285758333 4287455851 4287916903 4286868324 4286803046 4286280297 4287853428 4285830030 4287322733 4286868327 4285754466 4286935659 4285952874 4286278510 4286213225 4286212714 4286800994 4286278507 4286212964 4287917156 4287915104 4286083949 4284058755 4286802795 4286868588 4286933868 4286868075 4286933866 4286802793 4286802793 4286868586 4287390316 4286931561 4286213228 4287327338 4286802793 4287392628 4287322985 4285303943 4288369495 4289529906 4289007410 4288483111 4289138990 4288354342 4288876586 4289072946 4288942120 4289007921 4288418098 4287958834 4288352552 4288548391 4288035148 4286278258 4288352554 4288286761 4288352041 4288417834 4288352041 4288417834 4288352041 4288417834 4288874536 4288416038 4287893543 4288286761 4287959337 4288548906 4289529904 4287910745 4287914583 4289073193 4288483361 4288354597 4288876576 4287961120 4289138721 4289074985 4289073195 4289531696 4288876589 4288550961 4288352545 4288483360 4287379787 4286345843 4289072928 4289138721 4289007905 4288942371 4288877091 4289074985 4289074985 4289009705 4289466408 4289730347 4288550947 4289138721 4288352544 4288286752 4289726507 4289026395 4287914844 4288415784 4288942120 4288878889 4289663272 4288941607 4289401129 4289007911 4288354346 4288417834 4288418348 4288288551 4288876830 4289204001 4287838531 4286805362 4289007400 4289007402 4289007402 4289007402 4289007400 4289073193 4288942120 4288942120 4288941868 4289007913 4287959075 4288417568 4288420139 4288417834 4288809002 4288371034 4287849305 4288548651 4288352554 4289074985 4289597479 4288420388 4289009707 4289009705 4287961120 4288418088 4287895602 4288092455 4288287009 4288417567 4288035139 4286806905 4289009705 4289009705 4289009707 4288483879 4288352295 4288417834 4288352554 4288286762 4288419624 4288419624 4287764770 4288550945 4288354342 4288419628 4288415784 4288043097 4287915098 4288352545 4288420129 4287895584 4288614169 4287829783 4288483614 4288354336 4288352545 4288876586 4288352305 4287895337 4287959075 4287893791 4287447373 4286348412 4288550945 4288485152 4288550945 4288419359 4288550945 4288485152 4288485152 4288550945 4288616235 4289009705 4288485922 4289533217 4288420129 4288352545 4289136417 4287978330 4288367187 4290052137 4289464352 4289070624 4289530148 4288483360 4289070622 4289464363 4289070626 4289464362 4288415784 4287957032 4288350494 4289071137 4288559435 4287326833 4289005857 4289005857 4289005857 4288940064 4289005857 4289005857 4289071137 4289005344 4288350242 4289136676 4288349981 4289464355 4289005855 4289464105 4289660714 4287777619 4286350203 4288432988 4287844952 4287191899 4287781218 4287390308 4287320664 4287254872 4287385931 4287976027 4287844952 4287322971 4289024085 4288959571 4287849311 4285826180 4287977827 4287977827 4287847011 4287912804 4287847009 4287847011 4287847011 4287912804 4288371561 4287975523 4287909979 4289024612 4288500313 4288369505 4288432483 4285629818)
	offset: 0@0! !

!SokobanTheme class methodsFor: 'images' stamp: 'rhi 10/26/2005 17:36'!
formGoalBordered

	^ (ColorForm
	extent: 32@32
	depth: 8
	fromArray: #( 16843009 16843009 16843009 16843009 16843009 16843009 16843009 16843009 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16908802 33686018 33686018 33686018 33686018 33686018 33686018 33686017 16843009 16843009 16843009 16843009 16843009 16843009 16843009 16843009)
	offset: 0@0)
	colorsFromArray: #(#(0.0 0.0 0.0) #(0.936 0.936 0.807) #(1.0 1.0 0.87) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0)  )! !

!SokobanTheme class methodsFor: 'images' stamp: 'rhi 10/26/2005 17:36'!
formPlayerStar

	^ (ColorForm
	extent: 32@32
	depth: 8
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 257 0 0 0 0 0 0 0 66049 0 0 0 16777216 0 0 0 16908801 0 0 0 65792 0 0 1 33685760 0 0 0 66049 16777216 0 1 33685760 0 0 0 258 33620224 0 258 33685760 0 0 0 258 33686017 16777216 66050 33685760 0 0 0 1 33686018 33620224 16908802 33685760 0 0 0 1 33686018 33686017 33686018 33685760 0 0 0 0 16908802 33686018 33686018 33619968 0 0 0 0 16908802 33686018 33686018 33619968 0 0 0 0 66050 33686018 33686018 33620224 0 0 0 0 66050 33686018 33686018 33686017 16777216 0 0 0 258 33686018 33686018 33686018 33620224 0 0 0 66050 33686018 33686018 33686018 33686017 16777216 0 0 16908802 33686018 33686018 33686018 33686018 33620224 0 1 33686018 33686018 33686018 33686018 33686018 33620225 0 65794 33686018 33686018 33686018 33686017 16843009 16777216 0 16908802 33686018 33686018 33686018 16843008 0 0 1 33686018 33685761 16843266 33686018 16777216 0 0 258 16843009 16842752 66050 33686018 16777216 0 0 65793 0 0 258 33686017 0 0 0 0 0 0 258 33686017 0 0 0 0 0 0 1 33686017 0 0 0 0 0 0 1 33686017 0 0 0 0 0 0 0 16908801 0 0 0 0 0 0 0 16908801 0 0 0 0 0 0 0 65792 0 0 0 0 0 0 0 65792 0 0 0 0 0 0 0 256 0 0 0)
	offset: 0@0)
	colorsFromArray: #(#( ) #(0.388 0.388 0.388) #(1.0 0.611 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0)  )! !

!SokobanTheme class methodsFor: 'images' stamp: 'rhi 10/26/2005 17:36'!
formWallBordered

	^ (ColorForm
	extent: 32@32
	depth: 8
	fromArray: #( 50529027 50529027 50529027 50529027 50529027 50529027 50529027 50529027 50463234 33686018 33686018 33686018 33686018 33686018 33686018 33686017 50463234 33686018 33686018 33686018 33686018 33686018 33686018 33686017 50463234 33686018 33686018 33686018 33686018 33686018 33686018 33686017 50463234 33686018 33686018 33686018 33686018 33686018 33686018 33686017 50463234 33686018 33686018 33686018 33686018 33686018 33686018 33686017 50463234 33686018 33686018 33686018 33686018 33686018 33686018 33686017 50463234 33686018 33686018 33686018 33686018 33686018 33686018 33686017 50463234 33686018 33686018 33686018 33686018 33686018 33686018 33686017 50463234 33686018 33686018 33686018 33686018 33686018 33686018 33686017 50463234 33686018 33686018 33686018 33686018 33686018 33686018 33686017 50463234 33686018 33686018 33686018 33686018 33686018 33686018 33686017 50463234 33686018 33686018 33686018 33686018 33686018 33686018 33686017 50463234 33686018 33686018 33686018 33686018 33686018 33686018 33686017 50463234 33686018 33686018 33686018 33686018 33686018 33686018 33686017 50463234 33686018 33686018 33686018 33686018 33686018 33686018 33686017 50463234 33686018 33686018 33686018 33686018 33686018 33686018 33686017 50463234 33686018 33686018 33686018 33686018 33686018 33686018 33686017 50463234 33686018 33686018 33686018 33686018 33686018 33686018 33686017 50463234 33686018 33686018 33686018 33686018 33686018 33686018 33686017 50463234 33686018 33686018 33686018 33686018 33686018 33686018 33686017 50463234 33686018 33686018 33686018 33686018 33686018 33686018 33686017 50463234 33686018 33686018 33686018 33686018 33686018 33686018 33686017 50463234 33686018 33686018 33686018 33686018 33686018 33686018 33686017 50463234 33686018 33686018 33686018 33686018 33686018 33686018 33686017 50463234 33686018 33686018 33686018 33686018 33686018 33686018 33686017 50463234 33686018 33686018 33686018 33686018 33686018 33686018 33686017 50463234 33686018 33686018 33686018 33686018 33686018 33686018 33686017 50463234 33686018 33686018 33686018 33686018 33686018 33686018 33686017 50463234 33686018 33686018 33686018 33686018 33686018 33686018 33686017 50463234 33686018 33686018 33686018 33686018 33686018 33686018 33686017 50397441 16843009 16843009 16843009 16843009 16843009 16843009 16843009)
	offset: 0@0)
	colorsFromArray: #(#(0.0 0.0 0.0) #(0.741 0.87 0.71) #(0.87 1.0 0.839) #(0.936 1.0 0.905) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0) #(0.0 0.0 0.0)  )! !

!SokobanTheme class methodsFor: 'themes' stamp: 'rkrk 5/13/2007 13:09'!
formCheese

	^ Form
	extent: 32@32
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 4292776984 4292776976 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292776976 4292776976 4292776976 4292776976 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292252688 4292776976 4292774912 4292776968 4293368848 4293368856 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292776984 4292776976 4293366784 4293366800 4293368848 4293368840 4293368848 4293368856 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292776976 4292776976 4293366792 4293368848 4293368848 4293371152 4293368848 4293368840 4293368848 4293368848 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292776976 4292776976 4293371152 4293895440 4293895440 4293371152 4293371152 4293895440 4293895440 4293895432 4293371136 4293895424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4293375331 4292776960 4293371152 4293895440 4293371152 4293895440 4293895440 4293897488 4293897488 4293899536 4293897488 4293895432 4293895432 4293895424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292774920 4292774920 4293368848 4293895440 4293895440 4293895440 4293895440 4293897488 4293897488 4293897488 4293895440 4293895440 4293895440 4293371152 4293895432 4293371152 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292774920 4293366784 4293371152 4293371144 4293895440 4293895440 4293897488 4293897488 4293895440 4293895440 4293895440 4293895440 4293897488 4293897488 4293897488 4293895432 4293371144 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292774912 4292774920 4293895432 4293895440 4293895440 4293895440 4293895440 4293897488 4293897488 4293897488 4293897488 4293897488 4293897488 4293897488 4293897488 4293895440 4293895440 4293895424 4293895432 4293368840 4293895432 0 0 0 0 0 0 0 0 0 0 0 4293908042 4294434370 4294434370 4294430274 4294425905 4294423832 4293897480 4293897488 4293895440 4293897496 4294421784 4293897488 4293897488 4293897488 4293897488 4293897488 4293895440 4293895440 4293895432 4293895424 4293371136 4293895440 0 0 0 0 0 0 0 0 0 4294438763 4294438746 4294440811 4294440811 4294440819 4294440811 4294963026 4294956601 4294428193 4294425880 4294423824 4294421776 4294421776 4293897488 4293897488 4294421776 4293897496 4293897488 4293897488 4293897488 4293897488 4293897488 4293895440 4293895440 0 0 0 0 0 0 0 0 4294438763 4294438755 4294440811 4294440811 4294965107 4294440811 4294965099 4294440811 4294965107 4294963043 4294434370 4294430249 4294425880 4293899536 4293899536 4293899536 4293899536 4293897488 4294423832 4293899544 4294423832 4293897488 4293897488 4293895440 4293897488 0 0 0 0 0 0 0 4294438763 4294440811 4294438755 4294440811 4294440819 4294438763 4294438763 4294965099 4294440811 4294965099 4294965107 4294965099 4294963043 4294960978 4294958649 4294430241 4294425872 4294425872 4293899536 4293899536 4294423824 4293899544 4293897488 4293897496 4293371144 4293371136 0 0 0 0 0 0 0 4294438763 4294438746 4294963043 4294440811 4293912419 4293912419 4294440811 4294965107 4294965099 4294965107 4294965115 4294965107 4294965115 4294965107 4294965099 4294963018 4294958641 4294432289 4294428176 4294428168 4294425872 4294425872 4293901584 4293899536 4293371144 4293371136 0 0 0 0 0 0 4294440811 4294436707 4294438746 4294965099 4293912419 4293912419 4294965099 4294965099 4294440819 4294440819 4294965107 4294965107 4294965107 4294965107 4294965115 4294965115 4294965107 4294965091 4294963026 4294434361 4294434345 4294430224 4294428168 4294428168 4293903888 4293901576 4293903896 4293903896 0 0 0 0 4294440811 4294438771 4294438746 4294438763 4294963051 4294438763 4294440811 4294965099 4294965107 4294965107 4294965107 4294440811 4294965107 4294965107 4294965107 4294965115 4294965115 4294965107 4294965107 4294965107 4294965099 4294963026 4294960953 4294432289 4294430232 4294428176 4293903872 4293903888 4293903896 0 0 4294438763 4294438763 4294438755 4294438746 4294438755 4294965099 4294963043 4294965099 4294440811 4294965099 4294965099 4294965115 4294965107 4294965107 4294965107 4294965107 4294965107 4294436707 4294438763 4294965107 4294965107 4294965115 4294965115 4294965099 4294440811 4294440803 4294963026 4294434361 4294430224 4293903888 4294428184 0 4294438763 4294438763 4294436682 4294438746 4294438755 4294438755 4294963043 4294440811 4294965091 4294965099 4294965099 4294965099 4294965099 4294440811 4294965107 4294965107 4294438755 4293385810 0 4294965107 4294965107 4294965107 4294965115 4294965107 0 4294965099 4294440811 4294965107 4294965091 4294436682 4293903896 4293903896 4294438763 4294436674 4293912394 4294436690 4294438746 4294438746 4294438746 4294438746 4294438755 4294440803 4294440811 4293912410 4293912419 4294965099 4294965099 4294965107 4293385810 4293912394 0 0 4294965107 4294965107 4294965107 4294440811 0 0 4294440811 4294440819 4294440819 4294965107 4294438755 4293903888 4294438763 4294436674 4294436682 4294436682 4294436690 4294438738 4293912402 4293912419 4294438746 4294438755 4294963051 4293910098 4293385810 0 4294440811 4294438755 4293385802 4293912402 0 0 0 4294965099 4294440819 4293912402 0 0 4294440811 4294965099 4293912427 4294440860 4294438771 4293912402 4294438763 4294965099 4293912394 4293912394 4293912402 4294438738 4293910090 4293910115 4294438755 4294438746 4294438755 4293912419 0 0 4294440803 4294438755 4293383754 4293912419 0 0 0 0 4294438763 4293385818 0 0 4294965107 4294440811 4293912443 0 0 4293912402 0 4294438763 4294436682 4293912386 4293914450 4294438746 4294436698 4294436715 4294438738 4294438746 4294438746 4294438755 0 0 4294965099 4294438755 4293385802 4293912402 0 0 0 0 4294965099 4294438763 4294965107 0 4294440811 4294965099 4293912460 0 0 4293912402 0 0 0 4294436682 4294436674 4293912386 4294438746 4294438746 4294436690 4293914450 4294438746 4294438746 4294438755 4294438755 4294438755 4294438755 4294438746 4293385810 0 0 0 0 4294965099 4294965099 4294440811 0 4294965107 4294440811 4293914500 0 0 4293912402 0 0 0 0 0 4294436674 4293912394 4294436682 4293912394 4294436690 4294438746 4294438738 4294438746 4294438746 4294438746 4294438755 4294438755 4293912394 0 0 0 4294438763 4294440811 4294440811 4294965099 4294440811 4294965107 4294440819 4294438771 0 0 4293912402 0 0 0 0 0 0 0 0 0 4294436690 4294436698 4294438738 4294436690 4294436690 4294438746 4294438746 4294438746 4294438746 0 0 4294438755 4294438755 4294438755 4294438755 4294440803 4294438755 4294440811 4294965099 4294440819 4294440819 4294965115 4293912402 0 0 0 0 0 0 0 0 0 0 0 0 4294438738 4294436698 4294436698 4294436698 4294436698 4294438738 4294438746 4294438746 4294438746 4294438746 4294438746 4294438746 4294436698 0 4294438755 4294438755 4294440803 4294438763 4294438763 4293912402 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4294436698 4293912410 4294438746 4294436690 4294438746 4294438746 4294438746 4293912410 0 0 0 4294438746 4294438755 4294438755 4294438746 4293912402 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4294436698 4294438746 4294438738 4294438746 0 0 0 0 4294438746 4294438755 4294436690 4293912402 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4294438746 4294438755 4294438755 4294438755 4294438746 4294438746 4294438746 4294438755 4293912394 4293912402 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4294438746 4294438755 4294438746 4294438746 4294438746 4293912394 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0! !

!SokobanTheme class methodsFor: 'themes' stamp: 'rkrk 5/13/2007 13:10'!
formHole

	^ Form
	extent: 32@32
	depth: 32
	fromArray: #( 4287325538 4287388251 4287060324 4286667610 4287912537 4289153880 4287453803 4286350227 4287847011 4287451481 4287453541 4287257443 4287451483 4287517274 4287386457 4287517017 4287388261 4286931809 4287454042 4287388249 4287976027 4288299351 4286938237 4286937988 4287322969 4287453793 4287324774 4287453795 4287847011 4288106841 4287781729 4287980139 4290058545 4289136417 4288415786 4288483361 4289005593 4288874520 4287769153 4287918970 4289597479 4288350242 4288874535 4289071147 4289136928 4288874535 4289005857 4288940331 4289464353 4289136417 4289071137 4288874785 4289660714 4289595699 4288236377 4288566106 4289527844 4289530146 4289136417 4289005857 4289988907 4289462314 4289464616 4290123825 4289601842 4288941858 4288876840 4289206056 4288942361 4287957008 4286198074 4286153594 4288487210 4287893793 4287895584 4287895327 4287961118 4288419626 4288420139 4288354344 4289007903 4288419875 4288352544 4288483361 4288286752 4288616487 4286798673 4286473052 4288939800 4288876576 4288483361 4288288800 4288876576 4289138721 4288354344 4289079601 4288489778 4288420390 4288419888 4288419626 4289072926 4288286498 4286921027 4286151544 4288354609 4288090145 4287958824 4288548904 4288352554 4288419626 4288354344 4288485419 4288419624 4288420135 4288354342 4289009194 4289073193 4288548906 4286861905 4286732891 4289005857 4289072930 4288286752 4288548896 4288614186 4288417567 4287830310 4288422449 4289079347 4288419888 4288747825 4288878888 4289531937 4289007905 4287313994 4286940801 4288878899 4288286759 4288352552 4288352041 4288221481 4288942120 4288876840 4288942122 4289009707 4288288551 4288878889 4289075498 4288876840 4288942128 4287322717 4287325025 4289398560 4289597227 4289139240 4288876325 4288942379 4288942122 4288419885 4288553267 4290060591 4289203752 4288942122 4288944163 4289007386 4288415768 4286921027 4286806653 4289012014 4288089893 4287923068 4287462516 4285951075 4284569429 4284174410 4284109643 4284372815 4284503890 4284766549 4285556576 4287200112 4288614186 4286994771 4286800473 4289661217 4288942623 4288155938 4289007905 4289007400 4289138723 4289007402 4289012015 4289471023 4288286502 4287959337 4287827751 4288548641 4288286498 4287377730 4286999418 4288417834 4287893543 4286016098 4282585370 4280294429 4279637526 4279571992 4279637528 4279572246 4279768085 4279637267 4280292372 4282860092 4287067759 4287792251 4287517529 4289071137 4289204265 4288417835 4288548906 4289073447 4288940331 4288352295 4289075250 4286872436 4287001204 4286149491 4286280560 4287394668 4288506984 4286345851 4284058514 4287199344 4284372302 4280295458 4279637526 4279571733 4279637267 4279637524 4279571735 4279571733 4279571731 4279637526 4279571733 4279703321 4282265137 4286147432 4287659893 4286739563 4286348404 4286282357 4286280561 4286739061 4286738283 4286213997 4286872187 4287844699 4287384393 4287515211 4287384139 4287316555 4288039508 4287316553 4286594372 4283386696 4280032025 4279637267 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279505940 4279571733 4279571733 4279571733 4279637267 4280622363 4284568917 4287265905 4287450196 4286794069 4287908941 4287776077 4287189338 4287908944 4288105044 4289405753 4288483113 4288417834 4288548904 4288352554 4288876329 4287959336 4284569429 4280097818 4279637267 4279571733 4279571733 4279637526 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279637526 4279505940 4279702806 4279702290 4280227605 4284438095 4287528309 4288352816 4288548906 4288749618 4288483879 4288744743 4289334055 4289077554 4288548641 4288352544 4288352544 4288548643 4288941868 4287041825 4281873200 4279637267 4279637526 4279505940 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279505940 4279637013 4279571474 4281013274 4285622110 4288223538 4288417055 4288551464 4288418086 4288614695 4288615200 4289077554 4287959073 4288354593 4288286498 4288548641 4288420137 4285555547 4280163357 4279571733 4279571733 4279571733 4279637526 4279571733 4279637526 4279505940 4279637526 4279571733 4279505940 4279571733 4279637526 4279637526 4279506453 4279505940 4279571733 4279637267 4282267955 4286805101 4288353314 4288549156 4288747303 4288876838 4288614697 4289012272 4288417568 4288417567 4288352291 4288548641 4288681767 4283845706 4279506453 4279571733 4279571733 4279505940 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279505940 4279571733 4279703319 4279505940 4279637267 4280095769 4285358170 4288550181 4288876838 4288877867 4288811561 4289073193 4289077307 4288483881 4288548651 4288548904 4288286762 4286608234 4281216297 4279506453 4279571733 4279505940 4279571733 4279571733 4279505940 4279505940 4279637526 4279571733 4279571733 4279571733 4279505940 4279571733 4279571733 4279571733 4279505940 4279571733 4279571735 4279768085 4283188289 4287719783 4288810532 4288484903 4288813096 4288745772 4288426307 4287963194 4287832378 4287898169 4287700790 4284897106 4279769625 4279505940 4279637526 4279571733 4279571733 4279505940 4279571733 4279637526 4279505940 4279571733 4279505940 4279505940 4279571733 4279571733 4279505940 4279637526 4279571733 4279571733 4279506201 4279571731 4280686362 4286080351 4289010742 4288097344 4287832630 4289009971 4287988860 4286804851 4286804851 4286935921 4287002735 4281939250 4279505942 4279571733 4279571733 4279571733 4279571733 4279637526 4279571733 4279571733 4279703319 4279571733 4279571733 4279637526 4279571733 4279571733 4279637526 4279505940 4279637526 4279571733 4279571733 4279571731 4279703319 4283714120 4287455081 4285958264 4285563775 4288376176 4289931586 4288487470 4289667122 4289405233 4286016614 4280358931 4279637274 4279440660 4279571733 4279571733 4279571733 4279571733 4279571733 4279637013 4279637013 4279637013 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279637528 4281216297 4287832363 4288815665 4289012525 4289475388 4289536315 4287830312 4288483360 4287726458 4284569168 4279702806 4279571733 4279637013 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279637013 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279637267 4279506453 4279571733 4280032025 4284767062 4288811047 4288417835 4289602095 4289472823 4288092201 4289072930 4287397493 4282716956 4279702810 4279440658 4279637526 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279505940 4279637526 4279505940 4279833878 4282596153 4288221230 4288877105 4289667385 4289077554 4287961120 4288352545 4286542442 4280750869 4279571731 4279637526 4279506453 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279506453 4279637013 4279637013 4279768085 4280756259 4286452006 4288286761 4289012024 4289208624 4287830312 4288419626 4285358938 4279833876 4279637015 4279506453 4279637015 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279637267 4279703060 4279375381 4279505942 4279834903 4284964437 4288484901 4289601842 4289533744 4288157994 4288352552 4284240465 4279768085 4279505940 4279637013 4279571731 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571731 4279571733 4279637015 4279702806 4283648840 4288481567 4290058032 4288491840 4287375929 4287725429 4283123264 4279505940 4279572246 4279506453 4279768081 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279375383 4279702292 4279506453 4279571731 4279571735 4282464566 4286521398 4288491587 4287984500 4286280299 4287331445 4281871917 4279571731 4279571220 4279637015 4279506453 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279637267 4279637015 4279506451 4279637267 4281545010 4285292126 4286806905 4285369219 4287322733 4286871149 4280952359 4279571731 4279571735 4279571735 4279637265 4279571733 4279571733 4279571733 4279571733 4279571733 4279637526 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571731 4279571731 4279506453 4279637015 4279768083 4281281324 4286140764 4285764749 4287713882 4289464883 4286015587 4279964949 4279571731 4279571733 4279571735 4279505938 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279637015 4279637013 4279571733 4279440660 4279637524 4280887334 4287695403 4288369245 4289026908 4289201960 4284569170 4279571731 4279571733 4279505940 4279571735 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279637015 4279506453 4279572246 4279571733 4279506451 4280624162 4287500328 4287915096 4288502106 4288415786 4282728506 4279375381 4279833624 4279637013 4279506451 4279440660 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279637013 4279571733 4279571733 4279505940 4279637267 4280427042 4286319652 4287849305 4287781720 4287367718 4281807407 4279440660 4279506199 4279637267 4279506451 4279571733 4279571733 4279505940 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279637013 4279571733 4279571220 4279572246 4279637013 4280032286 4286189606 4287783512 4287912536 4287236896 4281018666 4279571733 4279571733 4279506451 4279571733 4279637013 4279571733 4279374354 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571735 4279506453 4279637267 4279505940 4279506453 4279834392 4285075743 4287783510 4287842899 4287434022 4280820771 4279637013 4279637013 4279571474 4279571733 4279506453 4279505940 4279111182 4279505940 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571735 4279571733 4279505940 4279637528 4279571733 4279571733 4285205021 4288301392 4285694841 4286725969 4280427293 4279571733 4279571733 4279506453 4279505940 4279571733 4279505940 4278979596 4279440147 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279571733 4279506453 4279571735 4279506451 4279638039 4285150786 4286153595)
	offset: 0@0! !

!SokobanTheme class methodsFor: 'themes' stamp: 'rkrk 5/13/2007 13:10'!
formMouse
	"Source: www.squeakland.org"

	^ Form
	extent: 30@30
	depth: 32
	fromArray: #( 0 0 0 0 4292785589 4294426037 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292777092 4293889164 4293891204 0 0 0 0 0 4292772979 4293362795 4292246379 4291728524 4293377461 0 0 0 0 4292267726 4291217094 4291217085 4291217094 4291217094 4290624957 0 0 0 0 0 4290610291 4289555290 4292772987 4294415500 4294419868 4292248691 0 0 0 4291722091 4290605923 4291724403 4293366924 4292779148 4292254860 4292252812 4292787637 4291743446 4292269782 4291743438 4291217094 4290627261 4290624957 4290098613 4289572269 4289572269 4290624957 4289045933 4289045925 4291724411 4288439114 4291722091 4294415500 4294944156 4294946221 4294417564 4291730572 0 4292787637 4290605923 4289555290 4291724403 4293895572 4294423973 4294958806 4292257180 4291728524 4291743430 4291745494 4292269774 4291743438 4291217094 4290624957 4290098613 4289572269 4289045925 4289045925 4290098613 4290092188 4289031002 4290079578 4292772987 4294417548 4294946221 4294946221 4294421933 4292252812 0 4292785589 4290605923 4290079578 4292248699 4294419860 4294421916 4294428349 4293908174 4291206284 4291741373 4292269782 4291745494 4291743438 4291217094 4290624957 4289574325 4289572269 4289045925 4289047973 4290098605 4289565844 4288441178 4291195755 4294415492 4294419860 4294946221 4294946221 4294426037 4293366932 0 4292783533 4290605914 4289555290 4291724403 4294419860 4294421916 4294426029 4293906118 4291206292 4292265661 4292269782 4291743438 4291743438 4291743438 4290624957 4290098613 4289572269 4289045925 4289572269 4290096565 4289565836 4289555290 4291722099 4293891204 4294946213 4294946221 4294426037 4294419877 4292252812 0 4292787637 4290603875 4289555290 4291722099 4294419868 4294421916 4294423973 4293373349 4291202180 4292265670 4292269790 4292269782 4291743438 4291743438 4290624957 4290098613 4290096565 4289572261 4289572269 4290096565 4290088068 4289555290 4293362811 4294419868 4294946213 4294946221 4294948277 4293364868 4291730588 0 0 4290081635 4290079578 4291722099 4293366924 4294419860 4294421916 4293371284 4291202171 4292267726 4292271838 4292269782 4292269774 4291743438 4291217094 4290098613 4289574317 4289572269 4289045925 4290094501 4290083699 4290079578 4293889147 4294944148 4294421925 4294946221 4294946204 4291197803 0 0 0 4292261301 4291195747 4291724411 4292775044 4293893268 4294417548 4292250747 4290607979 4292265670 4292796126 4292269790 4292269782 4291743438 4291217094 4290098613 4290096565 4289572269 4289045925 4290094501 4291197811 4291195747 4293364868 4294419868 4294946221 4294946221 4292248699 0 0 0 0 4292269790 4291732892 4291197811 4292775052 4293893268 4294417548 4292248691 4291720035 4292787645 4291745494 4291743438 4292269782 4291743438 4291217094 4290098613 4289572269 4289572269 4289045925 4289570213 4292775044 4291720043 4294417540 4294944156 4294946221 4292250756 4291210661 0 0 0 4292269790 4292269782 4293914607 4292789958 4292250756 4294417556 4294944148 4293362811 4292248683 4291210661 4288456101 4289047973 4290098613 4290624966 4291217094 4290098613 4289572269 4289572269 4288456101 4290094509 4292777100 4292246379 4294944156 4294944156 4290083699 4289043612 4290098613 0 0 0 4292269782 4292796135 4293388263 4293390311 4292267726 4292779156 4294944156 4293889156 4292250747 4290616485 4286874764 4287927444 4288453788 4289047973 4289572269 4289572269 4289045925 4289045925 4289045925 4289045925 4292779156 4293889156 4293891212 4289559411 4285756275 4286282619 4287927444 4290098613 0 0 4292269782 4292796126 4293388263 4293388263 4293390319 4292794070 4291730572 4293893268 4292254868 4289043604 4286874756 4286874756 4287401100 4287403148 4287927444 4288453788 4287927452 4287927444 4287927444 4287929500 4289567900 4291206292 4288447611 4285758331 4285229931 4285756275 4286282619 4289045925 0 0 4292269782 4292796126 4293388263 4293388263 4293388263 4293390319 4292798430 4292267726 4290098613 4289045933 4288456101 4287929500 4287401108 4287401100 4287927444 4287403156 4287401100 4287925388 4287927444 4287927444 4288453788 4288456101 4288453788 4287401100 4287401100 4286282619 4286280563 4287927436 0 0 4291743438 4292796126 4292798430 4293388263 4293388263 4293388263 4293390311 4292798447 4292271838 4291743438 4290627270 4290098613 4289572269 4289572269 4289045925 4288453780 4287401108 4287401100 4287927444 4288453780 4289045916 4289045933 4289045925 4288453788 4287927444 4287401100 4286874756 4287927452 0 0 4291743438 4292269782 4292796126 4293388263 4293388263 4293388263 4293388263 4293390319 4293390319 4293388263 4292796126 4291745494 4292269782 4291743438 4290098613 4289045925 4288453788 4287927444 4287927444 4288453788 4289045925 4289045925 4289570213 4289045925 4288453788 4287403156 4287401100 4289045925 0 0 4291741390 4292269782 4292796126 4293388263 4293388263 4293388263 4293914607 4293916663 4293916655 4293388263 4293388263 4292798439 4292796126 4292269790 4291217094 4290098613 4289572269 4289045925 4289045925 4289045925 4289572269 4290098613 4290096557 4289572269 4289045925 4289045916 4287927444 4290098613 0 0 4291743438 4291745494 4292269782 4292796126 4293388263 4293388263 4287927444 4281413937 4285756275 4292796126 4293390311 4292798430 4292796126 4292269782 4291217094 4290098613 4289572269 4289572269 4289572269 4289572269 4288453788 4283585106 4283585106 4287927444 4289045925 4289045916 4288453788 4290098613 0 0 4286278490 4291217085 4292269782 4292796118 4293388263 4291217102 4279769112 4278190088 4280361249 4291743438 4293388263 4292796126 4292269782 4291743438 4290624957 4290098613 4289572269 4289572269 4289572269 4289572269 4285229931 4278190088 4278190088 4285229931 4289572269 4289045925 4286870379 4287925388 0 4284102953 4281929728 4287399035 4291219150 4291743438 4292796126 4292796126 4285229931 4280361249 4289572269 4293388263 4292269782 4291743438 4291743438 4291217094 4290098613 4289572269 4289572269 4289572269 4289045925 4289572269 4290098613 4283585106 4281413937 4288453780 4289045933 4286874756 4280883216 4279762944 0 4285217065 4283045896 4284107330 4290098621 4290624957 4291217094 4291743438 4292796126 4292798439 4293388263 4292269782 4291743438 4291217094 4290624957 4290624957 4290098613 4290098613 4289572269 4289045925 4289045925 4289045925 4289045925 4289572269 4289572269 4289045925 4288453788 4285225562 4279762944 4279762944 0 4284690721 4281929736 4282528033 4289045925 4290624957 4290098613 4290624966 4291219150 4291743438 4291743438 4291743438 4291743438 4291217094 4290624957 4290624957 4290098613 4289572269 4289045925 4289045925 4289045925 4288453788 4288453788 4288453788 4287929492 4287927444 4287401100 4283056697 4279238656 4279238656 0 4283050264 4281929728 4283580985 4289574325 4290098621 4290098613 4290098613 4290624957 4290624957 4290624957 4291217094 4291217094 4290624957 4290624957 4290624957 4290624957 4290098613 4289045925 4288453788 4288453788 4288453788 4287927444 4287927444 4287401100 4287401100 4286876804 4283585106 4279238656 4279238656 0 4283048208 4279762944 4283058762 4291214781 4290098613 4290098613 4289572269 4287399044 4289570204 4289572269 4290100661 4290624957 4290098613 4290622909 4288453788 4283585106 4284111450 4287929500 4288453788 4287927444 4287927444 4287401100 4287927444 4286872435 4287401100 4287927444 4284703587 4278190088 4279762944 0 4286274122 4281407504 0 0 4290098613 4290098613 4284695097 4281403392 4285223490 4289043612 4289572269 4290098613 4290098613 4290098613 4281413937 4278190088 4278190088 4281938225 4287927444 4287401100 4286874764 4287401100 4286280555 4280881152 4280881160 4286280563 4288453788 4283583042 4282523928 0 0 0 0 0 0 4290096557 4284098840 4283572488 4282525976 4287927436 4289572269 4290098613 4290098613 4290624957 4280361249 4278190088 4278190088 4279767064 4286874756 4287401100 4286874756 4287401100 4283056697 4279762944 4279762944 4287399044 0 0 0 0 0 0 0 0 0 0 4284098840 4283045896 4281407496 4286280555 4289572269 4290098613 4290098613 4290624957 4285229931 4279769112 4279242768 4283585106 4287927444 4286874756 4287401100 4286872443 4281409816 4279238656 4279238656 0 0 0 0 0 0 0 0 0 0 0 4284102953 4282521608 4281407504 4287399044 4290096557 4290624957 0 4290098613 4290622901 4288451732 4286874756 4287927452 4287927444 4286874747 4286874747 4286874747 4284109394 4278714368 4279238656 0 0 0 0 0 0 0 0 0 0 0 4284697154 4281929728 4280356872 0 0 0 0 4290622909 4290098613 4290098613 4290098613 4290098613 4290098621 0 0 0 4284111442 4278714368 4278714368 0 0 0 0 0 0 0 0 0 0 0 4289565828 4280352768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278190088 4278714368 0 0 0 0 0)
	offset: 0@0! !

!SokobanTheme class methodsFor: 'themes' stamp: 'rkrk 5/13/2007 13:10'!
formMouseLeft

	^ Form
	extent: 32@32
	depth: 32
	fromArray: #( 0 0 4292772979 4292772987 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4292772987 4293889164 4292772987 4293368972 0 0 0 0 0 0 0 0 0 4290098613 4289572269 4290098613 4290098605 4290098613 4290627270 0 0 0 0 0 0 0 0 0 0 0 0 0 4292775035 4294417548 4291720043 4289553234 4293893285 0 0 0 0 0 0 4289572269 4286874756 4287401100 4288453788 4289570213 4289572277 4289572277 4290618780 4291732901 4290622901 0 0 0 0 0 0 0 0 0 0 4293375413 4294417564 4294946204 4293891195 4289553234 4291197811 0 0 0 0 0 4286874756 4286282628 4287403148 4289045925 4290098613 4290622909 4290624949 4290610299 4291193690 4292770675 4293373357 4290624957 0 0 0 0 0 0 0 0 0 4294419877 4294421925 4294421933 4294415500 4291195747 4289553234 4291197811 0 0 0 4286874756 4286284923 4287927444 4289045925 4290098613 4290098613 4290100669 4291204236 4292246379 4290079578 4289553234 4294419877 4292265678 4291217094 0 0 0 0 0 0 0 0 4294421925 4294423981 4294946221 4294419852 4292248691 4288439114 4291722091 0 0 4286874756 4285756275 4287927436 4287401100 4288451740 4288453797 4289572269 4290088076 4293362811 4292772987 4291195755 4288439114 4293366932 4292792022 4291745494 4291217094 0 0 0 0 0 0 0 4293375413 4294421925 4294946221 4294944156 4292772987 4289553234 4292252812 0 4287929500 4285229931 4287401100 4287401100 4285756275 4285229931 4285229931 4286280563 4293366916 4294941844 4293889156 4291195747 4289028946 4293893268 4293383894 4292271838 4292269782 4291743438 0 0 0 0 0 0 0 4293893276 4294421941 4294946213 4293889147 4290077522 4292250764 0 4285229923 4286874756 4287927444 4287929500 4286282619 4284703587 4284113754 4286868331 4294944156 4294419852 4293889156 4291195755 4289555282 4294419860 4292796126 4292274151 4292271838 4291743438 0 0 0 0 0 0 0 4292772987 4294946229 4294421925 4294415492 4290079587 4292252812 4285756275 4286280571 4287403156 4287927444 4288453788 4289043621 4285229931 4283585106 4291202180 4294946213 4294419852 4294415500 4290079587 4290605923 4294421925 4292798439 4292798439 4292796126 4291743438 4291743438 0 0 0 0 0 0 4292257172 4294417564 4294946221 4294415500 4291195747 4291724411 4285756275 4286874756 4287927436 4288451740 4289045925 4290098613 4287401100 4285227875 4293893268 4294944156 4294419852 4292772987 4289555290 4293364859 4293906126 4292800487 4292798439 4292796126 4292269782 4291219150 4291743438 0 0 0 0 0 0 4292250756 4294946221 4294417548 4292246379 4292250756 4286280571 4287401100 4287927444 4288453788 4289572269 4290622909 4289574325 4290612356 4294946213 4294419852 4294417540 4291720043 4291722091 4294421916 4292798439 4292274151 4292798430 4292796126 4292269782 4291745494 4291217094 0 0 0 0 0 0 4292263349 4292248699 4294946204 4292770675 4292252812 4286282619 4287401100 4288453788 4289572269 4289574325 4290624957 4291217094 4294419868 4294944156 4294415500 4292770675 4291720043 4293889147 4293381830 4293390319 4292798439 4292798439 4292271838 4292269782 4291745486 4290627270 0 0 0 0 0 0 0 4291730588 4293364868 4294415500 4291204244 4286876812 4287929492 4289570221 4290098613 4290098613 4291217094 4291739069 4294944156 4293889156 4292246387 4291722091 4292248691 4291208613 4292274151 4293388263 4292798439 4292798430 4292271838 4292269782 4291743438 4290624957 0 0 0 0 0 0 0 0 4289561723 4293362811 4289041548 4287403156 4289045925 4290098613 4290098613 4290624949 4291219150 4293375405 4294415492 4291722099 4292246387 4292248699 4290622893 4292798439 4293388263 4293388263 4292796126 4292796126 4292269782 4292269782 4291743438 4290624957 4291217094 0 0 0 0 0 0 0 4285758331 4286282619 4287403156 4288453788 4289572269 4290098613 4290624949 4291217094 4291217094 4293366924 4292244331 4291197803 4292259245 4292794070 4293388263 4293388263 4293388263 4292798439 4292274151 4292269790 4292269782 4292269782 4291743438 4287401100 4287401100 0 0 0 0 0 0 0 4285229931 4286874756 4287927444 4289045925 4290098613 4290622909 4291217094 4291219142 4291745486 4292263357 4291730580 4292265670 4292800495 4292800487 4293388263 4293388263 4293388263 4292798439 4292271838 4292269790 4291745494 4291745486 4291743430 4291214781 4287401100 4291214781 0 0 0 0 0 4286874756 4285754227 4287401100 4288453788 4289572269 4290098613 4291217094 4291743438 4291743446 4292269782 4292271838 4292798439 4293390319 4293388263 4293388263 4293388263 4293388263 4292798439 4292796126 4292269782 4292269782 4291745494 4291743438 4291219142 4291214790 4287401100 4287925388 0 0 0 0 4278190088 4282530105 4286874756 4287927444 4289045925 4290098613 4291217094 4291743438 4291743438 4292796126 4292798439 4292274142 4292798439 4293388263 4293388263 4293388263 4293388263 4293388263 4292798439 4292271838 4292269782 4292269782 4291745494 4291217094 4291219142 4290624966 4290624957 0 4286280563 4282530114 0 4283585106 4278190088 4283585106 4287401100 4287927444 4289572269 4290098613 4291741382 4291743438 4292269782 4290624957 4289047981 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4292798439 4292796126 4292269782 4292269782 4291745486 4291217094 4291741382 4291217094 4290624957 4291217094 0 0 4282530114 0 0 4282532418 4286282619 4287401100 4288453788 4289572269 4291217094 4291743438 4292269782 4292798439 4283056706 4278190088 4289047973 4293916655 4293388263 4293388263 4292798439 4292798439 4292798439 4292271838 4292269782 4291745486 4291219150 4291219142 4291217094 4291217085 4291214790 4287927444 4281940281 4280363305 4281940290 0 0 4285229931 4286280563 4287401100 4289045925 4290098613 4291217094 4291745486 4292269782 4293388271 4285756275 4278190088 4288453788 4293916663 4293388263 4292798439 4292798430 4292796126 4292796126 4292269790 4291745494 4291743438 4291217094 4291219142 4291217094 4290624957 4290624957 4284109394 4281407504 4287925380 0 0 0 4284703587 4286282619 4287927444 4289572269 4290624957 4291743438 4292269782 4292271838 4293388263 4292274142 4288456101 4292798439 4293388263 4292798430 4292798439 4292796126 4292796126 4292271838 4292269782 4291745494 4291743438 4291217094 4291217094 4290624957 4290627261 4289043621 4282523928 4283043848 0 0 0 4282532418 4285229931 4286282619 4288453788 4290098613 4290624957 4291743438 4292269782 4292796126 4292798439 4293388263 4293392367 4292798439 4292798439 4292796126 4292271838 4292271838 4292271838 4292269782 4291743446 4291743438 4291217094 4291217094 4291214790 4290624957 4291217094 4286874747 4281931784 4283043840 4286276426 0 4284703587 4281413937 4285756275 4286872452 4288453788 4290098613 4291217094 4291743438 4292269782 4292796126 4292796135 4292274151 4292798439 4292796126 4292796126 4292271838 4291747550 4292269790 4292269782 4292269782 4291745494 4291219150 4291217094 4290624957 4290624957 4290622909 4290624966 4285752154 4281931776 4281929728 4285752138 0 4282532418 4283058762 4285229931 4286872443 4288453788 4290098613 4291217094 4292269782 4292269782 4292269790 4292796126 4292796126 4292796126 4292271838 4292271838 4292269782 4292269790 4291745494 4292269782 4291745494 4291745486 4291741390 4291217094 4290624957 4290622909 4290098613 4290100669 4285752154 4281405440 4282519560 4286870379 0 4281413937 4283585098 4285229931 4286282619 4289570213 4290622909 4291217094 4291743438 4292269782 4292269782 4292269790 4292269790 4292269790 4292269790 4292269782 4292269782 4292269774 4292269782 4291743446 4291745494 4286276434 4284105265 4288449668 4290100661 4290096557 4289574325 0 4288451732 4279238656 4281927680 0 0 4283054393 4283585106 4284705643 4282532418 4283585106 4289572269 4291217094 4291219142 4291745494 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4291743438 4291743438 4291745486 4289043621 4282521608 4281929728 4284102945 4290096565 0 0 0 0 4283580994 4284102961 0 0 4283587154 4283585098 4283585106 4278190088 4278190088 4286874756 4291217094 4291217094 4291219150 4291745494 4292269782 4292269782 4292267734 4292269782 4291743438 4291743438 4291217094 4291217102 4291743446 4285752163 4281929736 4284094480 4284690721 0 0 0 0 0 0 0 0 0 0 4285229931 4283058770 4278190088 4278190088 4286282619 4291743438 4291217094 4291741382 4291743438 4291743438 4291745486 4291743438 4291219150 4291743438 4291217094 4290624966 4290624957 4290624949 4283583033 4281929736 4282521608 4284102945 0 0 0 0 0 0 0 0 0 0 4287927444 4284111450 4280361249 4281411881 4288453788 4290624957 4290624957 4291217094 4291217094 4291741382 4291217094 4291217094 4291217094 4290624957 4290098613 4290098613 4290098613 0 4284699218 4281405440 4282521608 4284695097 0 0 0 0 0 0 0 0 0 0 0 4285754227 4284703587 4287401100 4290622909 4290098613 4290098613 4290624957 4290098613 4290624957 4290624957 4290624957 4290624957 4291217094 4290098613 0 0 0 4286282619 4278714368 4281927680 4286870371 0 0 0 0 0 0 0 0 0 0 0 0 4284703587 4287401100 4290624957 4290624957 4290624957 4290624957 4290624957 4290624957 0 0 0 0 0 0 0 0 0 4283583042 4283576617 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0! !

!SokobanTheme class methodsFor: 'themes' stamp: 'rkrk 5/13/2007 13:10'!
formMouseRight

	^ Form
	extent: 32@32
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4294946213 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4290098613 4290098613 4290098613 4290098613 4290098613 4289572269 4290098613 4290098613 0 0 0 0 0 0 0 0 4293368972 4292772979 4293889156 4293889156 0 0 0 0 0 0 0 0 0 0 0 4290624957 4291208613 4290618780 4289572277 4289572277 4289045925 4288453788 4287401100 4286874756 4289572269 0 0 0 0 0 0 4294419877 4289553234 4292246379 4294417548 4293889164 0 0 0 0 0 0 0 0 0 4290624957 4290100669 4293373357 4292770667 4291193690 4290610299 4290622909 4290624957 4290098613 4289045925 4287401100 4286282628 4286874756 0 0 0 0 0 4291197803 4289553234 4293889147 4294946213 4294419868 4293364859 0 0 0 0 0 0 0 0 4290624957 4292265670 4294419868 4289553234 4290079578 4292246379 4291204236 4290100669 4290098613 4290098613 4289045925 4287929492 4286282619 4285756275 0 0 0 0 4289553234 4290605923 4294417548 4294946221 4294419877 4292775035 0 0 0 0 0 0 0 4290624957 4290624957 4292794070 4293366924 4288439114 4291195755 4292772987 4293362811 4289565836 4289572269 4288453797 4288451740 4287401100 4287927436 4286280563 4286874756 0 0 4293897637 4289026634 4292248691 4294419852 4294946221 4294423981 4293364859 0 0 0 0 0 0 4290624957 4290624957 4292271838 4293383894 4293893268 4289028946 4291195747 4293889156 4294941844 4293364868 4286280563 4285229931 4285229931 4285756275 4287401100 4287401100 4285229931 4286874756 4286874756 4292783516 4289553234 4292772979 4294419868 4294946221 4294421925 4292775035 0 0 0 0 0 4290624957 4290624957 4292271830 4292274151 4292796126 4294419868 4289555282 4291195755 4293891204 4294944140 4294419868 4286868331 4284113754 4284703587 4286282619 4287929500 4287927444 4286874756 4285229923 4286874756 4292783525 4290077522 4293891204 4294946213 4294946229 4293893276 4292775035 0 0 0 0 4290100669 4290624957 4292269782 4292796126 4292798439 4292798439 4294421925 4290605923 4290079587 4294415500 4294419852 4294946213 4291202180 4283585106 4285229931 4289043621 4288453788 4287927444 4287403156 4286280571 4286280563 4292252812 4290079587 4293891204 4294944165 4294946229 4292772987 0 0 0 0 0 4290624957 4291743438 4292269782 4292796126 4292798439 4292800487 4293906126 4293364859 4289555290 4292772987 4294419852 4294944156 4293893268 4285227875 4287401100 4290098613 4289045925 4288451740 4287927436 4286874756 4285756267 4292248699 4291195747 4293891212 4294946221 4294417564 4292257180 0 0 0 0 0 4290624957 4291745494 4292269790 4292796126 4292798430 4292274151 4292798439 4294421916 4291722091 4291720043 4294417540 4294419852 4294946213 4290612356 4289574325 4290622909 4289572269 4288453788 4287927444 4287401100 4286282619 4292250756 4292246379 4294417548 4294946221 4292250756 0 0 0 0 0 4290624957 4290624957 4291745486 4292269782 4292271838 4292798439 4292798439 4293390319 4293381830 4293889147 4291720043 4292770675 4294415500 4294944156 4294419868 4291217094 4290624957 4289574325 4289572269 4288453788 4287401100 4286872452 4291728532 4292772979 4294946204 4292248699 0 0 0 0 0 0 4290624957 4290624957 4291745494 4292269782 4292269790 4292798430 4292798439 4293388263 4292274151 4291208613 4292248691 4291722091 4292246387 4293889156 4294944156 4291739069 4291217094 4290098613 4290098613 4289570221 4287929492 4286876812 4291204244 4294413452 4293364868 4292248699 0 0 0 0 0 0 4290624957 4290624957 4291743438 4292269782 4292269782 4292796126 4292796126 4293388263 4293388263 4292798439 4290622893 4292248699 4292246387 4291722099 4294415492 4293375405 4291219150 4290624949 4290098613 4290098613 4289045925 4287403156 4289041548 4293362811 4290086011 0 0 0 0 0 0 0 4290100669 4290624957 4291743438 4292269782 4292269782 4292269790 4292274151 4292798439 4293388263 4293388263 4293388263 4292794070 4292259245 4291197803 4292244331 4293366924 4291217094 4291217094 4290624949 4290098613 4289572269 4288453788 4287403156 4286282611 4285758331 0 0 0 0 0 0 4290624957 4290624957 4290624957 4291219150 4291745494 4292269782 4292269790 4292271838 4292798439 4293388263 4293388263 4293388263 4292800487 4292800495 4292265670 4291730580 4292263357 4291745486 4291219142 4291217094 4290622909 4290098613 4289045925 4287927444 4286874756 4285229931 0 0 0 0 0 0 4286280563 4291217094 4291214781 4291219142 4291743438 4292269774 4292269782 4292269782 4292796126 4292798439 4293388263 4293388263 4293388263 4293388263 4293390319 4292798439 4292271838 4292269782 4291743446 4291743438 4291217094 4290098613 4289572269 4288453788 4287401100 4285754227 4286872452 0 0 0 4285756275 4286280563 0 4291219142 4290624949 4291217094 4291217102 4291745494 4292269782 4292269782 4292271838 4292798439 4293388263 4293388263 4293388263 4293388263 4293388263 4292798439 4292274142 4292798439 4292796126 4291743438 4291743438 4291217094 4290098613 4289045925 4287927444 4286874756 4282530105 4282530105 0 0 4282530114 0 0 4291217085 4290624957 4291217094 4291217094 4291743430 4291745486 4292269782 4292269782 4292796126 4292798439 4293388263 4293388263 4293388263 4293388263 4293388263 4293388263 4289047981 4290624957 4292269782 4291743438 4291741382 4290624957 4289572269 4287927444 4287401100 4283585106 4278190088 4278190088 0 4281940290 4280887593 4281940281 4287927444 4291214790 4290627261 4291219142 4291217102 4291219150 4291745486 4292269782 4292271838 4292798439 4292798439 4292798439 4293388263 4293388263 4293916655 4289047973 4278190088 4283056706 4292798439 4292269782 4291743438 4291217094 4289572269 4288453788 4287401100 4286280571 4283056706 0 0 0 0 4280883216 4284109394 4290624966 4290624957 4291214790 4291219142 4291217094 4291743438 4291745494 4292269790 4292796126 4292796126 4292798430 4292798439 4293388263 4293916663 4288453788 4278190088 4285756275 4293388271 4292269782 4291745486 4291217094 4290098613 4289045925 4287401100 4286282619 4285229931 0 0 0 0 4283043840 4282523920 4288453788 4291217094 4290624966 4291217094 4291217094 4291743438 4291745494 4292269782 4292271838 4292796126 4292796126 4292798439 4292798430 4293388263 4292798439 4288456101 4292274142 4293388263 4292271838 4292269782 4291743438 4290624957 4289572269 4288451732 4286282619 4284703587 0 0 0 4285749842 4283043840 4281929736 4286874747 4291217094 4290624957 4290624966 4291217094 4291217094 4291743438 4291743446 4292269782 4292271838 4292271838 4292271838 4292796126 4292798439 4292798439 4293392367 4293388263 4292798439 4292796126 4292269782 4291743438 4290624957 4290098613 4288453788 4286282619 4285754219 4282532418 0 0 4286274122 4281929728 4281931776 4285752154 4290624966 4290622909 4290624957 4290624957 4291217094 4291219150 4291745494 4292269782 4292269782 4292269790 4291747550 4292271838 4292796126 4292796126 4292798439 4292274151 4292796135 4292796126 4292269782 4291743438 4291217094 4290098613 4288453788 4286872443 4285756275 4281413937 4284703587 0 4286868331 4282519552 4281405440 4285752154 4290624957 4290098613 4290622909 4290622909 4291217094 4291743438 4291745486 4291745494 4292269774 4291745494 4292269790 4292269782 4292271838 4292271838 4292796126 4292796126 4292796126 4292271838 4292269782 4291745494 4291217094 4290098613 4288453788 4286872443 4285229931 4283058762 4282532418 0 0 4281927680 4279238656 0 0 4289574325 4290096557 4290100661 4288449676 4284105273 4286276434 4291743438 4291745494 4291745486 4292269782 4292269782 4292269782 4292269782 4292269790 4292271838 4292271838 4292269782 4292269782 4291745486 4291217094 4290622901 4289570213 4286282619 4285229931 4283585098 4281413937 0 0 4284102961 4283580994 0 0 0 0 4289572277 4284102945 4281929728 4282521608 4289043621 4292269774 4291743438 4291743438 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4292269782 4291745494 4291217094 4291217094 4289572269 4283585106 4282532418 4284705643 4283585106 4283054393 0 0 0 0 0 0 0 0 0 4284100897 4284094480 4281929736 4285752163 4291743446 4291741390 4291219142 4291219142 4291743438 4292269782 4292269782 4292269782 4292269782 4291743438 4291219150 4291217094 4291217094 4286874756 4278190088 4278190088 4283585106 4283585098 4283587154 0 0 0 0 0 0 0 0 0 4284102945 4283045896 4281929728 4283583033 4288453788 4287929500 4290624966 4291217094 4291219142 4291219150 4291743438 4291745494 4291743438 4291743438 4291741382 4291217094 4291217094 4286282619 4278190088 4278190088 4283058762 4285229931 0 0 0 0 0 0 0 0 0 0 4284695097 4282521608 4281405440 4284109394 0 4288453788 4288453788 4290098613 4290624957 4291217094 4291217094 4291217094 4291741382 4291217094 4291217094 4290624957 4290624957 4288453788 4281411881 4280361249 4284111450 4287927444 0 0 0 0 0 0 0 0 0 0 0 4281929728 4278714368 4284699218 0 0 0 4288453788 4288453788 4288453788 4288453788 4288453788 4288453788 4290098613 4290098621 4290098613 4290098613 4290096565 4287925388 4284703587 4285756275 0 0 0 0 0 0 0 0 0 0 0 0 4283576617 4283058754 0 0 0 0 0 0 0 0 0 4288453780 4288453788 4288453788 4288453788 4288453788 4288453788 4287927444 0 0 0 0)
	offset: 0@0! !

!SokobanTheme class methodsFor: 'themes' stamp: 'rkrk 5/13/2007 13:12'!
mouseTheme
	"doIt: [self initThemes]"
	"doIt: [self current: (self themesAt: 'Simple')]"

	^ self new
		name: 'Mouse';
		addImage: #player -> self formMouse;
		addImage: #playerLeft -> self formMouseLeft;
		addImage: #playerRight -> self formMouseRight;
		addImage: #box -> self formCheese;
		addImage: #wall -> self formBricks;
		addImage: #goal -> self formHole;
		yourself! !

!SokobanTheme class methodsFor: 'themes' stamp: 'rhi 10/28/2005 11:08'!
simpleTheme
	"doIt: [self initThemes]"
	"doIt: [self current: (self themesAt: 'Simple')]"

	^ self new
		name: 'Simple';
		addImage: #player -> self formPlayerStar;
		addImage: #box -> self formBoxEllipse;
		addImage: #wall -> self formWallBordered;
		addImage: #goal -> self formGoalBordered;
		yourself! !


!SokobanWall methodsFor: 'testing' stamp: 'rhi 7/16/2003 19:06'!
isSokobanWall

	^ true! !


!SokobanWall class methodsFor: 'images' stamp: 'rhi 10/26/2005 19:13'!
blockImage

	^ SokobanTheme current wallImage! !


!SokobanWorld methodsFor: 'accessing' stamp: 'rhi 7/17/2003 12:46'!
boxes
	"^ <Set of: SokobanBox>"

	^ boxes! !

!SokobanWorld methodsFor: 'accessing' stamp: 'rhi 7/17/2003 12:46'!
boxes: aSet

	boxes := aSet.! !

!SokobanWorld methodsFor: 'accessing' stamp: 'rhi 7/16/2003 18:50'!
fixed
	"^ <SokobanField>"

	^ fixed! !

!SokobanWorld methodsFor: 'accessing' stamp: 'rhi 7/17/2003 13:40'!
fixed: aSokobanField

	self flag: #rhi. "Refactor!!"
	aSokobanField allBlocksDo: [:each | each isSokobanBlock ifTrue: [each sworld: self]].
	fixed := aSokobanField.! !

!SokobanWorld methodsFor: 'accessing' stamp: 'rhi 7/16/2003 20:41'!
index
	"^ <Integer>"

	^ index! !

!SokobanWorld methodsFor: 'accessing' stamp: 'rhi 7/16/2003 20:41'!
index: anInteger

	index := anInteger.! !

!SokobanWorld methodsFor: 'accessing' stamp: 'rhi 7/16/2003 18:50'!
movable
	"^ <SokobanField>"

	^ movable! !

!SokobanWorld methodsFor: 'accessing' stamp: 'rhi 7/17/2003 13:40'!
movable: aSokobanField

	self flag: #rhi. "Refactor!!"
	aSokobanField allBlocksDo: [:each | each isSokobanBlock ifTrue: [each sworld: self]].
	movable := aSokobanField.! !

!SokobanWorld methodsFor: 'accessing' stamp: 'rhi 7/16/2003 22:35'!
moves
	"^ <Integer>"

	^ moves! !

!SokobanWorld methodsFor: 'accessing' stamp: 'rhi 7/16/2003 22:35'!
moves: anInteger

	moves := anInteger.! !

!SokobanWorld methodsFor: 'accessing' stamp: 'rhi 7/16/2003 21:02'!
player
	"^ <SokobanPlayer>"

	^ player! !

!SokobanWorld methodsFor: 'accessing' stamp: 'rhi 7/16/2003 19:02'!
player: aSokobanPlayer

	player := aSokobanPlayer.! !

!SokobanWorld methodsFor: 'accessing' stamp: 'rhi 7/16/2003 22:35'!
pushes
	"^ <Integer>"

	^ pushes! !

!SokobanWorld methodsFor: 'accessing' stamp: 'rhi 7/16/2003 22:36'!
pushes: anInteger

	pushes := anInteger.! !

!SokobanWorld methodsFor: 'accessing' stamp: 'rhi 7/16/2003 21:03'!
range
	"^ <Point>"

	^ range! !

!SokobanWorld methodsFor: 'accessing' stamp: 'rhi 7/16/2003 21:03'!
range: aPoint

	range := aPoint.! !

!SokobanWorld methodsFor: 'accounting' stamp: 'rhi 7/17/2003 12:12'!
incrementMoves

	self moves: self moves + 1.! !

!SokobanWorld methodsFor: 'accounting' stamp: 'rhi 7/17/2003 12:11'!
incrementPushes

	self pushes: self pushes + 1.! !

!SokobanWorld methodsFor: 'derived accessing' stamp: 'rhi 7/16/2003 18:52'!
fixedAt: aPoint

	^ self fixed at: aPoint! !

!SokobanWorld methodsFor: 'derived accessing' stamp: 'rhi 10/26/2005 01:12'!
fixedAt: aPoint put: aSokobanBlock

	^ self fixed at: aPoint put: aSokobanBlock! !

!SokobanWorld methodsFor: 'derived accessing' stamp: 'rhi 7/30/2003 17:52'!
mazeSetName

	^ self class mazeSetName! !

!SokobanWorld methodsFor: 'derived accessing' stamp: 'rhi 7/16/2003 18:52'!
movableAt: aPoint

	^ self movable at: aPoint! !

!SokobanWorld methodsFor: 'derived accessing' stamp: 'rhi 10/26/2005 01:11'!
movableAt: aPoint put: aSokobanBlock

	^ self movable at: aPoint put: aSokobanBlock! !

!SokobanWorld methodsFor: 'mazes' stamp: 'rhi 7/30/2003 17:23'!
mazeSetNames

	^ self class mazeSetNames! !

!SokobanWorld methodsFor: 'mazes' stamp: 'rhi 7/30/2003 17:18'!
setMazesNamed: aSymbol

	self class setMazesNamed: aSymbol.! !

!SokobanWorld methodsFor: 'testing' stamp: 'rhi 7/17/2003 15:24'!
isFinished

	^ self boxes allSatisfy: [:each | (self fixedAt: each location) isSokobanGoal]! !

!SokobanWorld methodsFor: 'private' stamp: 'rhi 7/16/2003 22:40'!
addPadding

	self
		addPaddingTo: self fixed;
		addPaddingTo: self movable.! !

!SokobanWorld methodsFor: 'private' stamp: 'rhi 10/26/2005 01:09'!
addPaddingTo: aSokobanField

	| max |
	max := self range x.
	aSokobanField rows do: [:row | row
		add: (self class blockForFixed: self class free)
		withOccurrences: max - row size].! !

!SokobanWorld methodsFor: 'private' stamp: 'rkrk 5/13/2007 13:13'!
fitIntoWorld

	self fixed allBlocksDo: [:block |
		block isSokobanBlock ifTrue: [block fitIntoWorld]].
	self movable allBlocksDo: [:block |
		block isSokobanBlock ifTrue: [block fitIntoWorld]].! !


!SokobanWorld class methodsFor: 'accessing' stamp: 'rhi 10/25/2005 20:00'!
mazeSetName
	"^ <String>"

	^ MazeSetName! !

!SokobanWorld class methodsFor: 'accessing' stamp: 'rhi 10/25/2005 20:00'!
mazeSetName: aString

	MazeSetName := aString.! !

!SokobanWorld class methodsFor: 'accessing' stamp: 'rhi 7/16/2003 18:30'!
mazes
	"^ <IdentityDictionary key: Integer value: String>"

	^ Mazes! !

!SokobanWorld class methodsFor: 'accessing' stamp: 'rhi 10/25/2005 19:59'!
mazes: anIdentityDictionary

	Mazes := anIdentityDictionary.! !

!SokobanWorld class methodsFor: 'class initialization' stamp: 'rhi 10/25/2005 20:01'!
initialize
	"doIt: [self initialize]"

	super initialize.
	self setMazesNamed: #mazesUAlberta.! !

!SokobanWorld class methodsFor: 'constants' stamp: 'rhi 7/16/2003 21:19'!
box

	^ $$! !

!SokobanWorld class methodsFor: 'constants' stamp: 'rhi 7/16/2003 21:20'!
boxAtGoal

	^ $*! !

!SokobanWorld class methodsFor: 'constants' stamp: 'rhi 7/16/2003 21:20'!
free

	^ Character space! !

!SokobanWorld class methodsFor: 'constants' stamp: 'rhi 7/16/2003 21:20'!
goal

	^ $.! !

!SokobanWorld class methodsFor: 'constants' stamp: 'rhi 7/16/2003 21:20'!
player

	^ $@! !

!SokobanWorld class methodsFor: 'constants' stamp: 'rhi 7/30/2003 12:54'!
playerAtGoal

	^ $+! !

!SokobanWorld class methodsFor: 'constants' stamp: 'rhi 7/16/2003 21:21'!
wall

	^ $#! !

!SokobanWorld class methodsFor: 'derived accessing' stamp: 'rhi 10/26/2005 01:33'!
mazeAtIndex: anInteger

	^ self mazes at: anInteger! !

!SokobanWorld class methodsFor: 'instance creation' stamp: 'rhi 5/13/2007 19:34'!
fromFile: aString
	"inspectIt: [self fromFile: './Screens/screen.1']"

	^ self fromString: (FileStream fileNamed: (FileDirectory pathFromURI: aString)) contentsOfEntireFile! !

!SokobanWorld class methodsFor: 'instance creation' stamp: 'rhi 10/26/2005 01:13'!
fromIndex: anInteger
	"inspectIt: [self fromIndex: 1]"

	^ self fromString: (self mazeAtIndex: anInteger) index: anInteger! !

!SokobanWorld class methodsFor: 'instance creation' stamp: 'rhi 7/16/2003 20:42'!
fromString: aString
	"inspectIt: [self fromString: 
'    #####
    #   #
    #$  #
  ###  $##
  #  $ $ #
### # ## #   ######
#   # ## #####  ..#
# $  $          ..#
##### ### #@##  ..#
    #     #########
    #######']"

	^ self fromString: aString index: 0! !

!SokobanWorld class methodsFor: 'instance creation' stamp: 'rkrk 5/13/2007 13:14'!
fromString: aString index: anInteger

	| sworld |
	^ (sworld := self new)
		index: anInteger;
		fixed: (self fixedFrom: aString);
		movable: (self movableFrom: aString);
		range: (self rangeFrom: aString);
		fitIntoWorld;
		player: (self playerFrom: sworld movable);
		boxes: (self boxesFrom: sworld movable);
		moves: 0;
		pushes: 0;
		addPadding;
		yourself! !

!SokobanWorld class methodsFor: 'instance creation' stamp: 'rhi 7/17/2003 11:11'!
random
	"inspectIt: [self random]"

	^ self fromIndex: self mazes size atRandom! !

!SokobanWorld class methodsFor: 'mazes' stamp: 'rhi 12/21/2003 22:38'!
mazeSetNames
	"^ <OrderedCollection of: <Association key: Symbol value: String>>"

	^ OrderedCollection new
		add: #mazesLoma -> 'Loma';
		add: #mazesMasMicroban -> 'Mas Microban';
		add: #mazesMasSasquatch -> 'Mas Sasquatch';
		add: #mazesMicroban -> 'Microban';
		add: #mazesSasquatch -> 'Sasquatch';
		add: #mazesSasquatchIII -> 'Sasquatch III';
		add: #mazesSasquatchIV -> 'Sasquatch IV';
		add: #mazesSasquatchV -> 'Sasquatch V';
		add: #mazesSasquatchVI -> 'Sasquatch VI';
		add: #mazesUAlberta -> 'University of Alberta';
		yourself! !

!SokobanWorld class methodsFor: 'mazes' stamp: 'rhi 9/9/2004 13:27'!
mazeSetNamesAt: aSymbol

	^ (self mazeSetNames detect: [:keyValuePair | keyValuePair key == aSymbol]) value! !

!SokobanWorld class methodsFor: 'mazes' stamp: 'rhi 7/30/2003 17:13'!
mazeSets
	"^ <IdentityDictionary key: String value: BlockContext>"

	^ IdentityDictionary new
		at: #mazesLoma put: [self mazesLoma];
		at: #mazesMasMicroban put: [self mazesMasMicroban];
		at: #mazesMasSasquatch put: [self mazesMasSasquatch];
		at: #mazesMicroban put: [self mazesMicroban];
		at: #mazesSasquatch put: [self mazesSasquatch];
		at: #mazesSasquatchIII put: [self mazesSasquatchIII];
		at: #mazesSasquatchIV put: [self mazesSasquatchIV];
		at: #mazesSasquatchV put: [self mazesSasquatchV];
		at: #mazesSasquatchVI put: [self mazesSasquatchVI];
		at: #mazesUAlberta put: [self mazesUAlberta];
		yourself! !

!SokobanWorld class methodsFor: 'mazes' stamp: 'rhi 12/21/2003 22:26'!
mazesLoma
	"http://users.bentonrea.com/~sasquatch/sokoban/loma.html
	David W. Skinner <sasquatch@bentonrea.com>"

	^ IdentityDictionary new
		at: 1 put: '  ##### 
 ##   ## 
### #  # 
###$.# # 
#  $.#@# 
# #$.# # 
# #    # 
#  # ### 
##   ## 
 ##### ';
		at: 2 put: '##### 
#   #### 
# #$.  # 
#  .$#@# 
###$.  # 
  #  ### 
  #  # 
  #### ';
		at: 3 put: '  #### 
 ##  # 
 # . # 
 # * # 
## *### 
#  $ # 
#  @ # 
#  ### 
#### ';
		at: 4 put: '###### # 
#   ## # 
#  . # 
#  $ ### 
## * @ # 
###$ # # 
  #.#  # 
# #   ## 
# ###### ';
		at: 5 put: ' #### 
 #  # 
 #  # 
 #  #### 
###$$  # 
#  $.  # 
# #..### 
# @# # 
##   # 
###### ';
		at: 6 put: '  ##### 
  ##  # 
###   # 
#  $  # 
# .*.## 
## $ # 
###@ # 
  #### ';
		at: 7 put: '##### 
#   ## 
#  $ ## 
##$*. ## 
 # .@  # 
 #  #  # 
#####  # 
##  #### ';
		at: 8 put: '  ##### 
 ##   # 
###   # 
#  * ## 
# .@$## 
#  * ## 
##  ## 
##### ';
		at: 9 put: '  #### 
  #  # 
###  ### 
## $*  # 
#  *. @# 
#   #### 
#  ## 
##### ';
		at: 10 put: '#### ### 
#@ ### # 
# $$ ### 
# $ .  # 
## ..  # 
 ####### ';
		yourself! !

!SokobanWorld class methodsFor: 'mazes' stamp: 'rhi 10/26/2005 01:15'!
mazesMasMicroban
	"http://users.bentonrea.com/~sasquatch/sokoban/masmicroban.html
	David W. Skinner <sasquatch@bentonrea.com>"

	^ self mazesMasMicroban1, self mazesMasMicroban2! !

!SokobanWorld class methodsFor: 'mazes' stamp: 'rhi 12/21/2003 22:26'!
mazesMasMicroban1
	"http://users.bentonrea.com/~sasquatch/sokoban/masmicroban.html
	David W. Skinner <sasquatch@bentonrea.com>"

	^ IdentityDictionary new
		at: 1 put: '####
#  #
#  #
#  ###
#.$$@#
#  . #
#  ###
####';
		at: 2 put: ' #####
 #   #
##.# #
#  @ #
#  $ #
# #*##
#   #
#####';
		at: 3 put: '   ####
####  #
#  #  #
# . . #
# @$$ #
# # ###
#   #
#####';
		at: 4 put: ' #####
## @ ####
#  #  . ##
# #      #
# $$ #.  #
##    ####
 ##   #
  #####';
		at: 5 put: '######
#    #
# $$ ###
### @  #
  #  . #
  ## .##
   ####';
		at: 6 put: '   ####
####  #
#@.*  #
#  #  ###
####  $ #
   #  # #
   ##   #
    #####';
		at: 7 put: '  #####
###   #
#  $# #
#  .$ #
## ##.#
 #   @#
 ######';
		at: 8 put: '########
#   @  #
#   *  #
###.$###
  # * #
  #   #
  #####';
		at: 9 put: '######
#    #
# #$@#
# .*.#
# #$ #
#    #
######';
		at: 10 put: '#####
#   #
#   ###
#$$$@ #
#...  #
#######';
		at: 11 put: '######
#.#  #
#@$$ #
#..$ #
##   #
 #####';
		at: 12 put: ' #######
 #  #  #
 #  #$ #
##  .*+#
#   #$ #
#   #  #
##  ####
 #  #
 ####';
		at: 13 put: '#####
#   ###
#     #
#     #
###.###
# $*$ #
#  +  #
#######';
		at: 14 put: ' ####
##  ###
# .$  #
#@.$  #
# .$ ##
##  ##
 ####';
		at: 15 put: '####
#  ####
#  #  #
#.$**@#
##    #
 #   ##
 #####';
		at: 16 put: '    ####
  ###  #
  # $$ #
 ## #  #
## .#$@#
#      #
# ..####
#####';
		at: 17 put: ' #####
 #   #
 #$#@#
## $ #
#   ##
#.*. #
#    #
######';
		at: 18 put: ' #####
 #   ##
 #$#@ #
 # $  #
##  ###
# $.  #
#. .  #
#######';
		at: 19 put: '#######
#     #
# $$$.#
## #@.#
 # # .#
 #  # #
 ##   #
  #####';
		at: 20 put: ' ####
 #  ###
 #$   #
 # .# #
##*.  #
# $ ###
# @ #
#####';
		at: 21 put: '    ####
 ####  #
 #. .  ##
 #  # @ #
 ## #   #
 ## ##  #
 # $  ###
 #  $ #
 # # ##
 #   #
 #####';
		at: 22 put: ' #########
 #    #  #
 # $ $   #
 ## ###  #
### # #@###
#   ###   #
# # . .   #
#   #######
#####';
		at: 23 put: ' ##### #####
 #   ###   #
 #@$  ##.. #
###$#      #
#   ## ##  #
#       ####
#   #   #
#########';
		at: 24 put: '     #####
######   #
#   ## # #
# $@$    #
### ### ###
#         ##
#   ### .. #
#####    # #
    # #  # #
    #  ##  #
    ##    ##
     ######';
		at: 25 put: ' #####
##   ##
# .$. #
# $#$ #
# .$. #
#    ##
## @##
 ####';
		at: 26 put: '########
#      #
# ###$ #
# #  $ #
# #.*$@#
# #.#  #
#  .#  #
########';
		at: 27 put: '#######
#  +  #
# *$* #
#. # .#
#  #  #
#  #  #
#  #  #
# $#$ #
#  #  #
#######';
		at: 28 put: '  #######
  #     #
### ### #
# ..*   #
#  $$@ ##
####  ##
   #  #
   ####';
		at: 29 put: '######
#    #
# ##$###
# # $  #
# @.*. #
##     #
 #  ####
 ####';
		at: 30 put: '         #####
         #   #
########## # #
#.     #  $  #
#.  @  #    ##
#.# #######  #
#         $$ #
##  #####    #
 ####   ######';
		at: 31 put: '  ########
  #  #   #
  #  $   #
  #  ##$##
#### ##  #
# @...#$ #
#        #
######  ##
     ####';
		at: 32 put: '########
#      #
#    # #
###..$.#
  # #$##
  #  @ #
  ## $ #
   # # #
   #   #
   #####';
		at: 33 put: '### #######
## ####   #
# ## ...# #
 ###$   # #
##  $$### #
## @      #
###########';
		at: 34 put: '#####
#   ####
#  .#  #
## ..  ##
 # ## @ #
 # #    #
 # $ ####
 # $##
 # $ #
 #   #
 #####';
		at: 35 put: ' ##########
 #  ##    ##
 #     ##  #
 # # $#  # #
 # #  @ $# #
 # #  #$   #
 # ###  ####
## .   ##
#  .####
#  .#
#####';
		at: 36 put: '    ######
    #    ##
 #### ##  #
##      # #
# @$**. # #
#   # ##  #
#####    ##
    ######';
		at: 37 put: ' #####
 #   #
## # ##
# $   ##
#  $#. #
## $ . #
 #  #. #
 #### @#
    #  #
    ####';
		at: 38 put: '  ######
  #    #
### ## #
# ...  #
#  $ ###
# #$##
#  $ #
#  @ #
######';
		at: 39 put: ' ######
##    #
#  ## #
#@# $ #
#  *..#
## #$###
 #     #
 ###   #
   #####';
		at: 40 put: ' #####
 #   #
## . #
#  * #
# # ##
#  $ #
## * #
 # @ #
 #####';
		at: 41 put: '#####
#   ####
# # .  #
# #$.  #
# @$*# #
####   #
   #####';
		at: 42 put: ' #######
 #     ###
## ###$  #
#  .. $  #
#  .##$ ##
### # @##
  #   ##
  #####';
		at: 43 put: '     ####
     # @##
###### $ ##
#  . # $  #
#      $# #
## ..#    #
 ##  ######
  ####';
		at: 44 put: '    ####
 ####  ###
 #     $ #
 #  $$ # #
 # # @#  #
## ####  ##
#  ...    #
# ### #   #
#     #####
#######';
		at: 45 put: '   ###  #####
#### ####   #
#  ###      #
# ..  $$$$  #
# ..  # @#  #
#############
      #  #';
		at: 46 put: '########
#  #   #
#      #
#  ## ###
## ##   ####
 # ## $$$@ #
## ## #    #
# . . . ####
#   #####
#####';
		at: 47 put: '######
#    ###
# $ @  #
#  ### #
# $$ $ #
#     ###
### ##  #
# ....  #
#       #
#  ######
####';
		at: 48 put: '     #####
 #####   #
##  +  # #
# $$.$$  #
#  #.# ###
##  .  #
 #######';
		at: 49 put: ' #####
##   #
#    #
# .$.##
##$#$ #
 #.$. #
 #    #
 # @ ##
 #####';
		at: 50 put: ' ########
 #  #   #
##  #$  #
# .*@*. #
#  $#  ##
#   #  #
########';
		at: 51 put: '########
#  $.  #
#  $.  #
###  ###
#  $.  #
#@ $.  #
########';
		at: 52 put: '   ####
   #  #
   #$ #
   #  #
####@###
#  $   #
#  ..* #
#   #  #
########';
		at: 53 put: ' ######
 #    #
 #. ..##
###$ @ #
# $  $ #
#   ####
#####';
		at: 54 put: '     #####
    ##   #
    #  # #
    #  @ #
    #    #
  #####.###
  #    .  #
### #$#.  #
#  $$  ####
# #    #
#   ####
#####';
		at: 55 put: '   ####
 ###  ##
 # $ $ #
 #   # #
 ##$   #
  #  # #
  ## # #
  #. # #
  #.## #
###.## ##
#       #
#   @   #
#########';
		at: 56 put: '   #####
  ##   #
### .# #
#  $*$@#
#   .# #
### #  #
  #   ##
  #####';
		at: 57 put: '   #####
 ###   #
##     #
# **$ ##
#  * .#
### #@#
  #   #
  #####';
		at: 58 put: '    ####
 ####  ##
 #    $ #
 # #  # #
## #$$$@#
# ..  ###
# .. ##
###  #
  ####';
		at: 59 put: ' ######
 #    ###
 # $  $ #
 ##$# # #
### #@# ##
# . . .  #
#   ##   #
##########';
		at: 60 put: ' #######    #####
 #     ######   #
##      @ ...   #
#  ########## ###
# $  $   $     #
#  #   #   #   #
################';
		at: 61 put: '#####
#   #
#   ######
#$$$$ $ @#
#.....   #
##########';
		at: 62 put: '   ####
   #  ###
   # .  #
   #$.@ #
#### .$ #
#  $$.###
#     #
#######';
		at: 63 put: '#####
#   #####
#   $ $ ###
## $    $ ##
 ###### .. #
     #. . @#
     #     #
     ###  ##
       ####';
		at: 64 put: '#########
#  ##   ##
# $ $$*@ #
#  # . # #
## #. .  #
 #   #####
 #####';
		at: 65 put: '######
#    #
# ## ##
# # * ##
# #@*  ##
# # *   #
# # * $ #
# ## #.##
#    ###
######';
		at: 66 put: '     #####
     #   #
     # # #
     #   #
#######$ #
#    $..$#####
# # $.  .#   #
#   #.  .$ # #
#####$..$    #
    # $#######
    #   #
    # # #
    # @ #
    #####';
		at: 67 put: '   ####
  ##  ##
 ## *  ##
## $ .$ ##
#  . @ * #
# *   .  #
## $. $ ##
 ##  * ##
  ##  ##
   ####';
		at: 68 put: '     #
    #.#
   # $ #
  #     #
 #  ***  #
#.$ *@* $.#
 #  ***  #
  #     #
   # $ #
    #.#
     #';
		at: 69 put: '#######
# . . #
#.$$$.#
# $@$ #
#.$$$.#
# . . #
#######';
		at: 70 put: '########
#  #   #
#  #.. #
# $$$$$#
#  #...#
#  #   #
#  @   #
########';
		yourself! !

!SokobanWorld class methodsFor: 'mazes' stamp: 'rhi 12/21/2003 22:27'!
mazesMasMicroban2
	"http://users.bentonrea.com/~sasquatch/sokoban/masmicroban.html
	David W. Skinner <sasquatch@bentonrea.com>"

	^ IdentityDictionary new
		at: 71 put: '########
#   #  #
# $.$. #
##.  $ #
# $  .##
# .$.$ #
#  #  @#
########';
		at: 72 put: '#########
#       #
# *$*$* #
# $...$ #
# *. .* #
# $...$ #
# *$*$* #
#      @#
#########';
		at: 73 put: '#########
#       #
# .$.$. #
# $.$.$ #
# .$@$. #
# $.$.$ #
# .$.$. #
#       #
#########';
		at: 74 put: '#########
#       #
# $.$.$ #
# .$.$. #
##$.@.$##
# .$.$. #
# $.$.$ #
#       #
#########';
		at: 75 put: '#########
#   #   #
# .$.$. #
# $.$.$ #
##.$@$.##
# $.$.$ #
# .$.$. #
#   #   #
#########';
		at: 76 put: ' ######
 #  . ###
## $.   #
#  $*$$ #
#..*@*..#
# $$*$  #
#   .$ ##
### .  #
  ######';
		at: 77 put: '  #####
  #   ###
 ## #   ###
 #  .$#   #
## #$.$.# #
#  $.@.$  #
# #.$.$# ##
#   #$.  #
###   # ##
  ###   #
    #####';
		at: 78 put: ' #######
##     ##
#  $.$  #
# $#.#$ #
##..@.. #
# $#.#$ #
#  $.$  #
#   #  ##
########';
		at: 79 put: '    ####
 ####  #
 #     #
##.# # ##
#@$ $#  #
# .$    #
##.$##  #
 #. #####
 ####';
		at: 80 put: ' #### #####
##  ###   #
#  . #  $ #
# . .$ $ ##
###*## # #
  #  # @ #
  #  #####
  #  #
  ####';
		at: 81 put: ' #######
 #  #  ###
 #  #  . ###
 #   $ # @ #
 ## # $ $  #
  # ##..####
  #  #  #
### ### ###
#     $   #
#   ###.  #
##### #####';
		at: 82 put: ' ##########
 #        #
 #.####   #
##.$ @ $$ #
# .*.$ #  #
# ### ## ##
#        #
##########';
		at: 83 put: '###### ####
# .  ###  #
#      @  ##
#....# $#  #
###### $   #
     ##$ $ #
      #   ##
      # $##
      #  #
      ####';
		at: 84 put: '########
#  ##  #
#  ..  #
# .  . #
### ####
 #    ##
 # $$@ #
 ### $ #
###  # #
#    $ #
#    ###
######';
		at: 85 put: '        ####
        #  #
      ###  #
     ##    #
     #  #$###
     # $ $  #
     ##$    #
#######  ####
#     #  ##
#  @  ##  #
#  #  ....#
#    ######
######';
		at: 86 put: '  #####
 ##   #
 #  # #
##    #
#  $ ####
#  $$#. #
###$    #
  #  #  #
  ####. #
   #@#. ##
   #  .  #
   #     #
   #######';
		at: 87 put: '     ####
     #  ###
    ## .  ##
    #. .   #
    #.  #@ #
    ## ##  #
   ##  #####
  ## $ #
 ## $  #
## $  ##
# $  ##
#   ##
#####';
		at: 88 put: ' ######
 #. . #
 #  *.##
###$ @ #
# $  $ #
#   ####
#####';
		at: 89 put: '########
#      #
# #.#  #
#  *   #
##$*$ ##
#  *@##
# #.##
#   #
#####';
		at: 90 put: ' #####
 #   #
 #   ##
 #$*$ #
##. . #
# .@.##
# $*$#
##   #
 #   #
 #####';
		at: 91 put: '  ####
  #  #
  #  #
  #  ###
###$ $ ##
#  $@$  #
#   #   #
###### ##
  ## . .#
  #  . .#
  #     #
  #  ####
  ####';
		at: 92 put: ' ######    ####
 # @  ######  #
 #  #   $     #
## ....# $ #  #
#   ## ## $  ##
#      ### $ #
######## ##  #
          ####';
		at: 93 put: '    ####
  ###  #
 ## .  #
##     #
# .$. ##
# $ ###
# .$####
###    #
 ##$#  #
 #  #  #
 #  @ ##
 ###  #
   ####';
		at: 94 put: '       ######
    ####    ###
    #    ##   #
 #### ###..## ####
 #  #$$     #    #
##  $ $ #... @ # #
#  #  $ ##### #  #
#    ####  #    ##
##   #     #   ##
 #####     #####';
		at: 95 put: '#############
#       #   #
#    ## #   #
## ### $ $ ##
#@...# $$$ #
#          #
##..########
 ####';
		at: 96 put: '     ####
     #  #
 #####  #
 #  $ $ #
 # .#  ###
 # .#$$  ##
## .#     #
#  *###@  #
#        ##
## .######
 ####';
		at: 97 put: '#####    #####
#   ######   #
#          # #
## ####### # #
 # #     # # #
 # #$$ ..... #
## #   #######
#  #$#@#
# $ $  #
#  #  ##
####  #
   ####';
		at: 98 put: '#####
#   ###
# # $ ###
# # $   #
# #.$##@#
# #.$   #
#  .#####
## .  #
 #    #
 ######';
		at: 99 put: '  #####
  #   #
  #   #
  #  ###
###. # #####
#  . ###   #
#  . # $   #
# #.## $ $ #
#  . @  $$##
##  ###   #
 #### #####';
		at: 100 put: ' #######
 #     ##
 # ###  ####
 #   ##    #
 #  $ #### #
####$ .....#
#  #  #### #
####$$#    #
 #  $ # ####
 #  @ # #
 # #### #
 #      #
 ########';
		at: 101 put: '  #####
### . #
#  . $##
#  $$. ###
### .$$@ #
  ##$ .  #
   # . ###
   #####';
		at: 102 put: '   ####
  ##  #
  #   #####
  #       #
  #   #   #
  ##    .##
   #####.#
  ######.###
  #     .  #
###  #$#.  #
#  $$ $ ####
#   $ @ #
###  ####
  ####';
		at: 103 put: '  ##########
  #   #    #
### ... .# #
#    ## ## #
#    ##  # #
###  #@  # #
 ##  ##  # ###
  ##### $#$  #
   ## # $    #
    ### $##  #
     ##  #####
      ####';
		at: 104 put: '   ######
####    #
#    ## ##
# ##     #
# #  #   #
#  $$#$$ #
###$ $ $##
 ##     ##
 ####@####
 #  . .. #
 # .. .  #
 # .##   #
 #####   #
     #####';
		at: 105 put: ' ####
 #  ###
##    ##
#  * . #
# *$*$ #
## .$. #
 #@  ###
 #####';
		at: 106 put: '  ####
###  #
#  . ##
# #*  #
# $.#@#
##$.# #
#  $  #
#   ###
#  ##
####';
		at: 107 put: '  ####
 ##  ####
 #  $$  #
 # #  # #
 # $ $# #
 # #  # #
 #@#  # #
## #$#  #
# .....##
#   ####
#####';
		at: 108 put: '   ####
   #  #
  ## $###
  #  .  ###
### .$.   #
# $.$@$.$ #
#   .$. ###
###  .  #
  ###$ ##
    #  #
    ####';
		at: 109 put: ' #####
 # . #####
 #$ $$ $ #
 # .. . .#
##$   .$ #
# $.   $##
#. . .. #
#@$ $$ $#
##### . #
    #####';
		at: 110 put: '  ########
  #  #   #
###... . #
#    # ###
# @    #
###  # ##
  ### $ #
  ## $  #
### $  ##
#  $  ####
#    #   #
#  ##    #
#       ##
##  #  ##
 ####  #
    ####';
		at: 111 put: '  ####
  #  #
###  ##
#  $ .# ####
#  $#.###  #
#  $ .#    #
#####.# $  #
  ###.#$#@ #
  #  .  $  #
  #   ###  #
  ##  # ####
   ####';
		at: 112 put: '#########
#   #   #
# $...$ #
# $*@*$ #
# $...$ #
#   #   #
#########';
		at: 113 put: '###########
#         #
#  * . *  #
##*$*@*$*##
#  * . *  #
#    #    #
###########';
		at: 114 put: '      #####
    ###   #
    #   # #
    # #   #
##### $ $#####
#   ## # #   #
# # $ ... $# ##
#    #.@.#    #
## #$ ... $ # #
 #   # # ##   #
 #####$ $ #####
    #   # #
    # #   #
    #   ###
    #####';
		at: 115 put: '      #
     # #
    #   #
   # .$. #
  # .$.$. #
 # .$ $ $. #
#  $.$@$.$  #
 # .$ $ $. #
  # .$.$. #
   # .$. #
    #   #
     # #
      #';
		at: 116 put: '########
#  #   #
#      #
#  ## ##########
## ##  #       #
 # ##  #       #
 # ##  $ $ $ $ #
## ### #######@#
#    . . . .   #
#   ############
#####';
		at: 117 put: '       ####
 #######  #
##   ##   #
#    #  $ #
# # ##$  ##
# #   $ ##
#@# .#$ ##
#  ..  ##
###. ###
  #  #
  ####';
		at: 118 put: '     #####
     #   ##
######  $ ##
#    ##  $ ##
#     ##  $ #
#...#  ##   #
#   @  ##$  #
#...# ## $ ##
##### # $  #
    #     ##
    #  ####
    ####';
		at: 119 put: ' #######
 #     ###
 # ###.  #
 # # . # #
## #...  #
#@   .####
#  #  #
## #####
# $$   ##
#  $$   #
### $$  #
  #     #
  ##   ##
   #####';
		at: 120 put: '#### ####
#  ###  ######
#  #         #
####$  $## # #
 #   #   # $ ##
###    ## $$  #
#  ## $   #   #
# @ #  ########
#     ##     #
#......# ######
#      ###    #
######## ######';
		at: 121 put: '   #######
  ## .   #
 ##  .   #
 # $*.# ##
 # # .  #
## # . ##
#  ### #
# #   @##
# $$$#  #
#     # #
###   # #
  #$##  #
  #    ##
  ######';
		at: 122 put: '   ####
 ###  ##
 #     #
##*  # #
# *$*. #
#  @  ##
#######';
		at: 123 put: '  #####
###   ####
#   $  $ #
# $##  $ #
##     # #
 ##### # ###
     # ... #
     ##.   #
      ## @##
       #  #
       ####';
		at: 124 put: '#########
#   #   #
# $ * $ #
#..# #..#
# $ # $ #
# .$@$. #
# $ # $ #
#..# #..#
# $ * $ #
#   #   #
#########';
		at: 125 put: '     ##########
     #        ##
 ##### #### $  #
 #.. #     #   #
 #   .  # $  # #
 #.. #### # $  #
 ## ##  # $$#  #
  # #   ##    ##
###@###  ######
#     #
#     #
#  #  #
####  #
   ####';
		at: 126 put: ' #######
 #     #
 # $$  #
 #  $###
 # #  #
 # #$ #
 # #  #
## ## ##
#    ..#######
#@###...     #
#   #.#### $ #
### #.# $ $$ #
  #  .    #  #
  #########  #
          ####';
		at: 127 put: '#####
#@  ######
#  $ #   #
#.*.*. $ #
#  $ #####
##   #
 #####';
		at: 128 put: '   #######
  ##     ##
###  ###  #
#   #   # #
#@$***. # #
##      # #
 #### ##  #
    #    ##
    ######';
		at: 129 put: '       ####
########  #
#     $   #
#  ##.##  #
##$##  . ##
 #  . $# ##
 # ###.#  #
 # ### @  #
 #   $ ####
 #  ####
 ####';
		at: 130 put: '            ####
           ##  ###
          ##  @  #
         ##  *$ .#
        ##  **  ##
       ##  **  ##
      ##  **  ##
     ##  **  ##
    ##  **  ##
   ##  **  ##
  ##  **  ##
 ##  **  ##
##  **  ##
#  **  ##
# **  ##
#  ####
####';
		at: 131 put: '            ####
          ###  ###
         ##.$.   #
        ##.$.$$. #
       ##.$.$$.$##
      ##.$.$$.$.#
     ##.$.$$.$.##
    ##.$.$$.$.##
   ##.$.$$.$.##
  ##.$.$$.$.##
 ##.$.$$.$.##
##.$.$$.$.##
#.$.$$.$.##
## $$.$.##
 #@  $.##
 ####.##
    ###';
		at: 132 put: '                  #####
            ##### #   #
            #   ### # #
      ##### # #       #
##### #   # #   #### ##
#   ### # # ### #  # #
# #    @  #   # #  # ###
#   ####$###### ####   #
### #  # .      #    # #
  # #  #  ##  #    #   #
 ## #####  ##    # #####
 #         ##  ### #
 # # ### #  #####  # #####
 #   # #    # #    # #   #
 ##### #  #####  # ### # #
       # ###  ##         #
   ##### #    ##  ##### ##
   #   #    #  ##  #  # #
   # #    #        #  # ###
   #   #### ###### ####   #
   ### #  # #   #       # #
     # #  # ### # # ###   #
    ## ####   # #   # #####
    #       # # #####
    # # ###   #
    #   # #####
    #####';
		at: 133 put: '     ##### ##################
    #     #                  #
   #  #  #  ################  #
  #  #  #  #                #  #
 #  #  #  #  ##############  #  #
#  #  #  #  #              #  #  #
# #  #  #  #  ############  #  # #
# # #  #  #  #            #  #   #
# # # #  #  #  ##########  #  #  #
# # # # #  #  #          #  #  # #
# # # # # #  #  ########  #  #  #
# # # # # # #  #        #  #  #  #
# # # # # # # #  ######  #  #  # #
# # # # # # # # #      #  #  # # #
# # # # # # # # # ####  #  # # # #
# # # # # # # #       #  # # # # #
# # # # # # #   ## ##  # # # # # #
# # # # # #  ## ##   # # # # # # #
# # # # #  #    @.$# # # # # # # #
# # # #  #  #### # # # # # # # # #
# # #  #  #      # # # # # # # # #
# #  #  #  ######  # # # # # # # #
#  #  #  #        #  # # # # # # #
 #  #  #  ########  #  # # # # # #
# #  #  #          #  #  # # # # #
#  #  #  ##########  #  #  # # # #
#   #  #            #  #  #  # # #
# #  #  ############  #  #  #  # #
#  #  #              #  #  #  #  #
 #  #  ##############  #  #  #  #
  #  #                #  #  #  #
   #  ################  #  #  #
    #                  #     #
     ################## #####';
		at: 134 put: '            ##### # #####
           ##   ######  ##
          # #           # #
         ##### #######  ####
        ##   #  #   ## ##  ##
       # #      # # #      # #
      ##### ##  ## ##   #  ####
     ##   #  ####   ##### ##  ##
    # #      # #     # #      # #
   ##### ##  ##  #    ##   #  ####
  ##   #  ####   # #   ##### ##  ##
 # #      # #    # #    # #      # #
##### ##  ##     # # #   ##   #  ####
#   #  ####   ## #   #    ##### ##  #
#      # #         # # #   # #      #
## ##  ##   ######   # #    ##   #  #
## #####           # #       ##### ##
 # #  #   ### # ## # # #####  #  # #
## # #            @            # # ##
 # #  #  ##### # # ## # ###   #  # #
## #####       # #           ##### ##
#  #   ##    # #   ######   ##  ## ##
#      # #   # # #         # #      #
#  ## #####    #   # ##   ####  #   #
####  #   ##   # # #     ##  ## #####
 # #      # #    # #    # #      # #
  ##  ## #####   # #   ####  #   ##
   ####  #   ##    #  ##  ## #####
    # #      # #     # #      # #
     ##  ## #####   ####  #   ##
      ####  #   ## ##  ## #####
       # #      #   #      # #
        ##  ## ## # #  #   ##
         ####  ## # ## #####
          # #   $ # .   # #
           ##  ######   ##
            ##### # #####';
		at: 135 put: '          ####
          #  #          ####
      #####  #          #  #         ####
      #   #  #      #####  #         #  #
      #     ####    #   #  #     #####  #
      ####     #    #     ####   #   #  #
         # #   #   #####     #   #     ####
         # #####   #   # #   #  #####     #
     ##### ##  #####     #####  #   # #   #
     #   # ##  #  #####     #####     #####
     #     ##  #  #  ## #   #  #####     ####
     ####     ##  #  ## #####  #  ## #   #  #
       #  ##     ##  ## #####  #  ## #####  #
       #  #  ##     ###       ##  ## #####  #
       #  #  #  ##       ###     ###       ####
       ####  #  #  ##### ##  ##       ###     #
         #####  #  ##### ##  #  ##### ##  #   #
         #  #####  #   # ##  #  ##### ##  #####
     #####  #  #####     #####  #   # ##  #
     #   #  #  #  #####     #####     #####
    ##     #####  #   # #   #  #####     #
    #####     #####     #####  #  #  #   #
    #  ## #   #  #####     #####  #  #####
#####  ## #####  #  ## #   #  #####  #
#   #  ## #####  #  ## #####  #  #####
#     ###       ##  ## #####  #  #  ####
####       ###     ###       ##  #  #  #
  #  ##### ##  ##       ###     ##  #  #
  #  ##### ##  #  ##### ##  ##     ##  #
  #  #   # ##  #  ##### ##  #  ##     ####
  ####     #####  #   # ##  #  #  ##     #
    #####     #####     #####  #  ## #   #
    #   # #   #  #####     #####  ## #####
    #     #####  #   # #   #   ##### #
    ####     #   #     #####   #   # #
      #  #   #   ####     #    #     ####
      #  #####     # $#   #    ####     #
      #  #         # .#####      #  #   #
      ####         # @#          #  #####
                   ####          #  #
                                 #### ';
		yourself! !

!SokobanWorld class methodsFor: 'mazes' stamp: 'rhi 12/21/2003 22:27'!
mazesMasSasquatch
	"http://users.bentonrea.com/~sasquatch/sokoban/massasquatch.html
	David W. Skinner <sasquatch@bentonrea.com>"

	^ IdentityDictionary new
		at: 1 put: '#####
#   #####
# $ $ $ #
### # # #
  # #   #
 ## ### ##
 # .....@#
 # $ $   #
 # ### ###
 #     #
 #######';
		at: 2 put: '     ####
######..#
#     . #
#  #  ..#
#  ## ###
#    $  ##
#  # #$ @#
#  # $ $ #
#  ## $ ##
#####   #
    #####';
		at: 3 put: '          #####
         ##   ##
         #     ##
         #    @ #
############ #. #
#            #.##
# ############.#
#             .#
##$#$#$#$#$#$#.#
 #            .#
 ###############';
		at: 4 put: '       #####
     ###   #
#### #  $$ ####
#  ###  $  #  #
#    ###$$  $ #
# *#  @  ## # #
## ##### #..# ##
 #    ## #..#  #
 ##  $ # #..   #
# ## $ #  ..####
 # ##    #  #
  # ####   ##
   #   #####';
		at: 5 put: '     #####
  ####   #
  #  . # ###
  # $. $ $ #
  # #.## $ #
###@#..#$  #
#   ##.#  ##
# $ $ .# $#
## ###.## #
 #        #
 #####  ###
     ####';
		at: 6 put: '    #####
   ##   ######
   #  @   #  #
   #  #  $ * #
####  ###$#. #
#.....#    .##
#.....# #$#. ###
###     . ##   #
 #  ## ##$ ### ####
 #   #  #  $  $   #
 #   $$$# #  $  $ #
 #####  # ######  #
     #$    #   ####
    ## $ # #
    # $    #
    #    ###
    ######';
		at: 7 put: '         #####
##########   #
#. ........ .##
#  ####    #  ##
## $   #    #  ##
 # $  # #    #  ##
 # $ $ # #    #  #
 # $  $   #    @ #
 # $ $$  #       #
 # $## ###########
 #  #  #
 #    ##
 ######';
		at: 8 put: '     #########
 #####       #
##      #### #
# $ #  @ *..*###
#  #  # #....  #
#  #$#  #....  #
# $# # ##$###  #
#    #$       ##
##  $  $#  ####
 ##  $  ####
  ### $$ #   #
    #    # ###
    ######';
		at: 9 put: '              ####
           ####  ## ###
        ####  $   # #*# ####
 ########  $   $  # ### #  #
 #  $ $ $   $ ##  #     #  ##
## $     $ #### $ #######   #
#   $$ ##### $   ##      #  #
#  ## ##  $   $  #          #
#.#  $ # $ $  ####  ## ##   #
#.#  $ $ $ ####        #    #
#.#.#   $  #           #    #
#.#.  ###  #     ########   #
#.#.###@#### ##  #         ##
#.............   # ######  #
#  .########### ## #    ####
#####         #    #
              ######';
		at: 10 put: '             ####
   ##### #####  ##
  ##   ###       ##
 ##   * * . $ # @ ##
 #  ## * ## ### #  #
 # ## *  #  # $  # #
 # # *  #  #     # #
## #   ## # # ###  #
#  ## # #. $ .##  ##
# #.# ## ## #.#  ##
# #  $  #. $ .$ ##
#   #*  $.#  . ##
##### ## ## # ##
    # # $  #  #
    # #    # ##
    #  #$##  #
    ##      ##
     ########';
		at: 11 put: '    ####
    #  ####
    # $   #########
    # .#    $ ##  #
    # $# .## $    ##
 #### .###   #$$   #
##  ## #  .. # $$  #
#  $      ...#   $ #
# $  #####... #   ##
#  $#   #  .**@####
###   # #    # #
  #####  ####  # #
      ##      ##
       ########';
		at: 12 put: '#  ###
 ##   ##
 #*.$  #
# .$.$ .##
# $.$.$  #
#  $.@.$  #
 #  $.$.$ #
 ##. $.$. #
   #  $.*#
   ##   ##
     ###  #';
		at: 13 put: '    #####
    #   #####
    # # #   #
    #     # #
 #####.# ...#####
 #  .$$ ###$#   #
 # #.#     $. # #
 #  .# $$$  #   #
###  # $@$ #  ###
#   #  $$$ #.  #
# # .$     #.# #
#   #$### $$.  #
#####... #.#####
    # #     #
    #   # # #
    #####   #
        #####';
		at: 14 put: '    #######
    #     ###
    # ###$  ##
    #....$   #
  ### ## #   #
###@.$  # # ##
# .*.$   ## #
#  $.$  #.$$#
#  ## ##    #
#####   # ###
    ###  $ #
      ##   #
       #####';
		at: 15 put: '  #####
  #   #####
  # $$#   #####
  #   . $ #   #####
 ### ##   . $ #   #####
 #   ##.### ....$ #   #####
 # $$#   ###.##.  # $ #   #
 #   # $ #  .##.###   .$$ #
### ##   .$$$#   ###.##   #
#   ##.###   #$$$.   ## ###
# $$.   ###.##.  # $ #   #
#   # $ #  .##.###   #$$ #
#####   # $.... ###.##   #
    #####   # $ .   ## ###
        #####   # $ .   #
            #####   #$$ #
                #####  @#
                    #####';
		at: 16 put: '#############
#           #
# .$.$.$.$. #
# $.$.$.$.$ #
# .$.$.$.$. #
# $.$.$.$.$ #
# .$.$@$.$. #
# $.$.$.$.$ #
# .$.$.$.$. #
# $.$.$.$.$ #
# .$.$.$.$. #
#           #
#############';
		at: 17 put: '#############################
#                           #
# .$.$.$.$.$.$.$.$.$.$.$.$. #
# $.$.$.$.$.$.$.$.$.$.$.$.$ #
# .$.$.$.$.$.$.$.$.$.$.$.$. #
# $.$.$.$.$.$.$.$.$.$.$.$.$ #
# .$.$.$.$.$.$.$.$.$.$.$.$. #
# $.$.$.$.$.$.$.$.$.$.$.$.$ #
# .$.$.$.$.$.$@$.$.$.$.$.$. #
# $.$.$.$.$.$.$.$.$.$.$.$.$ #
# .$.$.$.$.$.$.$.$.$.$.$.$. #
# $.$.$.$.$.$.$.$.$.$.$.$.$ #
# .$.$.$.$.$.$.$.$.$.$.$.$. #
# $.$.$.$.$.$.$.$.$.$.$.$.$ #
# .$.$.$.$.$.$.$.$.$.$.$.$. #
#                           #
#############################';
		at: 18 put: '  #####################
 ##        #     #    #
 #  $ $ $  #$ $ $ $  $###
 # $##### $$  $## ## $  #
 #  #  ..#   # #    #   #
 ##$   ... # #   ...#$ ##
##   $ ... #$ #  ...$  ##
#  $####..#    ##...##$ #
#    *.*..$$@$$..*.*    #
# $##...##    #..####$  #
##  $...  # $# ... $   ##
## $#...   # # ...   $##
#   #    # #   #..  #  #
#  $ ## ##$  $$ #####$ #
###$  $ $ $ $#  $ $ $  #
  #    #     #        ##
  #####################';
		at: 19 put: '       #####  #####
       #   #  #   #
       # #.####.# #
       # ..    .. #
#####  ### #### ###
#   #    # #    #
# # ##   # #@## #
#  $ ##  # #  # ###
##  $ ## # $  $.. #
 ##  $ ### #  #.# #
  ##  $ ## ## #   #
   ##  $ # #  #####
    ##  $  $ ##
     #####  ##
         ####';
		at: 20 put: '          #########
     #### #       #
  ####  # # $     #
  #  #  ####.#    #
  #   $ $   .#### #
  #  $#$## #.#....#
### # $  # #.#....#
#  $ $  # #..*....#
# # ## $  # ####  #
#  $ # # $#      ##
##  $  #    ######
 ##  $ # $$$#
  ## $$@##  #
   ##      ##
    ########';
		at: 21 put: '   #############
   #     #     #
   # $ $ $ $ $ #
   ### ##### ###
####.$   $   $.####
# ...# $ # $ #... #
#  $##*#.#.#*##$  #
##   . . @ . .   ##
#  $##*#.#.#*##$  #
# ...# $ # $ #... #
####.$   $   $.####
   ### ##### ###
   # $ $ $ $ $ #
   #     #     #
   #############';
		at: 22 put: '   ##########
  ##        #
 ##    ###  #######
 # $$ #    $#  #  #
 #  ###  #$$      #
 #    $$ #     #$$#
 #  #   #### #$   #
 ## # ###.*. # ## #
## *.*.#..*.##    ###
#  ***...**.### $$  #
# #....#...#  #   # #
#  ## ##.*. $ # ### #
##  # $ ..##   $  # #
 ## # $$### $#$$  # #
  #  @  #   $    #  #
  #####   ##$####  ##
      ######      ##
           ########';
		at: 23 put: '############## #######
#             #       #
#.##########  #$#####  #
#           #        #  #
#*########  # ######  #  #
#         #         #  #  #
#*######  # #######  #  #  #
#       #          #  #  #  #
#*####  # ########  #  #  #  #
#     #           #  #  #  # #
#*##  # #########  #  #  # # #
#   #            #  #  # # # #
#$  # ##########  #  # # # # #
# #             #  # # # # # #
# # ###########  # # # # # # #
#. @           $ * * * * * . #
##############################';
		at: 24 put: '                    ####
              #######  #
              #      $ ##
    ########  # ..## $  #
           ## ##.#  #   #
   #######     #.# $ $###
 ###     #######.#  # ##
 #   ##    #   $.  $$  #
 # ##  #.# #@# #.#  ## #
 #  $$  .$   #    ##   #
 ## #  #.#######     ###
###$ $ #.#     #######
#   #  #.## ##
#  $ ##.. #  ########
## $      #
 #  #######
 ####';
		at: 25 put: '  ######
  ##   ###########
  # $ $  $  # *  ######
  # .*.#..*.# .$     ##
  # *  # $ $  * $#*.$ #
 ## ####    # .  # *  #
 #  $ #########.## .$ #
 #.*.. *        #### ##
 #$ $ #$#.$$.*# #    #
 #    # #*.$$.#$# $ $#
## ####        * ..*.#
# $. ##.######### $  #
#  * #  . #    #### ##
# $.*#$ *  $ $ # .$ #
##     $. #.*..# * @#
######  * #  $  *.$ #
     ###########   ##
               ######';
		at: 26 put: '######    #######
#  ..#    #  #  #
#  ..###### $#  #
## #.  $ ##  $  #
 #  $$$   # ##$##
 #.#. #$ $  #  #
 #.#.## ##  $  #
 #.#   $  # #  #
 #. ##   @# ##$#
 #.   ####     #
 #.      $  $# #
 #. ########   #
 ####      #####';
		at: 27 put: '################
#   #   ##  #  #
# .$. $  # . . #
## ### #  $ #$ #
# . #  ### ##.##
#  $ .$  #. #  #
### ## #  $  $ #
##  #  ### ##  #
#  ## ###  #  ##
# $  $  # ## ###
#  # .#  $. $  #
##.## ###  # . #
# $# $  # ### ##
# . . #@ $ .$. #
#  #  ##   #   #
################';
		at: 28 put: ' ##########
 #    #   #
 # $  #   #     ####  #####
 ### $$   #######  ####   #
## $  $  ###   ##  $      #
# $   ###  # # ##  ##### ###
#  #$#       ..### ##  #   #
#    #  #.# #.. #   # $  $ #
### $ $ #.# #.. #   #  ## ##
  #  #  #.#  #### #### ##  #
 ########.#         # $  $ #
 #  ..  #.# ######  #   #  #
 #.$$$$.#.# #   #  #### ####
 #.$ @$.#.# # # #  $      #
 #.$$$$.#.# #   #  ####   #
 #  ..   .  #   ####  #####
 ############';
		at: 29 put: '                #####
          #######   # #####
     ######       #.###   #
    ##      # ### #.    * #
    #  ###### ##  #  ### ##
    # ## $ ..$ # $   ##  #
    # #  $ *.$@##### #  ##
    # #    ..$ # $   # ##
#####$#######$## # .   #
# $            . #### ####
# $$# #########$##   .   #
# # . .#      .  # $$*$$ #
#   .  # $.$.#   #... ...#
##### $ # ## ##### $$*$$ #
    #.#    #         .   #
    ######################';
		at: 30 put: '    ####
#####  ##########
#      #  #     #
# #  ..   ##   $###
# # ##.#.  # $$$@ #
#      #.  # $  # #
#   ######## $  # #
###    $       ## #
  #.############  #
  #.             ##
  ################';
		at: 31 put: ' #####
##   # ####
#    ###  #
#  # @#   #
##$####   ######
# ...    ##    ##
# ...  #    ##  #
#### # #####  # ##
   # #       $#  #
   # # $ $ $$  # #
   #  #####    # #
   ##      #   # #
    ######  ###  #
         ##     ##
          #######';
		at: 32 put: '      #
    ## ##
    #   #
   # .$. #
 ##  $.$  ##
 # .$.$.$. #
#  $.$+$.$  #
 # .$.$.$. #
 ##  $.$$ ##
   # .$.    #
    #   # # #
    ## ##   #
      #  ###';
		at: 33 put: '#####
#   ##
#  $ #####
##  $ #  #
 ## $ # $###########
  ##      $ $ $ $  #
   #####$ # # #  # #
       #      #    #
       # #######$#######
      ##         #@#   #
      #  # # ##  #     #
      #..*.*.*......   #
      ##########    # ##
               ####   #
                  #####';
		at: 34 put: ' #####  #####
 #   ####   #
## #$.*.$ # #
#   $.@.$   #
# # $.*.$# ##
#   ####   #
#####  #####';
		at: 35 put: '         #####
##########   #
#      $ $$$ #
# $## #  # # #
# $    # # # #
##$## .#.    #
 #   ..... # #
 #$ ##.@.## $#
 # # .....   #
 #    .#. ##$##
 # # # #    $ #
 # # #  # ##$ #
 # $$$ $      #
 #   ##########
 #####';
		at: 36 put: ' ####### #######
##  .  ###     ##
# $$.$$ # .$.$. #
# $ . $ # $.$.$ #
#...#...  .$@$. #
# $ . $ # $.$.$ #
# $$.$$ # .$.$. #
##  .  ###     ##
 ### ### ### ###
##     ###     ##
# .$.$. # .$$$. #
# $.$.$ # $...$ #
# .$ $.   $.#.$ #
# $.$.$ # $...$ #
# .$.$. # .$$$. #
##     ###     ##
 ####### #######';
		at: 37 put: '            #####
        #####   #####
    #####   # $ #   #####
#####   # $$     $$ #   #####
#   #$$ .   ##$##   . $$#   #
# $$.   ##### . #####   .$$ #
#   #####   ##.##   #####   #
##$ #   #.... . ....#   # $##
 #  . $ .   # @ #   . $ .  #
##$ #   #.... . ....#   # $##
#   #####   ##.##   #####   #
# $$.   ##### . #####   .$$ #
#   #$$ .   ##$##   . $$#   #
#####   # $$     $$ #   #####
    #####   # $ #   #####
        #####   #####
            #####';
		at: 38 put: '#####                 #####
#   ###################   #
# # $ $ $ $ $ $ $ $ $ $ # #
# $ #     #     #     # $ #
##  #.###.#.###.#.###.#  ##
 #$ #  .  #  *  #  .  # $#
 #  .  #  .  #  .  #  .  #
 #$###.#.###.@.###.#.###$#
 #  .  #  .  #  .  #  .  #
 #$ #  .  #  *  #  .  # $#
##  #.###.#.###.#.###.#  ##
# $ #     #     #     # $ #
# # $ $ $ $ $ $ $ $ $ $ # #
#   ###################   #
#####                 #####';
		at: 39 put: ' #################
 #               #
##$#.#.#.#.#.#.#$##
#  $.$.$.$.$.$.$  #
#  #$#$ $@$ $#$#  #
#  $.$.$.$.$.$.$  #
##$#.#.#.#.#.#.#$##
 #               #
 #################';
		at: 40 put: '                #####
  ###############   ########
 ## $ $ $ $ $    $ $ $ $ $ ##
###     #         #        ###
#  #.##.#.##.#.##.#.##.#.##  #
# $#  .$ $  $#  .$ $  $#  .$ #
#  .  #$  $ $.  #$  $ $.  #  #
# $##.#.##.#.##.#.##.#.##.#$ #
##      .  #   @  .  #      ##
##      #  .      #  .      ##
# $#.##.#.##.#.##.#.##.#.##$ #
#  #  .$ $  $#  .$ $  $#  .  #
# $.  #$  $ $.  #$  $ $.  #$ #
#  ##.#.##.#.##.#.##.#.##.#  #
###        #         #     ###
 ## $ $ $ $ $    $ $ $ $ $ ##
  ########   ###############
         #####';
		at: 41 put: ' ###########
##    #    ##
# $$*.$.*$$ #
#...     ...#
# $$*.$.*$$ #
##    *    ##
# $$*.$.*$$ #
#...  @  ...#
# $$*.$.*$$ #
##    #    ##
 ###########';
		at: 42 put: '###########
#         #
# $## ### ##   #####
#  # $ $ $ #####   ###
# $    #     # $. .  #
#  ##$###$## # #...# #
# $    #     # #. .# ##
## # $ $ $## # #...#  #
#  ## ### #. # #. . # #
# $       #    #    # #
# @######## ###     # #
####     #       ###  #
         # ####  #   ##
         #     ##  ###
         #####    ##
             ######';
		at: 43 put: '         #######
  ########  #. #
  #        $ * #####
  # ## ##   #. #   #      ####
### # $ $$#$#. # # ########  #
#  $#   #  $ * #......       #
# $    ### $#.  #  ####      #
## # #$$ # $ .# #  #  ##     #
 # #   $   @##  # ##   ##   ##
 #  ##  $$$ #  ## ###   #####
 ##  #.##.###       #
  ## #*$.*...  ##   #
   #   #   ##  ##  ##
   ###   ###########
     #####';
		at: 44 put: '     #######
     #  @  #
###### ### ######
#   #   $   #   #
#   $   #   $   #
##$###*###*###$##
#   $   #   $   #
#   #   *   #   #
##$###*###*###$##
#   #   $   #   #
# ..*...#...*.. #
###### ### ######
     #     #
     #######';
		at: 45 put: '              ####
           #### .#
     ####  #    .####
   ###  ####  ##..  ##
   #  $ #  #$ #...   #
   # #  #  #  #...   #
   # #$ # $ $ #      #
####  $    #  #    @##
#     # #$$#####   ##
#   $ $ #  #   #####
######  #  #
     ####  #
        ####';
		at: 46 put: '         #### ####
         #  ###  #
      #### $ $   #######
      #   $   #$   ##  ####
      # ### ###        #  #
     ##  $   ###### #     #
     #  $ # ##    #####   #
     # # #  #  # $$ # ## ###
     # #    #$.## $        #
     # ######   $  # ###   ##
     #....*.**.# #   # #   ##
     ####      # ##### #####
       ##$## ###$#
      ##  #   $  #
#######   # $    #############
# $      ###### ##         @ #
#        .........           #
##############################';
		at: 47 put: '      #####
      # . #
  ##### . #####
  #   $ . $   #
  # $ ##.## $ #
  #   # $ #   #
###$##     ##$###
#   #  ***  #   #
#....$ *@* $....#
#   #  ***  #   #
###$##     ##$###
  #   # $ #   #
  # $ ##.## $ #
  #   $ . $   #
  ##### . #####
      # . #
      #####';
		at: 48 put: '        #
       # #
     ##   ##
     # $.$ #
    #  . .  #
  ## $.$.$.$ ##
  #  . # # .  #
 # $.$# $ #$.$ #
#  . . $@$ . .  #
 # $.$# $ #$.$ #
  #  . # # .  #
  ## $.$.$.$ ##
    #  . .  #
     # $.$ #
     ##   ##
       # #
        #';
		at: 49 put: '    ####
    #  ######
    #  $ $  ###    ####
    #   $     #   ##  #
#####*#*#$$$  #  ## $ #
#     $ $   $ # ##    #
#  #$    $ $##### $$ ##
## # ####  .....#   ##
#      # $  **.## ###
#   #  # $$ #.##.   #
##     #    #.#+* # #
 #     ######.##..$ #
 ####### # $..##.####
         # # *..*.#
         #   .#.  #
         ######$# #
              #   #
              #####';
		at: 50 put: '#############################
#.      .   .   .   .      .#
# ##  # #   # # #   # #  ## #
# ##  $ # $ # $ # $ # $  ## #
#  ##$$$#$$$#$$$#$$$#$$$##  #
#   $...$...$...$...$...$   #
#  $$.#.$.#.$.#.$.#.$.#.$$  #
#   $...$...$...$...$...$   #
#.###$$$#$$$#$@$#$$$#$$$###.#
#   $...$...$...$...$...$   #
#  $$.#.$.#.$.#.$.#.$.#.$$  #
#   $...$...$...$...$...$   #
#  ##$$$#$$$#$$$#$$$#$$$##  #
# ##  $ # $ # $ # $ # $  ## #
# ##  # #   # # #   # #  ## #
#.      .   .   .   .      .#
############################# ';
		yourself! !

!SokobanWorld class methodsFor: 'mazes' stamp: 'rhi 10/26/2005 01:16'!
mazesMicroban
	"http://users.bentonrea.com/~sasquatch/sokoban/microban.html
	David W. Skinner <sasquatch@bentonrea.com>"

	^ self mazesMicroban1, self mazesMicroban2! !

!SokobanWorld class methodsFor: 'mazes' stamp: 'rhi 12/21/2003 22:27'!
mazesMicroban1
	"http://users.bentonrea.com/~sasquatch/sokoban/microban.html
	David W. Skinner <sasquatch@bentonrea.com>"

	self flag: #rhi. "Player missing in #40!!"
	^ IdentityDictionary new
		at: 1 put: '####
# .#
#  ###
#*@  #
#  $ #
#  ###
####';
		at: 2 put: '######
#    #
# #@ #
# $* #
# .* #
#    #
######';
		at: 3 put: '  ####
###  ####
#     $ #
# #  #$ #
# . .#@ #
#########';
		at: 4 put: '########
#      #
# .**$@#
#      #
#####  #
    ####';
		at: 5 put: ' #######
 #     #
 # .$. #
## $@$ #
#  .$. #
#      #
########';
		at: 6 put: '###### #####
#    ###   #
# $$     #@#
# $ #...   #
#   ########
#####';
		at: 7 put: '#######
#     #
# .$. #
# $.$ #
# .$. #
# $.$ #
#  @  #
#######';
		at: 8 put: '  ######
  # ..@#
  # $$ #
  ## ###
   # #
   # #
#### #
#    ##
# #   #
#   # #
###   #
  #####';
		at: 9 put: '#####
#.  ##
#@$$ #
##   #
 ##  #
  ##.#
   ###';
		at: 10 put: '      #####
      #.  #
      #.# #
#######.# #
# @ $ $ $ #
# # # # ###
#       #
#########';
		at: 11 put: '  ######
  #    #
  # ##@##
### # $ #
# ..# $ #
#       #
#  ######
####';
		at: 12 put: '#####
#   ##
# $  #
## $ ####
 ###@.  #
  #  .# #
  #     #
  #######';
		at: 13 put: '####
#. ##
#.@ #
#. $#
##$ ###
 # $  #
 #    #
 #  ###
 ####';
		at: 14 put: '#######
#     #
# # # #
#. $*@#
#   ###
#####';
		at: 15 put: '     ###
######@##
#    .* #
#   #   #
#####$# #
    #   #
    #####';
		at: 16 put: ' ####
 #  ####
 #     ##
## ##   #
#. .# @$##
#   # $$ #
#  .#    #
##########';
		at: 17 put: '#####
# @ #
#...#
#$$$##
#    #
#    #
######';
		at: 18 put: '#######
#     #
#. .  #
# ## ##
#  $ #
###$ #
  #@ #
  #  #
  ####';
		at: 19 put: '########
#   .. #
#  @$$ #
##### ##
   #  #
   #  #
   #  #
   ####';
		at: 20 put: '#######
#     ###
#  @$$..#
#### ## #
  #     #
  #  ####
  #  #
  ####';
		at: 21 put: '####
#  ####
# . . #
# $$#@#
##    #
 ######';
		at: 22 put: '#####
#   ###
#. .  #
#   # #
## #  #
 #@$$ #
 #    #
 #  ###
 ####';
		at: 23 put: '#######
#  *  #
#     #
## # ##
 #$@.#
 #   #
 #####';
		at: 24 put: '# #####
  #   #
###$$@#
#   ###
#     #
# . . #
#######';
		at: 25 put: ' ####
 #  ###
 # $$ #
##... #
#  @$ #
#   ###
#####';
		at: 26 put: ' #####
 # @ #
 #   #
###$ #
# ...#
# $$ #
###  #
  ####';
		at: 27 put: '######
#   .#
# ## ##
#  $$@#
# #   #
#.  ###
#####';
		at: 28 put: '#####
#   #
# @ #
# $$###
##. . #
 #    #
 ######';
		at: 29 put: '     #####
     #   ##
     #    #
 ######   #
##     #. #
# $ $ @  ##
# ######.#
#        #
##########';
		at: 30 put: '####
#  ###
# $$ #
#... #
# @$ #
#   ##
#####';
		at: 31 put: '  ####
 ##  #
##@$.##
# $$  #
# . . #
###   #
  #####';
		at: 32 put: ' ####
##  ###
#     #
#.**$@#
#   ###
##  #
 ####';
		at: 33 put: '#######
#. #  #
#  $  #
#. $#@#
#  $  #
#. #  #
#######';
		at: 34 put: '  ####
###  ####
#       #
#@$***. #
#       #
#########';
		at: 35 put: '  ####
 ##  #
 #. $#
 #.$ #
 #.$ #
 #.$ #
 #. $##
 #   @#
 ##   #
  #####';
		at: 36 put: '####
#  ############
# $ $ $ $ $ @ #
# .....       #
###############';
		at: 37 put: '      ###
##### #.#
#   ###.#
#   $ #.#
# $  $  #
#####@# #
    #   #
    #####';
		at: 38 put: '##########
#        #
# ##.### #
# # $$ . #
# . @$## #
#####    #
    ######';
		at: 39 put: '#####
#   ####
# # # .#
#    $ ###
### #$.  #
#   #@   #
# # ######
#   #
#####';
		at: 40 put: ' #####
 #   #
##   ##
# $$$ #
# .+. #
#######';
		at: 41 put: '#######
#     #
#@$$$ ##
#  #...#
##    ##
 ######';
		at: 42 put: '   ####
   #  #
   #@ #
####$.#
#   $.#
# # $.#
#    ##
######';
		at: 43 put: '     ####
     # @#
     #  #
###### .#
#   $  .#
#  $$# .#
#    ####
###  #
  ####';
		at: 44 put: '#####
#@$.#
#####';
		at: 45 put: '######
#... #
#  $ #
# #$##
#  $ #
#  @ #
######';
		at: 46 put: ' ######
##    #
#  ## #
# # $ #
#  * .#
## #@##
 #   #
 #####';
		at: 47 put: '  #######
###     #
# $ $   #
# ### #####
# @ . .   #
#   ###   #
##### #####';
		at: 48 put: '######
#  @ #
#  # ##
# .#  ##
# .$$$ #
# .#   #
####   #
   #####';
		at: 49 put: '######
# @  #
# $# #
# $  #
# $ ##
### ####
 #  #  #
 #...  #
 #     #
 #######';
		at: 50 put: '  ####
###  #####
#  $  @..#
# $    # #
### #### #
  #      #
  ########';
		at: 51 put: '####
#  ###
#    ###
#  $*@ #
### .# #
  #    #
  ######';
		at: 52 put: '  ####
### @#
#  $ #
#  *.#
#  *.#
#  $ #
###  #
  ####';
		at: 53 put: ' #####
##. .##
# * * #
#  #  #
# $ $ #
## @ ##
 #####';
		at: 54 put: '      ######
      #    #
  ##### .  #
###  ###.  #
# $  $  . ##
# @$$ # . #
##    #####
 ######';
		at: 55 put: '########
# @ #  #
#      #
#####$ #
    #  ###
 ## #$ ..#
 ## #  ###
    ####';
		at: 56 put: '#####
#   ###
#  $  #
##* . #
 #   @#
 ######';
		at: 57 put: '  ####
  #  #
  #@ #
  #  #
### ####
#    * #
#  $   #
#####. #
    ####';
		at: 58 put: '####
#  ####
#.*$  #
# .$# #
## @  #
 #   ##
 #####';
		at: 59 put: '############
#          #
# ####### @##
# #         #
# #  $   #  #
# $$ #####  #
###  # # ...#
  #### #    #
       ######';
		at: 60 put: ' #########
 #       #
##@##### #
#  #   # #
#  #   $.#
#  ##$##.#
##$##  #.#
#   $  #.#
#   #  ###
########';
		at: 61 put: '########
#      #
# #### #
# #...@#
# ###$###
# #     #
#  $$ $ #
####   ##
   #.###
   ###';
		at: 62 put: '   ##########
####    ##  #
#  $$$....$@#
#      ###  #
#   #### ####
#####';
		at: 63 put: '#####   ####
#   ##### .#
#       $  ########
###  #### .$    @ #
  #  #  #  ####   #
  ####  ####  #####';
		at: 64 put: ' ######
##    #
#   $ #
#  $$ #
### .#####
  ##.# @ #
   #.  $ #
   #. ####
   ####';
		at: 65 put: '  ######
  #    #
  #  $ #
 ####$ #
## $ $ #
#....# ##
#     @ #
##  #   #
 ########';
		at: 66 put: '   ###
   #@#
 ###$###
##  .  ##
#  # #  #
# #   # #
# #   # #
# #   # #
#  # #  #
## $ $ ##
 ##. .##
  #   #
  #   #
  #####';
		at: 67 put: '#####
#   ##
# #  #
#@$*.##
##  . #
 # $# #
 ##   #
  #####';
		at: 68 put: ' ####
 #  ######
##    $  #
# .# $   #
# .#$#####
# .@ #
######';
		at: 69 put: '####  ####
#  ####  #
#  #  #  #
#  #    $##
#  . .#$  #
#@ ## # $ #
#   . #   #
###########';
		at: 70 put: '#####
# @ ####
#      #
# $ $$ #
##$##  #
#   ####
# ..  #
##..  #
 ###  #
   ####';
		at: 71 put: '###########
#     #   ###
# $@$ # .  .#
# ## ### ## #
# #       # #
# #   #   # #
# ######### #
#           #
#############';
		at: 72 put: '  ####
 ##  #####
 #  $  @ #
 #  $#   #
#### #####
#  #   #
#    $ #
# ..#  #
#  .####
#  ##
####';
		at: 73 put: '####
#  #####
# $$ $ #
#      #
## ## ##
#...#@#
# ### ##
#      #
#  #   #
########';
		at: 74 put: ' ####
 #  #######
 #$ @#   .#
## #$$   .#
#  $  ##..#
#   # #####
###   #
  #####';
		at: 75 put: ' #######
## ....##
#   ######
#   $ $ @#
###  $ $ #
  ###    #
    ######';
		at: 76 put: ' #####
##   #
#    #####
#  #.#   #
#@ #.# $ #
#  #.#  ##
#    #  #
##  ##$$#
 ##     #
  #  ####
  ####';
		at: 77 put: '##########
# @ .... #
#   ####$##
## #  $ $ #
 # $      #
 #   ######
 #####';
		at: 78 put: ' #######
##     ##
#  $ $  #
# $ $ $ #
## ### ####
 #@  .....#
 ##     ###
  #######';
		at: 79 put: ' #########
 #    #  #
## $#$#  #
#  .$.@  #
#  .#    #
##########';
		at: 80 put: '####
#  #######
#  . ## .#
# $#    .#
## ## # .#
 #    #  #
 #### #  #
  # @$ ###
  # $$ #
  #    #
  ######';
		yourself! !

!SokobanWorld class methodsFor: 'mazes' stamp: 'rhi 12/21/2003 22:27'!
mazesMicroban2
	"http://users.bentonrea.com/~sasquatch/sokoban/microban.html
	David W. Skinner <sasquatch@bentonrea.com>"

	^ IdentityDictionary new
		at: 81 put: ' #####
 #   #
 # . #
## * #
#  *##
#  @##
## $ #
 #   #
 #####';
		at: 82 put: '#####
#   ###
# .   ##
##*#$  #
# .# $ #
# @## ##
#     #
#######';
		at: 83 put: '######
#    ##
# $ $ ##
## $$  #
 # #   #
 # ## ##
 #  . .#
 # @. .#
 #  ####
 ####';
		at: 84 put: '########
#  ... #
#  ### ##
#  # $  #
## #@$  #
 # # $  #
 # ### #####
 #         #
 #   ###   #
 ##### #####';
		at: 85 put: '       ####
 #######  #
 # $      #
 #   $ $  #
 # ########
## # .  #
#  # #  #
#  @ . ##
## # # #
 #   . #
 #######';
		at: 86 put: '    ####
  ###  ##
 ## $   #
## $  # #
# @#$$  #
# ..  ###
# ..###
#####';
		at: 87 put: '     ####
######  #
#       #
#  ... .#
##$######
# $  #
#   $###
##  $  #
 ## @  #
  ######';
		at: 88 put: '     ####
 # ###  #
 # #    #
 # #  # #
 # #$ #.#
 # #  # # #
 # #$ #.# #
   #  # # #
####$ #.# #
# @     # #
#   #  ## #
########';
		at: 89 put: '##########
#   ##   #
# $  $@# #
#### # $ #
   #.#  ##
 # #.# $#
 # #.   #
 # #.   #
   ######';
		at: 90 put: ' ########
 #  @   #
 # $  $ #
### ## ###
#  $..$  #
#   ..   #
##########';
		at: 91 put: '###########
#    .##  #
# $$@..$$ #
#   ##.   #
###########';
		at: 92 put: '  ####
  #  #    #####
  #  #    #   #
  #  ######.# #
####  $    .  #
#   $$# ###.# #
#   #   # #   #
######### #@ ##
          #  #
          ####';
		at: 93 put: ' #########
##   #   ##
#    #    #
#  $ # $  #
#   *.*   #
####.@.####
#   *.*   #
#  $ # $  #
#    #    #
##   #   ##
 #########';
		at: 94 put: '#########
# @ #   #
# $ $   #
##$### ##
#  ...  #
#   #   #
######  #
     ####';
		at: 95 put: '########
#@     #
# .$$. #
# $..$ #
# $..$ #
# .$$. #
#      #
########';
		at: 96 put: '  ######
  #    #
  #    #
#####  #
#   #.#####
#   $@$   #
#####.#   #
   ## ## ##
   #   $.#
   #   ###
   #####';
		at: 97 put: '   ####
   #  ########
#### $ $.....#
#   $   ######
#@### ###
#  $  #
# $ # #
## #  #
 #    #
 ######';
		at: 98 put: '#####
#   ## ####
#  $ ### .#
# $   $  .#
## $#####.# ####
# $  # # .###  #
#    # # .#  @ #
###  # #       #
  #### ##     ##
        #######';
		at: 99 put: '               #####
               #   #
#######  ####### # #
#     #  #  #      #
#  @  ####  #     ####
#  #    ....## ####  #
#    ##### ## $$ $ $ #
######   #           #
         #  ##########
         ####';
		at: 100 put: '#######
# @#  #
#.$   #
#. # $##
#.$#   #
#. # $ #
#  #   #
########';
		at: 101 put: '  #####
  #   #
  # # #######
  #  *  #   #
  ## ##   # #
  #     #*  #
### # # # ###
#  *#$+   #
# #   ## ##
#   #  *  #
####### # #
      #   #
      #####';
		at: 102 put: '###########
#....#    #
#  #   $$ #
#  @  ##  #
#     ##$ #
######  $ #
     #    #
     ######';
		at: 103 put: '  #####
  # . ##
### $  #
# . $#@#
# #$ . #
#  $ ###
## . #
 #####';
		at: 104 put: '    #####
#####   #
#    $  #
#  $#$#@#
### #   #
  # ... #
  ###  ##
    #  #
    ####';
		at: 105 put: ' #### ####
##  ###  ##
#   # #   #
#  *. .*  #
###$   $###
 #   @   #
###$   $###
#  *. .*  #
#   # #   #
##  ###  ##
 #### ####';
		at: 106 put: ' ########
 #      #
 #@   $ #
## ###$ #
# .....###
# $ $ $  #
###### # #
     #   #
     #####';
		at: 107 put: '########
#      #
# $*** #
# *  * #
# *  * #
# ***. #
#     @#
########';
		at: 108 put: '####     #####
#  ###   #   ##
#    #   #$ $ #
#..# ##### #  #
#  @    # $ $ #
#..#         ##
##   #########
 #####';
		at: 109 put: '  #######
# #     #
# # # # #
  # @ $ #
### ### #
#   ### #
# $  ##.#
## $  #.#
 ## $  .#
# ## $#.#
## ## #.#
### #   #
### #####';
		at: 110 put: '  ####
  #  #
  # $####
###. .  #
# $ # $ #
#  . .###
####$ #
   # @#
   ####';
		at: 111 put: '######
#    ####
#    ...#
#    ...#
######  #
  #  #  #
  # $$ ##
  # @$  #
  # $$  #
  ## $# #
   #    #
   ######';
		at: 112 put: ' #####
##   ####
#  $$$  #
# #   $ #
#   $## ##
###  #.  #
  #  #   #
 ##### ###
 #   # ##
 # @....#
 #      #
 #   #  #
 ########';
		at: 113 put: '   #####
  ##   #
###  # #
#    . #
#  ## #####
#  . . #  ##
#  # @ $   ###
#####. #  $  #
    ####  $  #
       ## $ ##
        #  ##
        #  #
        ####';
		at: 114 put: '######
#    ###
#  # $ #
#  $ @ #
## ## #####
#  #......#
# $ $ $ $ #
##   ######
 #####';
		at: 115 put: '    #####
#####   ####
#     #    #
#  #.....  #
##  ## # ###
 #$$@$$$ #
 #     ###
 #######';
		at: 116 put: '     #####
   ###   #
####.....#
# @$$$$$ #
#     # ##
#####   #
    #####';
		at: 117 put: ' #### ####
 #  ###  ##
 #      @ #
##..###   #
#      #  #
#...#$  # #
# ## $$ $ #
#  $    ###
####  ###
   ####';
		at: 118 put: ' #####
##   ##
#  $  ##
# $ $  ##
###$# . ##
  # # .  #
 ## ##.  #
 # @  . ##
 #   #  #
 ########';
		at: 119 put: '  ######
  #    ##
 ## ##  #
 # $$ # #
 # @$ # #
 #    # #
#### #  #
#  ... ##
#     ##
#######';
		at: 120 put: '      ####
#######  #
# $      ##
# $#####  #
#  @#  #  #
## ##..   #
#  # ..####
# $  ###
# $###
#  #
####';
		at: 121 put: ' ######
 # .  #
##$.# #
#  *  #
# ..###
##$ # #####
## ## #   #
#  #### # #
#   @ $ $ #
##  #     #
 ##########';
		at: 122 put: '#####
#   ###
# #$  #
# $   #
# $ $ #
# $#  #
#  @###
## ########
#      ...#
#         #
########..#
       ####';
		at: 123 put: '########
#      #
# $ $$ ########
##### @##. .  #
    #$  # .   #
    #   #. . ##
    #$# ## # #
    #        #
    #  ###  ##
    #  # ####
    ####';
		at: 124 put: '##############
#      #     #
# $@$$ # . ..#
## ## ### ## #
 # #       # #
 # #   #   # #
 # ######### #
 #           #
 #############';
		at: 125 put: '      #####
      #   ##
      # $  #
######## #@##
# .  # $ $  #
#        $# #
#...#####   #
#####   #####';
		at: 126 put: ' ###########
##.......  #
# $$$$$$$@ #
#   # # # ##
# # #     #
#   #######
#####';
		at: 127 put: '## ####
####  ####
 # $ $.  #
## #  .$ #
#   ##.###
#  $  . #
# @ #   #
#  ######
####';
		at: 128 put: '  #########
###   #   #
# * $ . . #
#   $ ## ##
####*#   #
 #  @  ###
 #   ###
 #####';
		at: 129 put: '  #########
### @ #   #
# * $ *.. #
#   $ #   #
####*#  ###
 #     ##
 #   ###
 #####';
		at: 130 put: '#####  #####
#   ####.. #
# $$$      #
#   $#  .. #
### @#  ## #
  #  ##    #
  ##########';
		at: 131 put: '#####
#   #
# . #
#.@.###
##.#  #
#  $  #
# $   #
##$$  #
 #  ###
 #  #
 ####';
		at: 132 put: '####
# @###
#.*  #####
#..#$$ $ #
##       #
 # # ##  #
 #   #####
 #####';
		at: 133 put: ' #######
 #  . .###
 # . . . #
### #### #
#  @$  $ #
#  $$  $ #
####   ###
   #####';
		at: 134 put: '        ####
#########  #
#   ## $   #
#  $   ##  #
### #. .# ##
  # #. .#$##
  # #   #  #
  # @ $    #
  #  #######
  ####';
		at: 135 put: '#######
#     #####
# $$#@##..#
# #       #
#  $ # #  #
#### $  ..#
   ########';
		at: 136 put: ' #######
 #     #
## ###$##
#.$   @ #
# .. #$ #
#.##  $ #
#    ####
######';
		at: 137 put: '       ####
      ##  ###
####  #  $  #
#  #### $ $ #
#   ..# #$  #
#  #   @  ###
## #..# ###
 # ## # #
 #      #
 ########';
		at: 138 put: '  ####
###  #
#    ###
# # . .#
# @ ...####
# # # #   ##
#   # $$   #
#####  $ $ #
    ##$ # ##
     #    #
     ######';
		at: 139 put: ' ####
##  ####
#   ...#
#   ...#
#   # ##
#   #@ #### ####
##### $   ###  #
    #  ##$ $   #
   ###     $$  #
   # $  ##   ###
   #    ######
   ######';
		at: 140 put: '######## #####
#  #   ###   #
#      ## $  #
#.# @ ## $  ##
#.#   # $  ##
#.#    $  ##
#. ## #####
##    #
 ######';
		at: 141 put: '  ########
  #  # . #
  #   .*.#
  #  # * #
####$##.##
#      $ #
# $ ## $ #
#   @#   #
##########';
		at: 142 put: '  ####
  #  #
  #  ####
###$.$  #
#  .@.  #
#  $.$###
####  #
   #  #
   ####';
		at: 143 put: '####
#  ####
# $   #
# .#  #
# $# ##
# .  #
#### #
   # #
 ### ###
 #  $  #
## #$# ##
# $ @ $ #
# ..#.. #
###   ###
  #####';
		at: 144 put: '   ####
 ###  #####
 # $$ #   #
 # $ . .$$##
 # .. #. $ #
### #** .  #
#  . **# ###
# $ .# .. #
##$$.@. $ #
 #   # $$ #
 #####  ###
     ####';
		at: 145 put: '   #####
   # @ #
  ##   ##
###.$$$.###
#  $...$  #
#  $.#.$  #
#  $...$  #
###.$$$.###
  ##   ##
   #   #
   #####';
		at: 146 put: ' #######
##  .  ##
# .$$$. #
# $. .$ #
#.$ @ $.#
# $. .$ #
# .$$$. #
##  .  ##
 #######';
		at: 147 put: '       #####
########   #
#.   .  @#.#
#  ###     #
## $  #    #
 # $   #####
 # $#  #
 ## #  #
  #   ##
  #####';
		at: 148 put: '###########
#  .  #   #
# #.  @   #
#  #..# #######
##  ## $$ $ $ #
 ##           #
  #############';
		at: 149 put: ' ####
##  ###
#@$   #
### $ #
 #  ######
 #  $....#
 #  # ####
 ## # #
 # $# #
 #    #
 #  ###
 ####';
		at: 150 put: '     ####
 #####  #
 #     $#######
## ## ..#  ...#
# $ $$#$  @   #
#        ###  #
#######  # ####
      ####';
		at: 151 put: '   ####
   #  #
 ###  #
##  $ #
#   # #
# #$$ ######
# #   #   .#
#  $  @   .#
###  ####..#
  ####  ####';
		at: 152 put: '###### ####
#     #    #
#.##  #$##  #
#   #     #  #
#$  # ###  #  #
# #      #  # #
# # ####  # # #
#. @    $ * . #
###############';
		at: 153 put: '#############
#.# @#  #   #
#.#$$   # $ #
#.#  # $#   #
#.# $#  # $##
#.#  # $#  #
#.# $#  # $#
#..  # $   #
#..  #  #  #
############';
		at: 154 put: ' ############################
 #                          #
 # ######################## #
 # #                      # #
 # # #################### # #
 # # #                  # # #
 # # # ################ # # #
 # # # #              # # # #
 # # # # ############ # # # #
 # # # # #            # # # #
 # # # # # ############ # # #
 # # # # #              # # #
 # # # # ################ # #
 # # # #                  # #
##$# # #################### #
#. @ #                      #
#############################';
		at: 155 put: '    ######               ####
#####*#  #################  ##
#   ###                      #
#        ########  ####  ##  #
### ####     #  ####  ####  ##
#*# # .# # # #     #     #   #
#*# #  #     # ##  # ##  ##  #
###    ### ###  # ##  # ##  ##
 #   # #*#      #     # #    #
 #   # ###  #####  #### #    #
 #####   #####  ####### ######
 #   # # #**#               #
## # #   #**#  #######  ##  #
#    #########  #    ##### ###
# #             # $        #*#
#   #########  ### @#####  #*#
#####       #### ####   ###### ';
		yourself! !

!SokobanWorld class methodsFor: 'mazes' stamp: 'rhi 12/21/2003 22:27'!
mazesSasquatch
	"http://users.bentonrea.com/~sasquatch/sokoban/sasquatch.html
	David W. Skinner <sasquatch@bentonrea.com>"

	^ IdentityDictionary new
		at: 1 put: '   ###
  ## # ####
 ##  ###  #
## $      #
#   @$ #  #
### $###  #
  #  #..  #
 ## ##.# ##
 #      ##
 #     ##
 #######';
		at: 2 put: ' ## #####
## ## . #
# ## $. #
 ## $   #
## $@ ###
# $  ##
#.. ## ##
#   # ##
##### #';
		at: 3 put: '           #####
          ##   #
          #    #
    ####  # $ ##
    #  ####$ $#
    #     $ $ #
   ## ## $ $ $#
   #  .#  $ $ #
   #  .#      #
##### #########
#.... @  #
#....    #
##  ######
 ####';
		at: 4 put: '  ###########
 ##     #  @#
### $ $$#   #
# ##$    $$ #
#  #  $ #   #
###### ######
#.. ..$ #*##
# ..    ###
#  ..#####
#########';
		at: 5 put: '  ###########
 ##    #    ##
### $ $#$ $ ###
# #$ $ # $ $# #
# $  ..#..  $ #
#  $...#...$  #
# $ .. * .. $ #
###### @ ######
# $ ..   .. $ #
#  $...#...$  #
# $  ..#..  $ #
# #$ $ # $ $# #
### $ $#$ $ ###
 ##    #    ##
  ###########';
		at: 6 put: '  ###########
###.  .$.  .###
 ## $  $  $ ##
  ## ..$.. ##
   ##$#$#$##
    #.$ $.#
    #  @  #
    ### ###
   ## $ $ ##
   #.  $  .#
   ### . ###
     #####';
		at: 7 put: '           ######
    ####  ##    #
  ###  #  #  ## ###
###    #### #   $ #
#  $ @ ...*..  $  #
# $ $  ## ###   ###
### ###   # #####
 #      ###
 #   ####
 #####';
		at: 8 put: '    #######
    #     ##
##### ###  ##
#       #  ##
#@$***. ##$ #
#  #    ## .#
##  ##  # $ #
 ##  ####.$.#
  ##        #
   ######  ##
        ####';
		at: 9 put: '#########
#. .    #
#.$. .  #
## ###@ #
 #  $  ##
 # $$ ##
 #  $ #
 #  ###
 ####';
		at: 10 put: '      ######
      #    #
      # @  ###
####  #      #
#  ####..#.#$#####
# $ $ ##...      #
#     .....#$$   #
###### ##$## #####
     #  $    #
     #### ####
       #  #
       #  #####
     ### $    #
     #  $ $   #
     # #$# ####
     #     #
     #######';
		at: 11 put: '  ####
###  ####
#   @   ##
# #. .#.###
# $$$ $$$ #
###.#.#.# #
 ##       #
  ####  ###
     ####';
		at: 12 put: '              #####
              #   #
    #####     #   #######
    #   ##### #   ..... #
##### # ##  # #     # # #
# $ $ $ $ $ # ##   ## $ #
# # ##......#### ### $$ ###
#      ## * #    # #  $$  #
##########+$$   ## #      #
         #.$ $# #  ########
         #.##   #
         ########';
		at: 13 put: '   #######
 ###     ##
 #   ###  #
 #      # #
###$#@  # #
#   ##### #
#   #  *. #
##$$#  *.##
 #     *..#
 #### #...##
    # #$$$ #
    #   $  #
    #####  #
        ####';
		at: 14 put: ' #######
##     # #
#  *.$.#
#  *.#.###
# #$@$$  #
#   ## # #
######   #
     #####';
		at: 15 put: '   ####
   #@ #
  ##  ##
  # .$#####
  #$. #   #
###..$# # #
#  ..$  $ #
# $ $ # ###
##### # #
    #   #
    ###.#
      ###';
		at: 16 put: '  ######
 ## #  ###
## #   # ##
# #   $.# #
##  $ $.# #
# #####. ##
#     $. @#
#     $. ####
### # #*# # ###
  #### .$     #
    #  .$     #
    ## .##### #
    # #.$ $  ##
    # #.$   # #
    ## #   # ##
     ###  # ##
       ######';
		at: 17 put: '    ###########
   ## . . . . ###
   #  $$ $ $ $  #
   #   ######## # #####
 #### ##  $     # #   #
 #    #  $ $ #  ### # #
##  # #   ####     $  #
#...  ##### $  #### ###
#... @     $     #    #
#...############ $  $ #
#####          #####  #
                   ####';
		at: 18 put: '    ####
#####  #
#      #
#$ $ $ #
#.*.*.*#
#*.*.*.#
# $ $ $#
#......#
#.*.*.*#
#$ $ $ #
# $ $ $#
#$ $ $ #
#      #
#@ #####
####';
		at: 19 put: '#####
#   #######
#  $      ##
## ######  ##
 # #    # # ########
 # # ##    $       ##
 # #.   #@###### $  ##
 # #.#  ###    ## $  ##
 # #.    #      ## $  ##
 # #.#   #  ##   ## $  ##
## #.#  ##  ###   ## $  #
#  #.#   #  #*##   ##   #
#   .# # #  ##*##   #####
######   #  ######
     #####';
		at: 20 put: '     ####
     #  #
######$.#
#   $ $.#
# $@$...#
# $$$..##
#  $ ..#
########';
		at: 21 put: '##### ########
#   ### . $  #
#   $ *.. #$ ##
## $# ..* $  @#
 #  $ . ###   #
 ######## #####';
		at: 22 put: '   ##### ####
   #@ .###  ###
####  $$ $    #
#   # . . ##  #
#  $ # . . ## #
## .  $ $$  # #
 # #  ###.  # #
 # #### ##### #
 #       #    #
 ####### # ####
       # .$ #
     ####   #
     ## #####
      ###';
		at: 23 put: '     #######
######     ######
#  . ..$#$.. .  #
#  $ $  .  $ $  #
###$####@####$###
#  $ $  .  $ $  #
#  . ..$#$.. .  #
######     ######
     #######';
		at: 24 put: '        ######
        #   ##
  ####### $  #
  # $ $ $ #$ #
  #   #. $   #
 ####.#.# $###
 #   ..... #
 #  $ ..##$#
### ## ..  #
#  $.#$ # $#
#   $   #  #
##@  #  ####
 ##  ####
  ####';
		at: 25 put: '         #####
     #####  #####
     #  .#$   $ #
     # #. $$$ @ ##
     #  .#$   $  #
     ###.#  $ $  #
       #.  ##$ ###
 #######*###.$ #
 # $    ....####
## #$#$$....#
#  $ $   #..#
#     $  #..#
#  ##########
#####';
		at: 26 put: '           ####
 ###########  #
 #  $ $ $ $   ##
 #  # # # # #$##
 ##. . . . . .#
  #$# # # # #$####
###. . . . . .   #
###$# # # # # @  #
  #   $ $ $ $  ###
  #  ###########
  ####';
		at: 27 put: '      ########
 ######      ##########
## $     ###          ##
# $ $ ## #  #########  #
#  $  #              # #
# $ $ # #  ######### # #
#  $  #  # #. . . .  # #
# $ $ # #    . . . .## #
#  $  # # # . . . . #  #
##$ $## #  #### # #   ##
 #   #@ #       #  ####
 ######  #####  #  #
      ##     #  #  #
       #####  ##  ##
           ##    ##
            ######';
		at: 28 put: '       ######
       #    ###
   ##### $ $  #
####   #.#    ##
#  $ #$#.##$#####
# $$. .#.$      ##
#  $.#.#.#####  ####
##  ....... @#     #
 ####$ #.### #$###$##
  ## $  .  #  $ $ $ #
   # $ ###          #
   #   # ############
   #####';
		at: 29 put: '####
#  #              ####
#  ######## #######  #
#         ###  ##  $ #
##.###### ...     #. #
 #.#      # .#   # $ #
 #$$$$#$$$ #.#   ##. #
 #.# $   $ #..      ##
 #.#  $  $   # #   ##
 #  #   $$ #   #####
 #.  ##$  ######
 #.   #  $.  #
##. @ ###.#$ #
#     # #    #
#    ## ######
######';
		at: 30 put: '     #####
     #   #
     #   #        ######
   ###  ## #####  #    ###
   #    #        ## #$$  #
  ##$   ########## $  $  #
###  ## ..........$  #$$@#
#    # $$# ####### $     #
#   $  #...#     ###  ####
#   #   $ ### ##   ####
########    #
       #    #
       #    #
       ######';
		at: 31 put: '   #####
   #   #####
   # $$#   ######
 ###.  . $ #    #
 #  .##.####### #
 # $.  . #    # #
##.##$$$$#$$$ ######
 #...    .    #    #
 #..##.####.### ##@#
 ## # $ $ $ # $ $  #
  # #       #     ###
  # #.##.#.######  #
  #  $ # $.     $  #
  #    ###.## ###$##
  ###### #        #
         ##########';
		at: 32 put: '                   #####
                   #   #
           ######### $ #
    ###### #   #   #   #
    #    # # $     $ #@#
  ### ## #### ### ## ###
  #   $  $     #   #   #
  #  $  $ # #$ # $$ $$ #
 ######  $  #  #   #   #
##    ## ###############
#  .#   $ #    #
#..    #  ######
#...####  #
#....# ####
#....#
######';
		at: 33 put: '   #######
  ##     ##
  #  ###  #
  # ## $  ####
  # # .#   $.####
  # # * *###.$  #
  # # *#   ### #####
  # # @ * *  # #   #
  # #  ### #*#  *  #
  # ## #  * *.# # #######
  # #  #     ....$  $   #
  # # ## $# $####$      #
###*   *     #    #######
#   ########## ####
#              #
##  ############
 ####';
		at: 34 put: '            #####
            # ..########
            # ......#  #
            #.. ##$$  $#
         #####.##   $  #
         #  ....# $  $$#
##### ## #  .. .#$  $  #
#   #    # ##.###  $$ $###
#   ###  # ## #  $  #    #
# @   #### #  # # ###$ # #
#             #  $    $  #
#   ####      ### ####$$##
#  ##  ####     #       #
#  #      ##    ######  #
####       ##     # # $ #
            ##    # #   #
             ###### #####';
		at: 35 put: ' #####
 #   #
## # #####
#    ##  #######
# #     $      ####
#   #### $  $$ #  #
#####  # $$$ $ #$ #
       # $  $ $ $ ######
     ###$   #$ $  $    #
     # $ $$      ### @ ##
     #  $ $$$$####...   #
     #  $     $ #. .#...#
     ### $$$$   ......  #
       #      ##..#.....#
       ###### ##.....####
            #   .....#   #
            ##########';
		at: 36 put: '                #####
    ####        #   ######
    #  #        # $    $ #
    #  ####     #  $##$  ###
    #     #########  # $ $ #
    #      ..........#   $ #
  ###### ##....@###  # $$  #
  #    # #####.## # ##   $ #
  #            #  #$  $$ $ #
 #### #  ##### #  #  $  #  #
 #    # #      #  ###   ####
 #      #  #   #    #####
 #   #     #####
 #####     #
     #######';
		at: 37 put: '  #####       #########
  #   #       #       #
### #$### ##### # # # #####
# $. .  # #    . . . .    #
# # # #$### # # # # # # #$#
#  . . . .  $ $ $ $  . .  #
###$# # #$###########$# #$#
  #  . .  ##        #  .  #
  ###$# #$####### # #$# #$###
    #  . .$ $ $ #   #  . .  #
    #$# # # # # #####$# # # #
    #  . . . . .  $  . . .  #
    ### # # # # # # # # # # #
      # $ $. . .$ $ $ $ $ $ #
      ##### # # #############
          #  @  #
          #######';
		at: 38 put: '                      ####
  ####         ########  #
###@ ##        #      #  #
#     #        # ### $ $ #
# ....##########   #  #..#
# . #  ## $   $ $# #  #..#
### #     $  $$$ # # $ $ #
  # ...# $  $$   # #  #  #
  #  ..# $   $ $ # # ##  #
  ##...#  $ $$ $ #$# #####
   #   ## $  $ $   # #
   ### ######  ### # ###
   # .   ## #### .   . #
  ##   . #     # #.#.# #
  #  .   # # # #   #   #
  # . ####     #########
  #  ##
  ####';
		at: 39 put: '   ####           #####
   #  #######  ####   #
   # @  $   ####   $  #
   #  ###.#    #  $$  #
 ###.## $ #$ #    #  ##
 #  ..# $ ...# ###  ##
 # $ ...$##.##     ##
 ##.###$ $..   $$ ##
  #.  #. .### $ $ #
  #  $...## ## #  #
 ## ######   #   ##
##   ##      #####
# $$  #
#   $ #
### $ #
  #  ##
  ####';
		at: 40 put: '     #######
#### #     #
#  ### $$$ #
#  ....$  #####
#  ..# $  #  @#
###$##$#### # ######
 #.*....$  $  ###  #####
 # ..#####  ##   $ $   #
 #....*.... #  $$  # $ #
 ########## #$$ ## #   #
    # $.###        $  ##
    #       $###$# #  #
    #####   $    $ ####
        ####    ####
           ######';
		at: 41 put: '   #####
   #   #
 ###   ########
##  ***    # # #
 #  * *    ## # #####
##  ***   ## # ##   ##
 ###   #### # # #   #
   #   # # # ####$ $###
  ##   ## # ##  $...$ ##
   ##### # ##    .@.  #
        # # #   $...$ ##
         ########$ $###
                #   #
                #####';
		at: 42 put: '####
#  ######
#       ####
# $ $   #  #####
##### ###    $ #
 #  #   $  #   #
 #      ##$######
 # $###  # ...# #
 ## #@#$ ##.#.# #
 #    #   #...# #
 # $ ##$ $#...#####
 ### ##   #...    #
  #  #  $ $ $ # # #
  # $### ###### # #
  #             # #
  #############   #
              #####';
		at: 43 put: '   ####
  ##  #############
 ##    .......... #
##    #  ####$### ##
#      # #      #  ##
#     #  # $$$  # # #####
#####  # . .# ### . . . ##
    #   $. .#  # $$ $ $ @#
   ####### ### #   #######
   # $   $   # ## ###
   #    $  $ #  # ## # ####
   # $### ####  # # # ##  ####
   #  $ $$$  # ## #  ##      #
   ##        # ## #### $$$   #
    ## ####### .....     #####
    #  $         ######  #
    #   ######  ##    ####
    #####    ####';
		at: 44 put: ' #############
##       #   ###
#  $ $$$$$     #
### $   $  ### #
  # $ $ $### # #
  ##   $ ##  # ###
   ####   ####   #
     ###       # ###
   ####   ####     #
   #@ $   ###  #.# #####
   # $ $ ## #  ....    #
   # $$ ##  ####.....  #
  ## $  #     #..#.##  #
  # $ $ ##    #......  #
  #  $ $ #    # . ..# ##
  ##  $  #    ## ##.# #
   #    ##     #      #
   ######      ########';
		at: 45 put: '  ####      ########
  #  ##### ##   #  #
  #    $ ### $  $  #
  #  $ # ##    $   ####
  ###  #    # ###$##  #
#####  ###  ####   $  #
#   # $  $$## .. ##$  #
#  $$   # $          ##
##  # $##  #### # ####
### #  ##$ ###..#..#
#   ###..  #  .....###
#   #  *.### #  #..  #
##$$#  *.##@ #  #    #
 #     *. ####  ###  #
 ######   #  #       #
      #####  ##    ###
              #  ###
              ####';
		at: 46 put: '      #### ###################
  #####  ###            .$   #
###  $.       #####$####   # #
#    $.  #### #     .   ### .#
#  $ $.### ## # #### #  $.# $#
###  $.## # # # #  #  # $ #  #
  ###### # ## #$ $ ##   #. # #
        ##### #.#.  #  ### # #
 #####  #   # ### ###   #    #
 ##*##  #     .#  #   #$$*  ##
 #*### ### ## ## ## #  .#. ##
 ###*# #  .$ .# $.$.## ### #
 ##*## # #.####     # $.   ##
 #*### # $$   ### ###   ##  ##
 ###*# # #   . $@$  #######. #
 ##### # ### ####.#        $ #
       #     #  ###########  #
       #######            ####';
		at: 47 put: '#########
#       #    ######
#   $   ######    ###
# #$#$ $ $  # $     #
# $   $@$  $ $ $ $$ #
# $ $# $ #     $$$  #
#  $ $ #######   #####
##    ###....##### ..#
 ###$$# $$$$ #...* ..#
  #         ##   #.. #
  #  #  #$###....##*##
  #   ##..$. ....    #
  ### .*   .#....#   #
    ##################';
		at: 48 put: '   #### ####
  ##  # #  #  #######
###   ###$ ## #     ###
#  $      $ ###       #
# $ $ ###$   #  #     #
### ### #    #   #    #
#  $ #  ## ###    # ###
#    $   # #@        ##
# $# # ### ###   #   #
#  $ # # $ $ #  #  # #
##   #    $  # #.    #
 ##  # #   ## #..  ###
  ## # #  ## #... ##
 ### # #### #....##
 #          $.*.##
 ############..##
            ####';
		at: 49 put: ' #########################
 #  #  #  #  #  #  #  #  #
 # $#$ # $#$ # $#$ # $#$ #
 #  #  #  #  #  #  #  #  #
 ## # ### # ### # ### # ##
 #  #  #  #  #  #  #  #  #
 #     #     #     #     #
## ### # ### # ### # ### ##
#   #  #  #  #  #  #  #   #
#   #     #  @  #     #   #
##  # ### # ### # ### #  ##
 #  .  . . .   . . .  .  #
 #########################';
		at: 50 put: '   # # # # # # # # # # # #
  # # # # # # # # # # # # #
 #   .$    . $.  . $   .$  #
  # $# #$# # # #$# # # #  #
 #  .  .    $.  .  .$ .  . #
  # #$# # # # #$#$ $# #$# #
 # .     .$ .$    . $.  .  #
  # $# # # # #@# # # # #$ #
 #  .  .$ .    $. $.     . #
  # #$# #$ $#$# # # # #$# #
 # .  . $.  .  .$    .  .  #
  #  # # # #$# # # #$# #$ #
 #  $.   $ .  .$ .    $.   #
  # # # # # # # # # # # # #
   # # # # # # # # # # # # ';
		yourself! !

!SokobanWorld class methodsFor: 'mazes' stamp: 'rhi 12/21/2003 22:27'!
mazesSasquatchIII
	"http://users.bentonrea.com/~sasquatch/sokoban/sasquatchiii.html
	David W. Skinner <sasquatch@bentonrea.com>"

	^ IdentityDictionary new
		at: 1 put: ' #######
 #  *  #
 #  @  #
 ##$#.##
 #  #  #
 # $#. #
 #  #  #
## ## ##
#  * * #
#   *  #
###   ##
  #####';
		at: 2 put: '      ####
#######  #
#     * .##
# $$#  *  ##
# $@ #* *  ##
## $ # * *  #
 ### #. * * #
 #   .  #  .#
 #   #  #####
 ########';
		at: 3 put: '        ####
#########  #
#          #
# #*### #  #
#  $   # # #
#*#*##  #  #
#  $  #  # #
#  *#  # # #
#  $ # # # ##
###$. . . . #
  #@####### #
  #         #
  ###########';
		at: 4 put: '   #############
  ##           #
 ##  #########@###
##  #         *  #
#  ## ########*# #
# #  $ $ $ $   # #
# #$.. . . ..$#  #
# # .#######. # ##
#  $.#######.$# #
### . . . . . # #
  # $ $ $ $ $ # #
  ######### ##  #
          # $ $ #
          #     #
          #######';
		at: 5 put: ' ###########
##         #
#  #######$##
# #       $ ###
# #...***.*.@ #
# #       $ # #
#  #######$#  #
##        $  ##
 ########   ##
        #####';
		at: 6 put: '             ####
     #########  ###
     #  . .   . . #
     # $$.$# #$.$ #
     ## . .# #. . #
      # $ $#  $ $ #
      # $  #* #####
     ##### # ##
     #   @   #
    ## # #####
##### *#  $ #
# $ $  #$ $ #
# . .# #. . ##
# $.$# #$.$$ #
# . .   . .  #
###  #########
  ####';
		at: 7 put: '  #####
  #   #####
### #     ##
#  * ####  #
#  * ##  # #
#  *  ** # #
#   #    # #
#@#** * ## #
###  #$  # #
 # .$ .* # #
 #   #  #  #
 ##  #    ##
  #########';
		at: 8 put: '       ####
########@ #
#   ...#$ #
# $ $ $ * #
#####   . #
   ##$#$. #
 ###. # .##
 #  .$#$ #
 #  .$   #
 ###.$#  #
   #  ####
   ####';
		at: 9 put: '        #
 ###########
 #   #  #  #
 # $ #$ $  #
 #$.*.*.#* #
 # .    $. #
 #$.$#.  .$#
## .$   #* ##
#  .#.*##.  #
# $ $   $   #
### # # #####
  ##@   #
   ######';
		at: 10 put: '           #
    #     # #
   # #  ##   ##
  # . # # .$. #
 # $.$ # .$ $. #
#   *  @ $ * $  #
 # $.$ # .$ $. #
  # . # # .$. #
   # #  ##   ##
    #     # #
           #';
		at: 11 put: '       #
      # #
    ##   ##
    #  .  #     #
  ## $.$.$ ##  # #
  # $.$.$.$ # # . #
 #  .$.$.$.  # $.$ #
#  .$.$@$.$.    *   #
 #  .$.$.$.  # $.$ #
  # $.$.$.$ # # . #
  ## $.$.$ ##  # #
    #  .  #     #
    ##   ##
      # #
       #';
		at: 12 put: '########
#  . . #
# $.$. #
##$#$# ##
 # . .  #
 #$#$# @#
 # . .  #
##$#$# ##
#  . . #
# $#$# ###
##   . . #
 ###$#$# #
   # .   #
   #$# ###
   #   #
   #####';
		at: 13 put: '       ####
########  #
#@ $ $ $$ ###
#  ....*.*  #
## ### ..*# #
 #$$  # .*  #
 # # $ #.*# #
 #   $ #..  #
 ##  $    ###
  ### #$#.#
   # $ $  #
   #     ##
   #######';
		at: 14 put: '          #####
  #########   #
### $ $ $ $.  #
#  .$.$ $.$.# #
# #.*..@..*.# #
# #.$.$ $.$.  #
#  .$ $ $ $ ###
#   #########
#####';
		at: 15 put: '           #####
############   #######
#     # # ## # # #   #
# # #$  $  # .$  $ # ##
#  ..*.** *@* **.*..  #
## # $  $. #  $  $# # #
 #   # # # ## # #     #
 #######   ############
       #####';
		at: 16 put: ' #########
##   *   ##
#  # # #  #
# #.$.$.# #
#  $.$.$  #
#*#.$@$.#*#
#  $.$.$  #
# #.$.$.# #
#  # # #  #
##   *   ##
 #########';
		at: 17 put: '         #
    #  #####
  #####    ####
  #   ..$$ #  #
  # $ $ .#@#$ ##
 #### # *##   #
 #   #  *  #$.#
## $##  .    . #
 # $.**.#.**.$ #
 # .    .  ##$ ##
  #.$#  *  #   #
  #   ##* # ####
 ## $# #. $ $ #
  #  # $$..   #
  ####    #####
     #####  #
       #';
		at: 18 put: ' #############
##    #   #  ##
# .##$$  $  . #
#  ...#.#.#.# #
## # $ $   .# #
# $. # # #$.$ #
#  #  $ $  #$##
#  .$# @ #$.  #
##$#  $ $  #  #
# $.$# # # .$ #
# #.   $ $ # ##
# #.#.#.#...  #
# .  $  $$##. #
##  #   #    ##
 #############';
		at: 19 put: ' #############
##     *     ##
#  ##.# ##.#  #
# # $ $ $ $ # #
# .$. ##  .$# #
# #  # . #  . #
# #$  $.$ #$# #
#*  #..@..#  *#
# #$# $.$  $# #
# .  # . #  # #
# #$.  ## .$. #
# # $ $ $ $ # #
#  #.## #.##  #
##     *     ##
 #############';
		at: 20 put: ' ### ### ###
##  # @ #  ##
#  $#$ $#$  #
# . . . . . #
 ##$#$ $#$##
# . . . . . #
#  $ $#$ $  #
# . . . . . #
 ##$#$ $#$##
# . . . . . #
#  $#$ $#$  #
##  #   #  ##
 ### ### ###';
		at: 21 put: '   ###   ###
   #  ###  #
  #    #    #
##  $$$.$$$  ##
#  .# . . #.  #
#  . # $ # .  #
 # .$ #.# $. #
 ##$ .$@$. $##
 # .$ #.# $. #
#  . # $ # .  #
#  .# . . #.  #
##  $$$.$$$  ##
  #    #    #
   #  ###  #
   ###   ###';
		at: 22 put: '   ###########
  #           #
 ##$####.####$##
# $. $ $.$ $ .$ #
# # ...   ... # #
# #$.$ $.$ $.$# #
# # . *#.#* . # #
# #$ $# $ #$ $# #
# .. ..$@$.. .. #
# #$ $# $ #$ $# #
# # . *#.#* . # #
# #$.$ $.$ $.$# #
# # ...   ... # #
# $. $ $.$ $ .$ #
 ##$####.####$##
  #           #
   ###########';
		at: 23 put: ' #### ### ####
#    #   #    #
# #  #   #  # #
#  **$***$**  #
#  * .   . *  #
 ##$.## ##.$##
#  * #   # *  #
#  *   @   *  #
#  * #   # *  #
 ##$.## ##.$##
#  * .   . *  #
#  **$***$**  #
# #  #   #  # #
#    #   #    #
 #### ### ####';
		at: 24 put: ' ###############
 #.  $  .  $  .#
 # ##$# # #$## #
 #  .* .#. *.  #
 # #   *$*   # #
##$$*   #   *$$##
#  #. $. .$ .#  #
#@   #* * *#    #
#  #. $. .$ .#  #
##$$*   #   *$$##
 # #   *$*   # #
 #  .* .#. *.  #
 # ##$# # #$## #
 #.  $  .  $  .#
 ###############';
		at: 25 put: '# ####  #  #### #
 #    #   #    #
# *.   ###   .* #
# $# $ $ $ $ #$ #
#   # .* *. #   #
#  . #  $  # .  #
 #  $ ##$## $  #
  #.* # . # *.#
# #  ..$@$..  # #
  #.* # . # *.#
 #  $ ##$## $  #
#  . #  $  # .  #
#   # .* *. #   #
# $# $ $ $ $ #$ #
# *.   ###   .* #
 #    #   #    #
# ####  #  #### #';
		at: 26 put: ' ###############
##      #      ##
# *$ $*$$$*$ $* #
# $...$...$...$ #
#  .$.$.$.$.$.  #
# $...$...$...$ #
# *$$$*$$$*$$$* #
# $...$...$...$ #
##$.$.$.@.$.$.$##
# $...$...$...$ #
# *$$$*$$$*$$$* #
# $...$...$...$ #
#  .$.$.$.$.$.  #
# $...$...$...$ #
# *$ $*$$$*$ $* #
##      #      ##
 ###############';
		at: 27 put: '  #############
 ## .   .   . ##
## $.$ $.$ $.$ ##
# $ * $ * $ * $ #
#..*.*.*.*.*.*..#
# $ * $ * $ * $ #
#  $.$.$.$.$.$  #
# $ * $ * $ * $ #
#..*.*.*@*.*.*..#
# $ * $ * $ * $ #
#  $.$.$.$.$.$  #
# $ * $ * $ * $ #
#..*.*.*.*.*.*..#
# $ * $ * $ * $ #
## $.$ $.$ $.$ ##
 ## .   .   . ##
  #############';
		at: 28 put: '      #####
   #### . ####
   # ##$.$## #
 ####   .   ####
 # ## $$.$$ ## #
 ##  ## . ##  ##
### $##$.$##$ ###
# $ $ $...$ $ $ #
#.......@.......#
# $ $ $...$ $ $ #
### $##$.$##$ ###
 ##  ## . ##  ##
 # ## $$.$$ ## #
 ####   .   ####
   # ##$.$## #
   #### . ####
      #####';
		at: 29 put: '#################
#  .    .    .  #
# ##$###$###$## #############
#.##  ##  ## ##.#  .     .  #
# $   *   *   $ # ##$###$## #
# ##  #   #   # #.##  ## ##.#
# ##*###*###*## # $   *   $ #
# #   #   #  ## # ##  #   # #
#.$   *   *   $.@ ##*###*## #
# ##  #   #   # # #   #  ## #
# ##*###*###*## # $   *   $ #
# #   #   #  ## #.## ##  ##.#
# $   *   *   $ # ##$###$## #
#.## ##  ##  ##.#  .     .  #
# ##$###$###$## #############
#  .    .    .  #
#################';
		at: 30 put: ' ###############
##             ##
#  ##### #####  # ###########
# # . . . . . # ###         ##
# #$ $ $ $ $ $#     ### ###  #
# # .#.#.#.#. # ## # . . . # #
# #$ $ $ $ $ $# ## #$ $ $ $# #
# # .#.#.#.#. # ## # .#.#. # #
#  $ $ $@$ $ $  ##  $ $ $ $  #
# # .#.#.#.#. # ## # .#.#. # #
# #$ $ $ $ $ $# ## #$ $ $ $# #
# # .#.#.#.#. # ## # . . . # #
# #$ $ $ $ $ $#     ### ###  #
# # . . . . . # ###         ##
#  ##### #####  # ###########
##             ##
 ###############';
		at: 31 put: '   ##### #####
 ###    #  @ ####
##    # $  #    ##
#   #..*.#*...#  #
# # . $# $ $# .  #
#   .#    #  $.#  #
#  #.$  #$   #*   #
 #. * #  $ #  .$# #
# $ #$ $$#$$ $# $ #
# #$.  # $  # * .#
#   *#   $#  $.#  #
#  #.$  #    #.   #
 #  . #$ $ #$ . # #
 #  #...*#.*..#   #
 ##    #  $ #    ##
  ####    #    ###
     ##### #####';
		at: 32 put: '   ######  #####
  ##    ####   #
  #  ##  $   # #
  # # .# $# $  #
  # #$.$  #   #######
  #  $. # ### #     #
  ### .$. . # #.$.$ #
   # $. ###$#$# ## ##
####  #$        #   #
#   # $ ###@###.    #
# $     #  #..  #..##
###### #    ..# .  #
    #   $$ #..## ..#
    #  $ $##     # #
    # $$       #   #
    #  #############
    ####';
		at: 33 put: '         ####
   #######  ####
   #         $ ##
####$  ###.###  ##
#   $ #  #.#  #  #
# # $ #   .  @ # #
# #   #..###   # #
# # $#....  #  # #
# #  #...#$  # # #
# #$ # ## $$ $ # #
# #  # .*    ##  #
# #$$## #  ##   ##
# #     ###   ###
#  ####$    ###
##      #####
 ########';
		at: 34 put: '            ####
    #####   #  #####
   ##   #   #      #
   #  # ##### # #  #
   # # $ $ $ $ #  ##
   # #       #  # #
   #  ######$## # #
####  # *  #  # # #
#   $ # .. $  # # #
# # # #*...# #  # #
# .***#. ..#   ## ##
##*....*.*  $ #    #
 ##* ##.##### # $  #
  ##  #     $  # # #
   ##@ #.#$ $ $ $# #
    ##    $ $  #   #
     ##  ###########
      ####';
		at: 35 put: '              ####
 ####       ###  #
 #  #########  ..#
 #  $ @ $   $ #..#
 # $# $   # # #..#
 #  ##*##$#$#$#..#
 # $ #..#.      ##
 #   #*. .##$## #
##$ $#..#.      #
#    ##$#########
#   $$ $ #
##       #
 #########';
		at: 36 put: '           #####
          ## . ##
         ##.$ $.##
         # $ * $ #
         #. * * .#
         # $ * $ #
         ##.$ $.##
 #######  ## . ##  #######
##     ##  ## ##  ##     ##
# .$.$. #   # #   # $.$.$ #
# $.$.$ ##### ##### .$.$. #
# .$ $.             $.@.$ #
# $.$.$ ########### .$.$. #
# .$.$. #         # $.$.$ #
##     ##  #####  ##     ##
 #######   #***#   #######
           #####';
		at: 37 put: '#########     #######
#   #   #######  #  #
# .$. $       # . . #
## ### # # # $ $ #$ #
# . #  #.$ $.## ##.##
#  $ .$ .# #. #. #  #
### ## #.$ $.  $  $ #
##  #  ##$$ .## ##  #
#  ## ##. $$##  #  ##
# $  $  .$ $.# ## ###
#  # .# .# #. $. $  #
##.## ##.$ $.#  # . #
# $# $ $ # # # ### ##
# . . #   @   $ .$. #
#  #  #######   #   #
#######     #########';
		at: 38 put: '#####       ###
#  ###############
# $   * @ *  #   #
#  # * * * *     #
## #  * . *  # ###
 # # * * * * # #
 # #  * . *  # #
 # # * * * * # #
## #  * . *  # ##
## ###########  #
# $           $ #
#   ##########  #
#####       #####';
		at: 39 put: '   ####   ####
   #  #####  ####
#### $ $        ##
#   $   ###  ##  ##
#@### # ###.#..#  #
#  $  # #      .# #
# $ # # #   #  .  #
## #  # ###########
 #   ## $ $ $ #
 ###### #.#.#.###
    #     # #   #
    # # #.#.#.# #
    # # $ $ $ # #
    #  #  # # # #
    ##  ###   # #
     ##    ###  #
      ####     ##
         #######';
		at: 40 put: '  ####### ## #######
  #     ######     ##
  #.###  ##  .  ##  ##
  # .  #  $*# .#  #  #
  # #.  ###.#  *$  # #######
  # $ *    ###  .  #       ##
 ###$# * $$  ##$ .########  #
##  $ # *  #  # # .   #   # #
#  $$  $#. .# @ #. .#$  $$  #
# #   #   . # #  #  * # $  ##
#  ########. $##  $$ * #$###
##       #  .  ###    * $ #
 ####### #  $*  #.###  .# #
       #  #  #. #*$  #  . #
       ##  ##  .  ##  ###.#
        ##     ######     #
         ####### ## #######';
		at: 41 put: '##############################
#        .........           #
# $      ###### ##         @ #
#######   # $    #############
      ##  #   $  #
       ##$## ###$#
     ####    ..# ##### #####
     #  ..*.**.# #   # #   ##
     # ######.. $  # ###$  ##
     # #    #*. # $        #
     # # #  #  # $$ # ## ###
     #  $ # ##    #####   #
     ##  $   ###### #     #
      # ### ###       $#  #
      #   $   #$ $ ##  ####
      #### $ $    ######
         #  ####  #
         ####  ####';
		at: 42 put: '#########################
#   #   #   #   #   #   #
# $ # # # # # # # # # $ #
#  * * $ $ * * $ $ * *  #
### # # # # # # # # # ###
#  * *...... ......* *  #
# # # ###### ###### # # #
#  $ .#     $     #. $  #
### #$ $$$$ @ $$$$ $# ###
#  $ .#     $     #. $  #
# # # ###### ###### # # #
#  * *...... ......* *  #
### # # # # # # # # # ###
#  * * $ $ * * $ $ * *  #
# $ # # # # # # # # # $ #
#   #   #   #   #   #   #
#########################';
		at: 43 put: '    ####
   ##  ####
   # $   .########
   # $ # .   $ $ #
#### ### .#### # #
#  ....#$.#  # # #
# #. $ # .#$ # # #
#  ##  $$$@$ # # #
##   ##  #   # # #
 ###   #  ## # # #
   ### # ...     #
     # #$* *$#  ##
     # # ...$ ###
     # $$ #   #
     #   ######
     ##### ';
		at: 44 put: '      #####
     ##   ##
     #  $  #
    ## $.$ ##
   ## $.*.$ ##
 ### $.*.*.$ ###
##  $.*.$.*.$  ##
#  $.*.$ $.*.$  #
# $.*.$   $.*.$ #
#  $.*.$ $.*.$  #
##  $.*.$.*.$  ##
 ### $.*.*.$ ###
   ## $.*.$ ##
    ## $.$ ##
     #  $  #
     ## @ ##
      #####';
		at: 45 put: '      #####
      #   #
     ## $ ##
   ### $.$ ###
   #  $.*.$  #
  ## $.*.*.$ ##
### $.*.$.*.$ ###
#  $.*.$ $.*.$  #
# $.*.$   $.*.$ #
#  $.*.$ $.*.$  #
### $.*.$.*.$ ###
  ## $.*.*.$ ##
   #  $.*.$  #
   ### $.$ ###
     ## $ ##
      # @ #
      #####';
		at: 46 put: '           #####
 ########### @ ###########
 #   .   .   #     .     #
 # $$*$$$*$$ # .$ $$$.$. #
 #.....*.....#*$.$...*.$*#
## $$*$$$*$$ # .$.$$$ $. ##
#    .   .   #     .      #
# ####################### #
#   .  .  .  #  . . . .   #
## $$* $$* $ # $.$.$.$.$ ##
 #.*.* * *.*.#*$$$ * $$$*#
 # $ *$$ *$$ # $.$.$.$.$ #
 #  .  .  .  #  . . . .  #
 ########### * ###########
           #####';
		at: 47 put: '           #####
 ########### @ ###########
 #  .     .  #    .$.    #
 # .$.$$$.$. #.$  $.$  $.#
 #.$$$.*.$$$.#$.*** ***.$#
## .$.$$$.$. #.$  $.$  $.##
#   .     .  #    .$.     #
# ####################### #
#   $.   .$  # $       .  #
##  * .$. *  # .**   **$ ##
 #  $.$*$.$  # *  ***  * #
 #  * .$. *  # $**   **. #
 #  $.   .$  # .       $ #
 ########### * ###########
           #####';
		at: 48 put: ' #########################
 #  #  #  #  #  #  #  #  #
 # $#$ # $#$ # $#$ # $#$ #
 #  #  #  #  #  #  #  #  #
 # $#$ # $#$ # $#$ # $#$ #
 #  #  #  #  #  #  #  #  #
 ## # ### # ### # ### # ##
 #  #  #  #  #  #  #  #  #
 #  $  #  $  #  $  #  $  #
## ### # ### # ### # ### ##
#   #  #  #  #  #  #  #   #
#   #  $  #  $  #  $  #   #
##  # ### # ### # ### #  ##
 #...........+...........#
 #########   #   #########
         #  ###  #
         #### ####';
		at: 49 put: '  #########################
  #           #           #
###$$ $$ $$ $$.$$ $$ $$ $$###
# $+.$..$..$..$..$..$..$..$ #
# $..$..$..$..$..$..$..$..$ #
#  $$.$$.$$.$$.$$.$$.$$.$$  #
# $..$..$..$..$..$..$..$..$ #
# $..$..$..$..$..$..$..$..$ #
##.$$.$$.$$.$$ $$.$$.$$.$$.##
# $..$..$..$..$..$..$..$..$ #
# $..$..$..$..$..$..$..$..$ #
#  $$.$$.$$.$$.$$.$$.$$.$$  #
# $..$..$..$..$..$..$..$..$ #
# $..$..$..$..$..$..$..$..$ #
###$$ $$ $$ $$.$$ $$ $$ $$###
  #           #           #
  #########################';
		at: 50 put: ' ####                   ####
 #  #####################  #
 #    ....... @ .......    #
 #  # .###############. #  #
###  #.    #  #   #   .#  ###
 #     #   $  #   $  #     #
 #     ##$##  ##$##  #     #
 ###   #  ##$##  #####   ###
 #  #  #  $   $  $   #  #  #
 #     #  #   #  #   #     #
 #  #  #####$######$##  #  #
 ##   ##   #  #   #  ##   ##
 #######   $  #   $  #######
       ##$##  ##$##  #
###### #  #####  ##$## ######
#    # #  $   $  $   # #    #
###### #  #   #  #   # ######
       ############### ';
		yourself! !

!SokobanWorld class methodsFor: 'mazes' stamp: 'rhi 12/21/2003 22:27'!
mazesSasquatchIV
	"http://users.bentonrea.com/~sasquatch/sokoban/sasquatchiv.html
	David W. Skinner <sasquatch@bentonrea.com>"

	^ IdentityDictionary new
		at: 1 put: '   ####
####  #
#     ####
# $ #  . ##
#  #   .  #
## #$$#.  #
##    #####
# @ ###
#   #
#####';
		at: 2 put: '     #####
######   #
#  $     #
#  $### ##
##.$. . .#
 # $#    #
 # @######
 #  #
 ####';
		at: 3 put: '    #####
 ####   #
 # @ $# #
 # #....#
##$ $ $ #
#  ### ##
#      #
#####  #
    ####';
		at: 4 put: '  ######
  #  . ##
  # #*  #
  # $.$ #
  ## *. #
 ## $.@ #
## # .$ #
#  $$.# #
#      ##
########';
		at: 5 put: ' ####
 #  #
## .###
#  .$ #
#* *  ##
# $.$$ #
#  .   #
###*####
  #@#
  ###';
		at: 6 put: '  ####
###  #
#  ..# #######
# #..# #     ####
# #. ###   $    #
# #.   # $ $ $$ #
# #  @ ### $##  #
#           #####
##  #########
 ####';
		at: 7 put: ' ###############
## $.       .$ ##
#  # ####### #  #
# #           # #
#  .***$#$***.  #
###     #     ###
  # ####@#### #
  #           #
  #############';
		at: 8 put: '#######################
#      #   #   #      #
# $@$$ # $     # .. ..#
## ## ### ### ### ## ##
 # #       #       # #
 # #   #   #   #   # #
 # ################# #
 #                   #
 #####################';
		at: 9 put: '###########
#@  #  #  #
#  $#$   $#
##  #..#  #
 #  #..#  #
 #  #..#  ##
 #$   $#$  #
 #  #  #   #
 ###########';
		at: 10 put: '######
#    #
# .$ #
# ** #
##$. #
 #  ####
 # ##  #
 #  #  #
 #     #
 #.**$@#
 #  #  #
 #######';
		at: 11 put: '  ########
 ##.... @#
 #  # .  #
## #  # ##
#  #$ # #
# $   # ##
###$ ##  #
  #   $$ #
  #   #  #
  ########';
		at: 12 put: ' ######
 #    #
 #    ###
 ##*#   #
## . ## #
#     # ##
# #.#  $ #
# $.###$ #
### ##   #
  #   $$@#
 ##..##  #
 #   #####
 #   #
 #####';
		at: 13 put: '      ####
  #####  #
###.  #$ ##
#  *   .*.#
# $.$ #$  #
### ###   #
 #   ### ###
 #  $# $.$ #
 #.*.@  *  #
 ## $#  .###
  #  #####
  ####';
		at: 14 put: ' ######
 #    #####
 # $ *#   #
 #  * * $ #
###* . *  #
# * .@. * #
#  * . *###
# $ * *  #
#   #* $ #
#####    #
    ######';
		at: 15 put: '###########
#    *    #
# $$ ## $ #
#  $..#$$ #
# ##*.*.  #
#*#..@..#*#
#  .*.*## #
# $$#..$  #
# $ ## $$ #
#    *    #
###########';
		at: 16 put: '#############
#     $   . #
#.$ $### *$ #
# ** ## .*  #
#  .$#..$ $ #
# # .$.$### #
#$##..@..##$#
# ###$.$. # #
# $ $..#$.  #
#  *. ## ** #
# $* ###$ $.#
# .   $     #
#############';
		at: 17 put: '###############
#             #
# $.$.$.$.$.$ #
# .$.$.#.$.$. #
# $.$.$ $.$.$ #
# .$.$.#.$.$. #
# $.$.$ $.$.$ #
# .# # @ # #. #
# $.$.$ $.$.$ #
# .$.$.#.$.$. #
# $.$.$ $.$.$ #
# .$.$.#.$.$. #
# $.$.$.$.$.$ #
#             #
###############';
		at: 18 put: ' ###############
##  #   #   #  ##
#   **.. ..**   #
#  *   $$$   *  #
##* .### ###. *##
# * ## $@$ ## * #
# . #       # . #
# .$#$ ### $#$. #
## $   # #   $ ##
# .$#$ ### $#$. #
# . #       # . #
# * ## $ $ ## * #
##* .### ###. *##
#  *   $$$   *  #
#   **.. ..**   #
##  #   #   #  ##
 ###############';
		at: 19 put: ' #########
 #   *   #
 # ## ## #
 #  * *  #
###  #  ###
#  .$#$.  #
# #  @  # #
#  .$#$.  #
###  #  ###
  #######';
		at: 20 put: '####
#  #########
#    ##    #
# $$$#     #
##...# #$$$#
 #...# #...#
 #$$$  #...##
 #    ##$$$ #
 ####### @  #
       ######';
		at: 21 put: '  #########
 ##   #   #
## $# # #$###
#   #. .#   #
# $ *.@.* $ #
#   #. .#   #
###$# # #$ ##
  #   #   ##
  #########';
		at: 22 put: '  ####  ####
  #  ####  ####
###     $ $   #
#    # $  *...##
# $ # #### #.. #
##   #         #
 # $$ $$@ #...##
 #   #  #######
 ####   # #
    #####';
		at: 23 put: '       ####
  ######  #
 ##  $  $ #
##  $ #$  #
#  $ #   $#
#   # ##  ##
###$  ..#  #
  #  #*...@#
  #   ..####
  #  ####
  ####';
		at: 24 put: '          ####
          #  ###
          #    #
   ########$$  #
   #       $  ##
   # #### $$ ##
####....# $  #
#   ...# $$  #
#  #...# $ ###
# @## ## $ #
#         ##
#  #  #####
#######';
		at: 25 put: ' ###############
##  ....#      ##
#  # #     ###  #
#   ....# #   # #
#      # $ $  # #
##     # $@$ #  #
 ####### $ $ #  #
  ##*#   $ $  # #
   ### ####   # #
    ##     ###  #
     #####     ##
         #######';
		at: 26 put: '   ##### #####
   # @ ###   #
   # # $     #
#### #$ $ ####
#    # $ $#
# ### $ $ #
#.......# ##
#### ## #  #
   #    #  #
   ######  #
        ####';
		at: 27 put: '    ####
  ###  ###
###      ##
# $$#$$$@ ##
#     #    #
# ###  #$$$#
#    #   # #
####   .## #
   ####.## ##
    ## .##  #
    ##...   #
    #  .#####
    #  .#
    #####';
		at: 28 put: ' ####
 #  #####
 #  $ $ #
 #* . . #
 #  ########
 #      #  #
 #### $    #
 #   #$### #
 # @$#   # ####
 # $$ $$   #  #
 #   # ## $ * #
## ###.....#. #
#...  ###$# . #
# $ $       . #
########  #####
       ####';
		at: 29 put: ' # ## ####
## #  #  ###
   # ##$   #
#### # * # #
#    # * # #
  #### * # #
###    . # #
#@#.****$# #
#        # #
# #####  # #
#      ##  #
######    ##
     ######';
		at: 30 put: '      #####
      #   #######
      #    ##   ##
      #.#       ###
  #####.#  # #######
 ##  ##.####. ##   ##
##     .....@.#  $ ###
#   ###.#  #.#  $ $  ##
#     #. #  .# $ $ $  #
#   # #.  ## #$ $ $   #
##  # #.   # $ $ $ ####
 ###  #.   #  $ $ ##
   # #     # $ $  #
   # #    ######$##
   #  ####       #
   ##      #######
    ########';
		at: 31 put: ' #############
 #     @     #
 #**.*****.**#
 #  $     $  #
 #   # ###   #
 #####   #####
######## ######
#             #
#**.*******.**#
#  $       $  #
#   #######   #
#####     #####';
		at: 32 put: '           ####
         ###  #
  ######## $$ ##
###   #   .*.$ #
#  $$ # #....$ #
# $.. # $ $    #
##$*. ##  ######
 # ..$## ###   #
 ## .  #    $# #
  # #$   @#  . ##
  #   ### ##$.. #
  ######  ## .*$##
  #    $ $ # ..$ #
  # $....# # $$  #
  # $.*.   #   ###
  ## $$ ########
   #  ###
   ####';
		at: 33 put: '      #######
     ##     ##
     #  *.*  #
     # #$ $# #
 #####  *.*  #####
##   ##     ##   ##
#  #  ###.###  #  #
# *$* # $*$ # *$* #
# . . ..$@$.. . . #
# *$* # $*$ # *$* #
#  #  ###.###  #  #
##   ##     ##   ##
 #####  *.*  #####
     # #$ $# #
     #  *.*  #
     ##     ##
      #######';
		at: 34 put: '     #####
     # @ #
     # $ #
     # $ #
    ## $ ##
#####.*.*.#####
#    *. .*    #
# $$$. # .$$$ #
#    *. .*    #
#####.*.*.#####
    ## $ ##
     # $ #
     # $ #
     #   #
     #####';
		at: 35 put: '      #####
      #   #
     ## $ ##
    ## $.$ ##
   ## $ * $ ##
  ## $.*.*.$ ##
### $.*.#.*.$ ###
#  $ *.# #.* $  #
# $.*.#   #.*.$ #
#  $ *.# #.* $  #
### $.*.#.*.$ ###
  ## $.*.*.$ ##
   ## $ * $ ##
    ## $.$ ##
     ## $ ##
      # @ #
      #####';
		at: 36 put: '      #####
     ###  ##
    ## $   ##
   ## $  *$ ##
  ## $.#.$.$ ##
 ## $.$. .$.$ ##
## $.$. . .$.$ ##
#  *$. * * .# $##
#   . . @ . .   #
##$ #. * * .$*  #
## $.$. . .$.$ ##
 ## $.$. .$.$ ##
  ## $.$.#.$ ##
   ## $*  $ ##
    ##   $ ##
     ##  ###
      #####';
		at: 37 put: '   ## ##
 ##  #  ##
 ##     ##
#  *$#$*  #
#  $...$  #
 # #.@.# #
#  $...$  #
#  *$#$*  #
 ##     ##
 ##  #  ##
   ## ##';
		at: 38 put: '    ## ##
  ##  #  ##
 #  .$ $.  #
 #  *   *  #
# .* #.# *. #
# $ # $ # $ #
 #  .$@$.  #
# $ # $ # $ #
# .* #.# *. #
 #  *   *  #
 #  .$ $.  #
  ##  #  ##
    ## ##';
		at: 39 put: '  ##### # #####
 ## # ##### # ##
 #  #   #   #  #
## $* $   $ *$ ##
#   ..*# #*..   #
###*..  #  ..*###
 # $ *$ # $* $ #
 #   #  *  #   #
### ###* *### ###
 #   #  *  #   #
 # $ *$ # $* $ #
###*..  #  ..*###
#   ..*#@#*..   #
## $* $   $ *$ ##
 #  #   #   #  #
 ## # ##### # ##
  ##### # #####';
		at: 40 put: '             ###
      #################
  ######   ##   ##   ######
####   # $$   #   $$ #   ####
#  #$$     #.. ..#     $$#  #
#      ### #.###.# ###      #
#* ##### ### #*# ### ##### *#
#           ..@..           #
#* ##### ### #*# ### ##### *#
#      ### #.###.# ###      #
#  #$$     #.. ..#     $$#  #
####   # $$   #   $$ #   ####
  ######   ##   ##   ######
      #################
             ###';
		at: 41 put: '###############
#  ..  .   .  #
# $##$ # $$##.#
#  #  ###  #  #
#.##  # # ##$ #
# $   $ $   $ #
#.##  # #  #  #
#.##  #@# ###.#
# $ # ### # #.#
# $         $ #
#.### ### # # #
#  #  #   ###.#
# $#$$###$# # #
#  .   .  . . #
###############';
		at: 42 put: '####   #####   ####
#  ##  #   #####  #
# $.#  # $     $  #
#  .#  #   #####  #
## .#### ###  ##$##
 #$. $     #  $   #
 # ..###   #  #   #
 #*..@#######$#####
 # ..####   #  #
 #$. $      #  #
## .######$##  #
#  .#   #  ##$##
# $.#   #  $   #
#  ##   #  #   #
####    ########';
		at: 43 put: ' ################
##              ##
#  ############  #
# #            # #
# # $$$ $ $   @# #
#  #   ###   $$# ##
## $ ##   #   $ $ #
 ##   # #  ####   #
  ###..  #     #  ###
    ##    .. # .# $ ####
     # #### ## .# #.#  #
     #    # ###* $ .#  ##
     #### #    .# #.    #
        #   ## .###.##  #
        ######          #
             #   #  #   #
             ############';
		at: 44 put: '###############################
#  .  .  .  .  .  .  .  .  .  #
# $ $ # $ $ # $ $ # $ $ # $ $ #
###.#####.#####.#####.#####.###
# $ $ # $ $ # $ $ # $ $ # $ $ #
#     .     .   # .     .     #
###.#####.###########.#####.###
#  $  #  $  . *@# #  *  *  $  #
#  $  *  *  # # * .  $  #  $  #
###.#####.###########.#####.###
#     .     . #   .     .     #
# $ $ # $ $ # $ $ # $ $ # $ $ #
###.#####.#####.#####.#####.###
# $ $ # $ $ # $ $ # $ $ # $ $ #
#  .  .  .  .  .  .  .  .  .  #
###############################';
		at: 45 put: ' #####################
##   #   #   #   #   ##
# * * * * * * * * * * #
#  # # # # # # # # #  #
# $.$ $.$ $.$ $.$ $.$ #
##. .#. .#. .#. .#. .##
# $.$ $.$ $.$ $.$ $.$ #
#  # # # # # # # # #  #
# $.$ $.$ $.$ $.$ $.$ #
##. .#. .#.@.#. .#. .##
# $.$ $.$ $.$ $.$ $.$ #
#  # # # # # # # # #  #
# * * * * * * * * * * #
##   #   #   #   #   ##
 #####################';
		at: 46 put: '   #    #    #    #    #
   #####################
  ##    #    #    #    ##
### .$$. .$$. .$$. .$$. ###
 # .*  *.*  *.*  *.*  *. #
 # $ ## $ ## $ ## $ ## $ #
 # $ ## $ ## $ ## $ ## $ #
 # .*  *.*  *.*  *.*  *. #
### .$$. .$$.@.$$. .$$. ###
 # .*  *.*  *.*  *.*  *. #
 # $ ## $ ## $ ## $ ## $ #
 # $ ## $ ## $ ## $ ## $ #
 # .*  *.*  *.*  *.*  *. #
### .$$. .$$. .$$. .$$. ###
  ##    #    #    #    ##
   #####################
   #    #    #    #    #';
		at: 47 put: '            #####
 ############ @ ############
 #            #            #
 #$.$  .$.$.$.#**.**$$$*.**#
 #.$.$.$.$.$.$#  $. ..$.$  #
 #$.$.$.$.$.$.#  $.$.. .$  #
##.$.$.$.  $.$#**.*$$$**.**##
#             #             #
# ######################### #
#    ..  ..   # $ . $. $ .  #
## $*$*$$$$*$ #  $ $.$. .  ##
 # *. .. .$.$ #.$.$.  $.$.$#
 # $.$. .. .* #$.$.$  .$.$.#
 # $*$$$$*$*$ #  . .$.$ $  #
 #   ..  ..   # . $ .$ . $ #
 ############ * ############
            #####';
		at: 48 put: '#############################
#   #   #   #   #   #   #   #
# # #   #   #   #   #   # # #
#   .$*$.$*$.$*$.$*$.$*$.   #
###.# # # # # # # # # # #.###
#  $  . . . . . . . . .  $  #
#  *# #$#$#$#$#$#$#$#$# #*  #
#  $  * . . . . . . . *  $  #
###*..$ #$#$#$@$#$#$# $..*###
#  $  * . . . . . . . *  $  #
#  *# #$#$#$#$#$#$#$#$# #*  #
#  $  . . . . . . . . .  $  #
###.# # # # # # # # # # #.###
#   .$*$.$*$.$*$.$*$.$*$.   #
# # #   #   #   #   #   # # #
#   #   #   #   #   #   #   #
#############################';
		at: 49 put: ' #############################
 #         *   *   *         #
 #  $ ### $  #####  $ ### $  #
 # $ $ ### $  ###  $ ### $ $ #
 #*#  $ ### $  #  $ ### $  #*#
 # ## .*.*.*.*.$.*.*.*.*. ## #
 # ###$ $ $ $ $.$ $ $ $ $### #
## ..*.....*...$...*.....*.. ##
##  $ $ $ $ $ *@* $ $ $ $ $  ##
## ..*.....*...$...*.....*.. ##
 # ###$ $ $ $ $.$ $ $ $ $### #
 # ## .*.*.*.*.$.*.*.*.*. ## #
 #*#  $ ### $  #  $ ### $  #*#
 # $ $ ### $  ###  $ ### $ $ #
 #  $ ### $  #####  $ ### $  #
 #         *   *   *         #
 #############################';
		at: 50 put: '##############################
# .$ ## $. ## .$ ## $. ## .$ #
#$  .  .  $##$  .  .  $##$  .#
#.  $##$  .  .  $##$  .  .  $#
# $. ## .$ ## $. ## .$ ## $. #
### #  # ##  ## #  # ##  ## ##
### #  # ## #  . # # ##  ## ##
# $. ## .$ #   $  # .$ ## $. #
#.  $##$  . .$##  #$  .  .  $#
#$  .  .  $#  @#$. .  $##$  .#
# .$ ## $. #  $   # $. ## .$ #
## ##  ## # # .  # ## #  # ###
## ##  ## #  # ##  ## #  # ###
# .$ ## $. ## .$ ## $. ## .$ #
#$  .  .  $##$  .  .  $##$  .#
#.  $##$  .  .  $##$  .  .  $#
# $. ## .$ ## $. ## .$ ## $. #
##############################';
		yourself! !

!SokobanWorld class methodsFor: 'mazes' stamp: 'rhi 12/21/2003 22:27'!
mazesSasquatchV
	"http://users.bentonrea.com/~sasquatch/sokoban/sasquatchv.html
	David W. Skinner <sasquatch@bentonrea.com>"

	^ IdentityDictionary new
		at: 1 put: '####
#  ###
#    #
# $  #
### ###
# $ $ #
#..@..#
#  $  #
###  ##
  ####';
		at: 2 put: '#####
#  @####
#  $.  #
###$.# #
#  $.# #
# #$.  #
#    ###
######';
		at: 3 put: '   #####
   #   #
#### # #
# . .# #
#  .   #
# .## $##
##  #$$ #
 ##   $@#
  ##  ###
   ####';
		at: 4 put: '#### ####
#  ###  #
#  # $$ #
# $$ #  #
#    #  ##
### $.#  #
  #..*.@.#
  ##   ###
   #####';
		at: 5 put: '###### ####
#    ###  #
# *     * #
## #***#  #
 #  *+*  ##
## #*$*# ##
#  # # #  #
#         #
#  ########
####';
		at: 6 put: '  ########
 ##  . . #
 # *$# # #
 #.  #$# ##
##* #  #  #
#   # *   #
# $#@ .#  #
#     $ ###
##  #   #
 ########';
		at: 7 put: '   ####
   #  #
   #$ #
   #  # ####
#### ####  #
#   .. ..  #
#  $*. *.$@##
#   #$ $#$  #
#####   #   #
    #########';
		at: 8 put: '  ####
  #  #
  #$ #
  #  # ####
### ####  #
#  .. ..  ###
# $*. *.$@  #
## #$ $#$ # #
 # #   #  # #
 #  ######  #
 ##        ##
  ##########';
		at: 9 put: '     #######
     #  @  #
     # ### ##
#### # # #  #####
#  ### # # .    #
# .    # # * $$ #
# * $$ # # *## ##
# *## ## # *   #
# .   #  # *## #
#  ####  # .   #
####     #  ####
         ####';
		at: 10 put: ' ########
##      ##
# .####  #
# .    # #
# * $$ # #
# *## #  #
# +   # ##
# $###  #
##     ##
 #######';
		at: 11 put: ' #########
##       ##
# .#####  #
# .     # #
# * $$  # #
# *## ##  #
# *   #  ##
# *## # ##
# +   # #
# $###  #
##     ##
 #######';
		at: 12 put: '#######
#  @  #
# $.$ #
##.$.##
## $ ##
# $.$ #
# .$. #
# .$. #
#  #  #
#######';
		at: 13 put: '    #####
 ####   #
 #  $$# #
## *..$ #
#@ .#.  #
# $..* ##
# #$$  #
#   ####
#####';
		at: 14 put: '        ######
####### #    ##
#     ### ##  ##
# #  $.##$  #  ##
#  #  *.@.*  #  #
##  #  $##.$  # #
 ##  ## ###     #
  ##    # #######
   ######';
		at: 15 put: '#######
#     ####
# # # .  ##
# $$$**$$ #
#....@....#
# $$**$$$ #
##  . # # #
 ####     #
    #######';
		at: 16 put: '  ########
  # #   ##
##### # ####
# $ $$ $ $ #
#..........#
# $ $ $$ $ #
#### # #####
  ## @ # #
  ########';
		at: 17 put: '       #####
       #   #
      ## # #
      # *  #
      # # ##
####### #  #
#   # .$.$.####
# #   $$.$$   ###
#  *##..@..##*  #
###   $$.$$   # #
  ####.$.$. #   #
     #  # #######
     ## # #
     #  * #
     # # ##
     #   #
     #####';
		at: 18 put: '  #######
  ##  ###
### .$###
# $$.$ #
# . .  #
## $.$###
###$.$  #
  # . . #
  # .$$ #
 ###. ###
 ###@ ##
 ######';
		at: 19 put: '                #######
       ###### ###     #
     ###    # #  $$##.#
 #####  $ $ ### #$ ##.#
 # $ $   #      #    .#
## # # $ #  ### #  ## #
# $  $   #### #  ##   #
# $#.*##$ #   ##    ###
#.*..... .#    ######
#  .#######
## @#
 #  #
 ####';
		at: 20 put: '     ###########
    ##         ##
    #  #######  #
    # #       # #
    # # ##### # #
   ## #      $# ##
####  ##  ### .$ #
#    ###$ .....# #
# #$    $ $  # @ #
#   ###  #########
##### ####';
		at: 21 put: '##############
#      #  #  ####
# #### #  @   . #
# $.....  #  #$ #
##$#####  # ##. #
 #      ###   $ #
 # ## $  ## ##  #
## ### $    #####
# $  #  #####
#    ####
###  #
  ####';
		at: 22 put: '     #####
     #   ###
  ####     ##
###   #.##  ##
#  $ $ $ $$@ #
#  # ##.##   #
## # # . #####
#  # ...*.   #
# $###   #   #
# $   ###  ###
#   #     ##
###########';
		at: 23 put: '     ######
######    #
# $    $$ #
# $  ##   #
# $##  #$ #
# $ $$ #  #
# .....#$ #
##@#.#$ $ #
 #.....#$ #
 #...**#  #
 #  $    ##
 ####  ###
    ####';
		at: 24 put: '  ########
  #      #
###*####.#
#    $ $ #
# #......###
# #$ #     #
# #. #@# # #
# $$## #$# #
#  $   $   #
#  #########
####';
		at: 25 put: '        #####
        #   #####
   ###### #     ##
   #  ## * ####  ##
 ###       $   #  ###
 #   #####$#  $ #   #
 # $  $  #  $$# #   #
 ###.#..*......... ##
###    $#  # $ $ # #
# $ $## #### ####  #
# #  ##   @  #    ##
#  ##  ######  ####
##            ##
 ##############';
		at: 26 put: '        #####
       ##   # #####
###### #  $ # #   ####
#    ### #$#### #    ##
#   ##   #  # $$ ###  #
#  ###  ##$ @ $     # #
#  #  . # $$ # $ $$ # #
#..#  .##   $#     ## #
#     . ##$  ####     #
#..##.#      #  #######
#     . #   ##
#..#  .  ####
#  ###.# #
#### #   #
     #####';
		at: 27 put: '   #######        ########
   #     #        #  ##  #
#### ### #    #####$    $##
#  #     ###  #      ## $ #
#     #    #  # $ $$$##   #
#     #    #####$  #  ### #
### ##### ##   #  $# $    #
#   #  #       #$  #  #####
#      #   #  ##  ## #  #
#   #  ####   ## # $ $  #
##### ##      ## #   #  #
   #       ####  ##### ######
   #   #      #    # $$$ #  ##
   #   #      ## $        $  #
   ######## ############## # #
        # @..................#
        # # ##################
        #   #
        #####';
		at: 28 put: '  #####          ####
  #   ############..#
  #  $# $ $ $ $  $  #
  ## $  # # # #$  ..#
   #  # . . . *..   #
 ### $####@## # ## ##
## ## # ## ####$ ###
#   ..* . . . #  #
#..  $# # # #  $ ##
#  $  $ $ $ $ #$  #
#..############   #
####          #####';
		at: 29 put: '     #####
     #   #
    ## # #####
   ## *  #   #
  ### # ## # #####
###   $$# *  #   #
#  *#.  $ # ## # #
# #  *... $$# *  #
#   #$$ ....$ # #####
##### # $.+.. $$#   #
   #  * #$$ ...*  # #
   # # ## # $  .#*  #
   #   #  * #$$   ###
   ##### # ## # ###
       #   #  * ##
       ##### # ##
           #   #
           #####';
		at: 30 put: '        ####
        #  #
        #  #
        #  #
########## #
#    $ $ $$#
# @  $..*. #
#   # *...$#
#####$...* #####
    # .*..$#   #
    #$$ $ $    #
    # ##########
    #  #
    #  #
    #  #
    ####';
		at: 31 put: '          ####
          #  #
          #  #
          #  #
############ #
#    $ $.* $$#
# @  $..*.*. #
#   # *  $ .$#
#####*.$   *.#
    #.*   $.*#
    #$. $  * #####
    # .*.*..$#   #
    #$$ *.$ $    #
    # ############
    #  #
    #  #
    #  #
    ####';
		at: 32 put: ' #########
 #   #   #
## # # # ##
# *.*$*.* #
#    #    #
### $@$ ###
#    #    #
# *.*$*.* #
## # # # ##
 #   #   #
 #########';
		at: 33 put: '           #
 # ######## #
  #        #
 # *$.$.$* #
 #  *###*  #
 # $#   #$ #
 #.. .@. ..#
 # $#   #$ #
 #  *###*  #
 # *$.$.$* #
 #        #
# ######## #
 #';
		at: 34 put: ' #### # ####
##  #   #  ##
#   #####   #
#  $. * .$  #
###.$.$.$.###
  # .$ $. #
# #*$ @ $*# #
  # .$ $. #
###.$.$.$.###
#  $. * .$  #
#   #####   #
##  #   #  ##
 #### # ####';
		at: 35 put: ' ###########
##    #    ##
# .$$. .$$. #
# $..$ $..$ #
# .$$...$$. #
# $..$ $..$ #
## $$.*.$$ ##
# $..$ $..$ #
# .$$...$$. #
# $..$ $..$ #
# .$$.@.$$. #
##    #    ##
 ###########';
		at: 36 put: '#############
#     #     #
# # #   # # #
#  .$.$.$.  #
# #$.$.$.$# #
#  .$.$.$.  #
# #$.$@$.$# #
#  .$.$.$.  #
# #$.$.$.$# #
#  .$.$.$.  #
# # # # # # #
#     #     #
#############';
		at: 37 put: '  ############
 #      @     #
# #  $ ## $  # #
#  #.##  ##.#  #
#  .   ##   .  #
# $# #*##*# #$ #
#  # *    * #  #
# # ## *  ## # #
# # ##  * ## # #
#  # *    * #  #
# $# #*##*# #$ #
#  .   ##   .  #
#  #.##  ##.#  #
# #  $ ## $  # #
 #            #
  ############';
		at: 38 put: '    ##########
 #####   @ *#####
 ##  $$ ##. .  ##
 # #    ##    # #
##  # ##  ## #  ##
##.     ##     $##
#*  # #*##*# # $ #
# . # *    * #   #
# ## ## *  ## ## #
# ## ##  * ## ## #
#   # *    * # . #
# $ # #*##*# #  *#
##$     ##     .##
##  # ##  ## #  ##
 # #    ##    # #
 ##  . .## $$  ##
 #####*     #####
    ##########';
		at: 39 put: '    #########
    #       #
  ###$#$ $#$###
  # . . . . . #
###$#$#$ $#$#$###
# . . . . . . . #
# #$#$#$#$#$#$# #
# . . .   . . . #
###$#$##@##$#$###
# . . .   . . . #
# #$#$#$#$#$#$# #
# . . . . . . . #
###$#$#$ $#$#$###
  # . . . . . #
  ###$#$ $#$###
    #       #
    #########';
		at: 40 put: '  ###### ######
 #     ###     #
# .$.$. # .$.$. #
# $.$.$ # $.$.$ #
# .$.$ ### $.$. #
# $.$.#    .$.$ #
# .$  #$ $## $. #
##  # $...$ #  ##
 ####  .@.  ####
##  # $...$ #  ##
# .$ ##$ $#  $. #
# $.$.    #.$.$ #
# .$.$ ### $.$. #
# $.$.$ # $.$.$ #
# .$.$. # .$.$. #
 #     ###     #
  ###### ######';
		at: 41 put: '   #####
  #    ##  ######
 #  ##  # ##     #
 # #  # # #  ###  #
 # #  # ### #   # #
 # #  $  #  $   # #
 #  #$#*.#.*#$##  #
 ##   *.$ $.*    ##
  ### .$ . $. ####
    ### .#. ###
 #### .$ . $. ###
##    *.$@$.*   ##
#  ##$#*.#.*#$#  #
# #   $  #  $  # #
# #   # ### #  # #
#  ###  # # #  # #
 #     ## #  ##  #
  ######  ##    #
           #####';
		at: 42 put: '    #####   #####
    #   #   #   #
  ###   #####   ###
  # .$.$. #  $.$  #
### $.$.$ #.$.$.$.###
#  $.$.$.$ $.$.$.$  #
#  .$.$.$. .$.$.$.  #
#  $.$.$.$ $.$.$.$  #
### $.$.$ #.$.$.$.###
  # .$.$. .  $.$  #
  ###   #.@.#   ###
  #  $.$  . .$.$. #
###.$.$.$.# $.$.$ ###
#  $.$.$.$ $.$.$.$  #
#  .$.$.$. .$.$.$.  #
#  $.$.$.$ $.$.$.$  #
###.$.$.$.# $.$.$ ###
  #  $.$  # .$.$. #
  ###   #####   ###
    #   #   #   #
    #####   #####';
		at: 43 put: '         #####
        ##   ##
       ##.$.$.##
       ##$.$.$##
       # .$.$. #
       # $.$.$ #
       # .$.$. #
  ###### $.$.$ ######
 ###     .$.$.     ###
##.$.$.$.$.$.$.$.$.$.##
# $.$.$.$.$ $.$.$.$.$ #
# .$.$.$.$ @ $.$.$.$. #
# $.$.$.$.$ $.$.$.$.$ #
##.$.$.$.$.$.$.$.$.$.##
 ###     .$.$.     ###
  ###### $.$.$ ######
       # .$.$. #
       # $.$.$ #
       # .$.$. #
       ##$.$.$##
       ##.$.$.##
        ##   ##
         #####';
		at: 44 put: '           #
          # #
        ##   ##
        #  $  #
       #  $ $  #
     ## .$.$.$. ##
     # .$.$.$.$. #
    # .$.$.$.$.$. #
  ## .$.$.$.$.$.$. ##
  #  $.$.$. .$.$.$  #
 #  $.$.$.   .$.$.$  #
#  $ $.$.  @  .$.$ $  #
 #  $.$.$.   .$.$.$  #
  #  $.$.$. .$.$.$  #
  ## .$.$.$.$.$.$. ##
    # .$.$.$.$.$. #
     # .$.$.$.$. #
     ## .$.$.$. ##
       #  $ $  #
        #  $  #
        ##   ##
          # #
           #';
		at: 45 put: '     ####
     #  ########
     #  .      #
     #  ### $$ #
     # $#  # .$#
 #####  # . .#.######
 #  $.  #  # .    $ #
 # $.#.###$###  $   #
 # $ . #.   .#####.##
 #  # ## *$$ #   # #
 # # . $ $@$ $ . # #
 # #   # $$* ## #  #
##.#####.   .# . $ #
#   $  ###$###.#.$ #
# $    . #  #  .$  #
######.#. . #  #####
     #$. #  #$ #
     # $$ ###  #
     #      .  #
     ########  #
            ####';
		at: 46 put: '     #####
     #   #####
     # # #   #####
     #     # #   #
  #####$#      #$#
  # $  $ ####$   #####
  # # #     # ## #   #
  #   ##### # # $$ # #
 ### $      #@#  #   #
 #   ####.... # #  ###
 # # #   .... # #   #
 #   # # ....   # # #
###  # # ....####   #
#   #  # #      $ ###
# # $$ # # #####   #
#   # ## #     # # #
#####   $#### $  $ #
    #$#      #$#####
    #   # #     #
    #####   # # #
        #####   #
            #####';
		at: 47 put: '################   #######
#              #   #     #
#  $ $ $ $ ### ##### ### ##
# $ $ $ $ $  . #    $  . ##
#  $ $ ### #.#.# ### #.#.###
# $ $ $  . # .  $  . # .   #
## ### #.#.# ### #.#.# ### ##
 #   . # .  $    # .  $ $.$##
 ###.#.# ### # @ # ### #.#.###
  ##$.$ $  . #    $  . # .   #
  ## ### #.#.# ### #.#.# ### ##
   #   . # .  $  . # .  $ $ $ #
   ###.#.# ### #.#.# ### $ $  #
    ## .  $    # .  $ $ $ $ $ #
    ## ### ##### ### $ $ $ $  #
     #     #   #              #
     #######   ################';
		at: 48 put: ' ##########################  #
##                        ##
# *.*.* *.*.* *.*.* *.*.* ###
# .$ $.$.$ $.$.$ $.$.$ $. .###
# * $ * * $ * * $ * * $ *#   #
# .$ $.*.$ $.*.$ $.*.$ $.*.* #
# *.*.$ $.*.$ $.*.$ $.*.$ $. #
#  $ * $ * * $ * * $ * * $ * #
# *.*.$ $.*.$ $.*.$ $.*.$ $. #
# .$ $.*.$ $.*+$ $.*.$ $.*.* #
# * $ * * $ * * $ * * $ * $  #
# .$ $.*.$ $.*.$ $.*.$ $.*.* #
# *.*.$ $.*.$ $.*.$ $.*.$ $. #
#   #* $ * * $ * * $ * * $ * #
###. .$ $.$.$ $.$.$ $.$.$ $. #
 ### *.*.* *.*.* *.*.* *.*.* #
  ##                        ##
#  ##########################';
		at: 49 put: '  ####################
  #      #    #      #
###$.$  $.$  $.$  $.$###
# $. .$$.#.$$. .$$.#.$ #
# .###.. # ..###.. # . #
# $. .$$.#.$$. .$$.#.$ #
#  $.$  $.$  $.$  $.$  #
#  $.$  $.$  $.$  $.$  #
# $.#.$$. .$$.#.$$. .$ #
##. # ..###.. # ..###.##
# $.#.$$. .$$.#.$$. .$ #
#  $.$  $.$  $.$  $.$  #
#  $.$  $.$  $.$  $.$  #
# $. .$$.#.$$. .$$.#.$ #
##.###.. # ..###.. # .##
# $. .$$.#.$$. .$$.#.$ #
#  $.$  $.$  $.$  $.$  #
#  $.$  $.$  $.$  $.$  #
# $.#.$$. .$$.#.$$. .$ #
# . # ..###.. # ..###. #
# $.#.$$. .$$.#.$$. .$ #
###$.$  $.$  $.$  $.$###
  #      #    #     @#
  ####################';
		at: 50 put: ' #########################
##   #       #       #   ##
# #  .$.$.$.$ $.$.$.$.  # #
#   .$.$.$.$.$.$.$.$.$.   #
#  .$.$.$.$.$.$.$.$.$.$.  #
##.$.$.$.$.$.$.$.$.$.$.$.##
# $.$.$.$.$.$.$.$.$.$.$.$ #
# .$.$.$.$.$.$.$.$.$.$.$. #
# $.$.$.$.$.$.$.$.$.$.$.$ #
# .$.$.$.$.$.$.$.$.$.$.$. #
# $.$.$.$.$.$.$.$.$.$.$.$ #
# .$.$.$.$.     .$.$.$.$. #
# $.$.$.$.$  $  $.$.$.$.$ #
## $.$.$.$. $@$ .$.$.$.$ ##
# $.$.$.$.$  $  $.$.$.$.$ #
# .$.$.$.$.     .$.$.$.$. #
# $.$.$.$.$.$.$.$.$.$.$.$ #
# .$.$.$.$.$.$.$.$.$.$.$. #
# $.$.$.$.$.$.$.$.$.$.$.$ #
# .$.$.$.$.$.$.$.$.$.$.$. #
# $.$.$.$.$.$.$.$.$.$.$.$ #
##.$.$.$.$.$.$.$.$.$.$.$.##
#  .$.$.$.$.$.$.$.$.$.$.  #
#   .$.$.$.$.$.$.$.$.$.   #
# #  .$.$.$.$ $.$.$.$.  # #
##   #       #       #   ##
 ######################### ';
		yourself! !

!SokobanWorld class methodsFor: 'mazes' stamp: 'rhi 12/21/2003 22:27'!
mazesSasquatchVI
	"http://users.bentonrea.com/~sasquatch/sokoban/sasquatchvi.html
	David W. Skinner <sasquatch@bentonrea.com>"

	^ IdentityDictionary new
		at: 1 put: ' ##### 
##   ## #### 
#  #  # #  # 
# *$* ###$ ## 
# .$. ... $ ## 
# *$* ###    ## 
#  #  # #    @# 
##   ## ####### 
 ##### ';
		at: 2 put: '########## 
#   #    # 
# #$$$$$ # 
#  .#.#  # 
#  ...  ## 
### @ ### 
  ##### ';
		at: 3 put: ' ######## 
##      ## 
#  *..*  # 
# #$  $#@# 
#  ****  # 
##     ### 
 ###  ## 
   #### ';
		at: 4 put: '  ####### 
###  #  # 
#  .$$. ## 
#  *  *@ # 
## .$$.  # 
 #  #  ### 
 ####### ';
		at: 5 put: '      #### 
  #####  #### 
 ##   #  $  # 
 # .# # #*  # 
## *  @  * ## 
#  *# # #. # 
#  $  #   ## 
####  ##### 
   #### ';
		at: 6 put: '  ######## 
  #      # 
### ## # #### 
#  *.** .*  # 
#  $   $# @ # 
#######   ### 
      ##### ';
		at: 7 put: '   ######## 
  ##  #   # 
  #   # # # 
  #       # 
  #   ## ## 
  ##    .# 
   #####.# 
    #  #.# 
 ####  # ### 
##         # 
#  ##$##.  # 
#  $ $ ##### 
#  $ @ # 
##  #### 
 #### ';
		at: 8 put: '########### 
#    @    # 
# ###$### # 
# # .$. # # 
# #$ . $# # 
#  $. .$  # 
###$. .$### 
  #  .  # 
  ####### ';
		at: 9 put: ' ####### 
 #     # 
 # $ $ #### 
### ## .  # 
#   #. $  # 
# @  .#*### 
### #.. # 
## $ #  # 
#   $ $ # 
#   ##. # 
######### ';
		at: 10 put: '      #### 
      #  # 
#######$ # 
# . $ $  # 
#  . .. ## 
##$##+#$# 
 # . .. #### 
##. $ $  $ # 
#  #####   # 
# $#   ##### 
#  # 
#### ';
		at: 11 put: '  #### 
  #  # 
  #  ## 
###   # 
#   # #### 
# . @ #  ### 
##.# #     # 
 #.# #$$$$ # 
 #.**$     # 
 ###. ##   # 
   #  ##  ## 
   ######## ';
		at: 12 put: '       #### 
  ######  # 
  #    #$.# 
 ## ## #  # 
 # $ $$$$ # 
##.*.*.*..# 
#     @   # 
#   ####### 
##### ';
		at: 13 put: '        #### 
     ####  # 
     #     # 
  #### **  # 
 ##  #  #  # 
 #  *** #### 
##$ ..... # 
# $ # $ $ # 
#   ####$ ## 
##### # @  # 
      #    # 
      ###### ';
		at: 14 put: '  ##### 
  # @ # 
### # ##### 
# $   ##  # 
#  . ##   ##### 
#### ## $$ $  # 
 # $   #      # 
 #  .  ##$ #### 
 #### ###  # 
  # $   #  # 
  #  .  #  # 
  #### ### ### 
   # $       # 
   #  .....# # 
   #######   # 
         ##### ';
		at: 15 put: '       #### 
      ##  ## 
      # $  ## 
  #####  *  # 
 ##  .  * * # 
##  * * $* .# 
#  * *$..$* ### 
# $ *$.##.    ## 
##    .##.$* $ # 
 ### *$..$* *  # 
   #. *$ * *  ## 
   # * *@ .  ## 
   #  *  ##### 
   ##  $ # 
    ##  ## 
     #### ';
		at: 16 put: '######## 
##  #### 
##. #  # 
#  *$$ ###### 
#  $.      ## 
#####*###. ## 
  #   * *   # 
  # #.$@$.# # 
  #   * *   # 
  ## .###*##### 
  ##      .$  # 
  ###### $$*  # 
       #  # .## 
       ####  ## 
       ######## ';
		at: 17 put: '         #####   #### 
         #   #####  # 
         #   $ $    # 
         ## ## ###  # 
          #   .  # ## 
          #$#....#*# 
########### # .$ # # 
#   #  ##   ### ## ## 
#   $  $  #  $  $   # 
## ## ###   ##  #   # 
 # # $. # ########### 
 #*#....#*# 
## #  .   ### 
#  ###@##$  # 
#    $ $    # 
#  ######   # 
####    ##### ';
		at: 18 put: '####  ####  #  ####  #### 
#  ####  #######  ####  # 
# .$. # .$. # .$. # .$. # 
#. $ . . $ . . $ . . $ .# 
#$$#$$*$$#$$@$$#$$*$$#$$# 
#. $ . . $ . . $ . . $ .# 
# .$. # .$. # .$. # .$. # 
#  ####  #######  ####  # 
####  ####  #  ####  #### ';
		at: 19 put: '   ######## 
  ##   # ## 
 ## $.$  ## 
## $.$.$ ## 
## .$.$.### 
# .$.$.$ ## 
# $.$ $. ## 
##.$.$.$.## 
# $.$.$.$ # 
#   . .   # 
#####@##### 
   #  # 
#### ### 
## #   ## 
##  $.$ ## 
## $.$.$ ## 
###.$.$. ## 
## $.$.$. # 
## .$ $.$ # 
##.$.$.$.## 
# $.$.$.$ # 
#   . .   # 
########### ';
		at: 20 put: '##### ##### 
########### 
##   .   ## 
## .$.$. ## 
## $*$*$ ## 
 #..$@$..# 
## $*$*$ ## 
## .$.$. ## 
##   .   ## 
########### 
##### ##### ';
		at: 21 put: '########## 
# ##  #  # 
# # * #### 
###$ .$ ## 
#  . @ * # 
# *   .  # 
## $. $### 
#### * # # 
#  #  ## # 
########## ';
		at: 22 put: '########## 
#   ##   # 
# $.  .$ # 
# .**$*. # 
## $ @* ## 
## *  $ ## 
# .*$**. # 
# $.  .$ # 
#   ##   # 
########## ';
		at: 23 put: '########## 
###     ## 
# $.*.*$## 
# *#$ #. # 
# .  @$* # 
# *$   . # 
# .# $#* # 
##$*.*.$ # 
##     ### 
########## ';
		at: 24 put: '########## 
##    #### 
##.$.$.$ # 
##$.$.$. # 
# .$ @.$ # 
# $.  $. # 
# .$.$.$## 
# $.$.$.## 
####    ## 
########## ';
		at: 25 put: '########## 
#  $.    # 
#  *  *  # 
# * ** *$# 
#  * @* .# 
#. *  *  # 
#$* ** * # 
#  *  *  # 
#    .$  # 
########## ';
		at: 26 put: ' ######## 
##  @   ## 
# #$.$.# # 
# $.$.$. # 
# .$  .$ # 
# $.  $. # 
# .$.$.$ # 
# #.$.$# # 
##      ## 
 ######## ';
		at: 27 put: '########## 
#       ## 
# $.$.$. # 
# .$.$.$ # 
# $.##$. # 
# .$##.$ # 
# $.$.$. # 
# .$.$.$ # 
##      @# 
########## ';
		at: 28 put: '########## 
#   .$   # 
#  .$.$  # 
# .$.$.$ # 
#.$.##$.$# 
#$.$##.$.# 
# $.$.$. # 
#  $.$.  # 
#   $.  @# 
########## ';
		at: 29 put: '  ####### 
 ## ##  ## 
#####  $### 
# $ ..  # # 
#   *$*.### 
## .$@$. ## 
###.*$*   # 
# #  .. $ # 
###$  ##### 
 ##  ## ## 
  ####### ';
		at: 30 put: '  ####### 
 ##     ## 
###$   $### 
# $.* *.$ # 
#  *.*.*  # 
#   *@*   # 
#  *.*.*  # 
# $.* *.$ # 
###$   $### 
 ##     ## 
  ####### ';
		at: 31 put: '############# 
#####  .$   # 
####  .$.$  # 
###  .$.$ $ # 
##  .$.$.$.$# 
#  .$.$.$.$.# 
# .$.$@$.$. # 
#.$.$.$.$.  # 
#$.$.$.$.  ## 
# $ $.$.  ### 
#  $.$.  #### 
#   $.  ##### 
############# ';
		at: 32 put: '###### ###### 
#   #####   # 
# #   #   # # 
#  $.$.$.$  # 
## .$.$.$. ## 
## $.$.$.$ ## 
 ##.$.@.$.## 
## $.$.$.$ ## 
## .$.$.$. ## 
#  $.$.$.$  # 
# #   #   # # 
#   #####   # 
###### ###### ';
		at: 33 put: ' ########### 
##    #    ## 
# $.$.$.$.$ # 
# .$.$.$.$. # 
# $.$.$.$.$ # 
# .$.   .$. # 
##$.$ @ $.$## 
# .$.   .$. # 
# $.$.$.$.$ # 
# .$.$.$.$. # 
# $.$.$.$.$ # 
##    #    ## 
 ########### ';
		at: 34 put: '############### 
#      #      # 
# #.$.$.$.$.# # 
# .$.$.$.$.$. # 
# $.$.$.$.$.$ # 
# .$.$.$.$.$. # 
# $.$.$ $.$.$ # 
##.$.$ @ $.$.## 
# $.$.$ $.$.$ # 
# .$.$.$.$.$. # 
# $.$.$.$.$.$ # 
# .$.$.$.$.$. # 
# #.$.$.$.$.# # 
#      #      # 
############### ';
		at: 35 put: '  ####   #### 
  #  # # #  # 
###.$#####$.### 
# $  .$ $.  $ # 
# .  $. .$  . # 
###$.## ##.$### 
  #.$#   #$.# 
 ##    @    ## 
  #$.#   #.$# 
###.$## ##$.### 
# $  .$ $.  $ # 
# .  $. .$  . # 
###$.#####.$### 
  #  # # #  # 
  ####   #### ';
		at: 36 put: '     ##### 
  ####   ### 
  #    #   ### 
 ## #  $.#   # 
 #  $.#.$.$# # 
## #.$.$ $.  ## 
#  .$ $.$.#   # 
# #$.$.@.$.$# # 
#   #.$.$ $.  # 
##  .$ $.$.# ## 
 # #$.$.#.$  # 
 #   #.$  # ## 
 ###   #    # 
   ###   #### 
     ##### ';
		at: 37 put: '    ####### 
  ###     ### 
 ##    #    ## 
 # $#$.$.#.$ # 
## .$.#.$.$# ## 
#  #.$.$.$.$  # 
#  .$.$ $.#.  # 
# #$.$ @ $.$# # 
#  .#.$ $.$.  # 
#  $.$.$.$.#  # 
## #$.$.#.$. ## 
 # $.#.$.$#$ # 
 ##    #    ## 
  ###     ### 
    ####### ';
		at: 38 put: '     ####### 
 ######   ###### 
 ##   $. .$   ## 
 # $ $.$#$.$ $ # 
 #  #.$.$.$.#  # 
## $. .$.$. .$ ## 
##$.$.#.$.#.$.$## 
# .$.$.   .$.$. # 
#  #$.$ @ $.$#  # 
# .$.$.   .$.$. # 
##$.$.#.$.#.$.$## 
## $. .$.$. .$ ## 
 #  #.$.$.$.#  # 
 # $ $.$#$.$ $ # 
 ##   $. .$   ## 
 ######   ###### 
     ####### ';
		at: 39 put: '       #### 
       #  ## 
      ## $#### 
     ###. .  # 
  #### $ # $ # 
  #  #  . .#### 
 ## $####$ #  ## 
###. . $. $# $#### 
# $ # $ **.#. .  # 
#  . .#.** $ # $ # 
####$ #$ .$ . .### 
  ##  # $####$ ## 
   ####. .  #  # 
    # $ # $ #### 
    #  . .### 
    ####$ ## 
      ## @# 
       #### ';
		at: 40 put: '              #### 
              #  # 
              #  # 
              #  # 
################ # 
#    $ $ $ $ $ $$# 
# @  $  *.*.*.   # 
#   #  ..* $... $# 
#####$... $ $..* # 
    # *.$. $. *.$# 
    #$.$ $.. $ * # 
    # * $ ..$ $.$# 
    #$.* .$ .$.* # 
    # *..$ $ ...$# 
    #$ ...$ *..  ##### 
    #   .*.*.*  $#   # 
    #$$ $ $ $ $ $    # 
    # ################ 
    #  # 
    #  # 
    #  # 
    #### ';
		at: 41 put: '          # 
         # # 
        # . # 
       # $.$ # 
      #  .$.  # 
     # $.$ $.$ # 
    # $. . . .$ # 
   # $.$.$ $.$.$ # 
  #  . . # # . .  # 
 # $.$.$# $ #$.$.$ # 
# ..$    $@$    $.. # 
 # $.$.$# $ #$.$.$ # 
  #  . . # # . .  # 
   # $.$.$ $.$.$ # 
    # $. . . .$ # 
     # $.$ $.$ # 
      #  .$.  # 
       # $.$ # 
        # . # 
         # # 
          # ';
		at: 42 put: '           # 
          # # 
         # # # 
        #  #  # 
       #   #   # 
      #    $    # 
     #.*********.# 
    # *         * # 
   #  * ******* *  # 
  #   * *     * *   # 
 #    * * *** * *    # 
# ###$* * *@* * *$### # 
 #    * * *** * *    # 
  #   * *     * *   # 
   #  * ******* *  # 
    # *         * # 
     #.*********.# 
      #    $    # 
       #   #   # 
        #  #  # 
         # # # 
          # # 
           # ';
		at: 43 put: '      #   #   # 
 ################### 
 #    #   #   #    # 
 # #  #   #   #  # # 
 #  **$***$***$**  # 
 #  *   .   .   *  # 
####$ #### #### $#### 
 #  * ## #.# ## *  # 
 #  *.# ## ## #.*  # 
 #  * ###   ### *  # 
####$  .  @  .  $#### 
 #  * ###   ### *  # 
 #  *.# ## ## #.*  # 
 #  * ## #.# ## *  # 
####$ #### #### $#### 
 #  *   .   .   *  # 
 #  **$***$***$**  # 
 # #  #   #   #  # # 
 #    #   #   #    # 
 ################### 
      #   #   # ';
		at: 44 put: '    #####   ##### 
#####   #####   ##### 
#   #   #   #   #   # 
#  $.$$$.$ $.$$$.$  # 
###.#...#...#...#.### 
 # $.$ $.$$$.$ $.$ # 
 #  .$ $.   .$ $.  # 
 # $.$ $.$$$.$ $.$ # 
###.#...#...#...#.### 
#  $.$$$.$ $.$$$.$  # 
#  $.   .$@$.   .$  # 
#  $.$$$.$ $.$$$.$  # 
###.#...#...#...#.### 
 # $.$ $.$$$.$ $.$ # 
 #  .$ $.   .$ $.  # 
 # $.$ $.$$$.$ $.$ # 
###.#...#...#...#.### 
#  $.$$$.$ $.$$$.$  # 
#   #   #   #   #   # 
#####   #####   ##### 
    #####   ##### ';
		at: 45 put: '####################### 
##  #      *      #  ## 
#   # #   # #   # #   # 
#  $.$.$ $.$.$ $.$.$  # 
###.$.$.#.$.$.#.$.$.### 
#  $. .$ $. .$ $. .$  # 
# #.$.$.#.$.$.#.$.$.# # 
#  $.$.$ $.$.$ $.$.$  # 
#   # #   # #   # #   # 
#  $.$.$ $.$.$ $.$.$  # 
# #.$.$.#.$.$.#.$.$.# # 
#* $. .$ $.@.$ $. .$ *# 
# #.$.$.#.$.$.#.$.$.# # 
#  $.$.$ $.$.$ $.$.$  # 
#   # #   # #   # #   # 
#  $.$.$ $.$.$ $.$.$  # 
# #.$.$.#.$.$.#.$.$.# # 
#  $. .$ $. .$ $. .$  # 
###.$.$.#.$.$.#.$.$.### 
#  $.$.$ $.$.$ $.$.$  # 
#   # #   # #   # #   # 
##  #      *      #  ## 
####################### ';
		at: 46 put: '  ######     ########### 
 ##    #######. . . .  ## 
##.$.$.$     .$.$.$.$.$.## 
# $.$.$.#####$.$.$.$.$.$ # 
# .$.$.$#   # $.$.$.$.$. # 
#.$.$.  # $     ####.$.$ # 
# .$.##### ### ##  # .$. # 
#.$.$#   #  # $  $ # $.$## 
# .$.# $  $ # # #  #### # 
#.$.$## ##  #   # ##  # # 
# .$. #   ###### $  $ # # 
#.$.$  $# #    #   #  # # 
##.$  #   # ## ##### ## # 
 # ## ##### ## #   #  $.## 
 # #  #   #    # #$  $.$.# 
 # # $  $ ######   # .$. # 
 # #  ## #   #  ## ##$.$.# 
 # ####  # # # $  $ #.$. # 
##$.$ # $  $ #  #   #$.$.# 
# .$. #  ## ### #####.$. # 
# $.$.####     $ #  .$.$.# 
# .$.$.$.$.$ #   #$.$.$. # 
# $.$.$.$.$.$#####.$.$.$ # 
##.$.$.$.$.$.  @  $.$.$.## 
 ##  . . . .#######    ## 
  ###########     ###### ';
		at: 47 put: ' ###### ##### ##### ###### 
##    ###############    ## 
# $ $ $.$ $ $.$ $ $.$ $ $ # 
#  $.$ . $.$ . $.$ . $.$  # 
# $.$.*.*.$.*.*.$.*.*.$.$ # 
#  $.$ . $.$ . $.$ . $.$  # 
##$ * $.$ $ $#$ $ $.$ * $## 
 #.....#.....#.....#.....# 
##$ * $.$ $ $#$ $ $.$ * $## 
## $.$ . $.$ . $.$ . $.$ ## 
##$.$.$.$.$.*.*.$.$.$.$.$## 
## $.$ . $.$ . $.$ . $.$ ## 
##$ * $.$ * * * * $.$ * $## 
 #....###... @ ...###....# 
##$ * $.$ * * * * $.$ * $## 
## $.$ . $.$ . $.$ . $.$ ## 
##$.$.$.$.$.*.*.$.$.$.$.$## 
## $.$ . $.$ . $.$ . $.$ ## 
##$ * $.$ $ $#$ $ $.$ * $## 
 #.....#.....#.....#.....# 
##$ * $.$ $ $#$ $ $.$ * $## 
#  $.$ . $.$ . $.$ . $.$  # 
# $.$.*.*.$.*.*.$.*.*.$.$ # 
#  $.$ . $.$ . $.$ . $.$  # 
# $ $ $.$ $ $.$ $ $.$ $ $ # 
##    ###############    ## 
 ###### ##### ##### ###### ';
		at: 48 put: '       #    #    #    # 
  ########################## 
 ##    #    #    #    #    ## 
 # $.$.#.$.$#$.$.#.$.$#$.$. # 
 # .$.$ $.$. .$.$ $.$. .$.$ # 
 # $.$. .$.$ $.$. .$.$ $.$. # 
 # .$.$#$.$. .$.$#$.$. .$.$ # 
####   #   ###   #   ###  #### 
 # .$.$#$.$. .$.$#$.$. .$.$ # 
 # $.$. .$.$ $.$. .$.$ $.$. # 
 # .$.$ $.$. .$.$ $.$. .$.$ # 
 # $.$. .$.$#$.$. .$.$#$.$. # 
####  ###   #   ###   #   #### 
 # $.$. .$.$#$.$. .$.$#$.$. # 
 # .$.$ $.$. . @$ $.$. .$.$ # 
 # $.$. .$.$ $  . .$.$ $.$. # 
 # .$.$#$.$. .$.$#$.$. .$.$ # 
####   #   ###   #   ###   ### 
 # .$.$#$.$. .$.$#$.$. .$.$ # 
 # $.$. .$.$ $.$. .$.$ $.$. # 
 # .$.$ $.$. .$.$ $.$. .$.$ # 
 # $.$. .$.$#$.$. .$.$#$.$. # 
####  ###   #   ###   #   #### 
 # $.$. .$.$#$.$. .$.$#$.$. # 
 # .$.$ $.$. .$.$ $.$. .$.$ # 
 # $.$. .$.$ $.$. .$.$ $.$. # 
 # .$.$#$.$.#.$.$#$.$.#.$.$ # 
 ##    #    #    #    #    ## 
  ########################## 
       #    #    #    # ';
		at: 49 put: '         #####     ##### 
        ##   ##   ##   ## 
       ##.$.$.## ##.$.$.## 
       ##$.$.$## ##$.$.$## 
       # .$.$. # # .$.$. # 
       # $.$.$ # # $.$.$ # 
       # .$.$. # # .$.$. # 
  ###### $.$.$ ### $.$.$ ###### 
 ###     .$.$.     .$.$.     ### 
##.$.$.$.$.$.$.$.$.$.$.$.$.$.$.## 
# $.$.$.$.$ $.$.$.$.$ $.$.$.$.$ # 
# .$.$.$.$   $.$.$.$   $.$.$.$. # 
# $.$.$.$.$ $.$.$.$.$ $.$.$.$.$ # 
##.$.$.$.$.$.$.$.$.$.$.$.$.$.$.## 
 ###     .$.$.# . #.$.$.     ### 
  ###### $.$.$ #*# $.$.$ ###### 
       # .$.$..*@*..$.$. # 
  ###### $.$.$ #*# $.$.$ ###### 
 ###     .$.$.# . #.$.$.     ### 
##.$.$.$.$.$.$.$.$.$.$.$.$.$.$.## 
# $.$.$.$.$ $.$.$.$.$ $.$.$.$.$ # 
# .$.$.$.$   $.$.$.$   $.$.$.$. # 
# $.$.$.$.$ $.$.$.$.$ $.$.$.$.$ # 
##.$.$.$.$.$.$.$.$.$.$.$.$.$.$.## 
 ###     .$.$.     .$.$.     ### 
  ###### $.$.$ ### $.$.$ ###### 
       # .$.$. # # .$.$. # 
       # $.$.$ # # $.$.$ # 
       # .$.$. # # .$.$. # 
       ##$.$.$## ##$.$.$## 
       ##.$.$.## ##.$.$.## 
        ##   ##   ##   ## 
         #####     ##### ';
		at: 50 put: '            #         # 
  ##### ######### ######### ##### 
 ##   ###   #   ###   #   ###   ## 
 # $.$. .$.$ $.$. .$.$ $.$. .$.$ # 
 # .$.$ $.$. .$.$ $.$. .$.$ $.$. # 
 # $.$. .$.$ $.$. .$.$ $.$. .$.$ # 
 ##.$.$#$.$. .$.$#$.$. .$.$#$.$.## 
  #    #   ###   #   ###   #    # 
 ##.$.$#$.$. .$.$#$.$. .$.$#$.$.## 
 # $.$. .$.$ $.$. .$.$ $.$. .$.$ # 
 # .$.$ $.$. .$.$ $.$. .$.$ $.$. # 
 # $.$. .$.$#$.$. .$.$#$.$. .$.$ # 
###   ###   #   ###   #   ###   ### 
 # $.$. .$.$#$.$. .$.$#$.$. .$.$ # 
 # .$.$ $.$. .$.$ $.$. .$.$ $.$. # 
 # $.$. .$.$ $.$. .$.$ $.$. .$.$ # 
 ##.$.$#$.$. .$.$ $.$. .$.$#$.$.## 
  #    #   ###   @   ###   #    # 
 ##.$.$#$.$. .$.$ $.$. .$.$#$.$.## 
 # $.$. .$.$ $.$. .$.$ $.$. .$.$ # 
 # .$.$ $.$. .$.$ $.$. .$.$ $.$. # 
 # $.$. .$.$#$.$. .$.$#$.$. .$.$ # 
###   ###   #   ###   #   ###   ### 
 # $.$. .$.$#$.$. .$.$#$.$. .$.$ # 
 # .$.$ $.$. .$.$ $.$. .$.$ $.$. # 
 # $.$. .$.$ $.$. .$.$ $.$. .$.$ # 
 ##.$.$#$.$. .$.$#$.$. .$.$#$.$.## 
  #    #   ###   #   ###   #    # 
 ##.$.$#$.$. .$.$#$.$. .$.$#$.$.## 
 # $.$. .$.$ $.$. .$.$ $.$. .$.$ # 
 # .$.$ $.$. .$.$ $.$. .$.$ $.$. # 
 # $.$. .$.$ $.$. .$.$ $.$. .$.$ # 
 ##   ###   #   ###   #   ###   ## 
  ##### ######### ######### ##### 
            #         # ';
		yourself! !

!SokobanWorld class methodsFor: 'mazes' stamp: 'rhi 7/30/2003 17:10'!
mazesSetNames
	"^ <IdentityDictionary key: Symbol value: String>"

	^ IdentityDictionary new
		at: #mazesLoma put: 'Loma';
		at: #mazesMasMicroban put: 'Mas Microban';
		at: #mazesMasSasquatch put: 'Mas Sasquatch';
		at: #mazesMicroban put: 'Microban';
		at: #mazesSasquatch put: 'Sasquatch';
		at: #mazesSasquatchIII put: 'Sasquatch III';
		at: #mazesSasquatchIV put: 'Sasquatch IV';
		at: #mazesSasquatchV put: 'Sasquatch V';
		at: #mazesSasquatchVI put: 'Sasquatch VI';
		at: #mazesUAlberta put: 'University of Alberta';
		yourself! !

!SokobanWorld class methodsFor: 'mazes' stamp: 'rhi 12/21/2003 22:23'!
mazesUAlberta
	"http://www.cs.ualberta.ca/~games/Sokoban/Mazes/Screens/
	Andreas Junghanns <andreas.junghanns@daimlerchrysler.com>"

	^ IdentityDictionary new
		at: 1 put: '    #####
    #   #
    #$  #
  ###  $##
  #  $ $ #
### # ## #   ######
#   # ## #####  ..#
# $  $          ..#
##### ### #@##  ..#
    #     #########
    #######

';
		at: 2 put: '############
#..  #     ###
#..  # $  $  #
#..  #$####  #
#..    @ ##  #
#..  # #  $ ##
###### ##$ $ #
  # $  $ $ $ #
  #    #     #
  ############


';
		at: 3 put: '        ########
        #     @#
        # $#$ ##
        # $  $#
        ##$ $ #
######### $ # ###
#....  ## $  $  #
##...    $  $   #
#....  ##########
########


';
		at: 4 put: '           ########
           #  ....#
############  ....#
#    #  $ $   ....#
# $$$#$  $ #  ....#
#  $     $ #  ....#
# $$ #$ $ $########
#  $ #     #
## #########
#    #    ##
#     $   ##
#  $$#$$  @#
#    #    ##
###########


';
		at: 5 put: '        #####
        #   #####
        # #$##  #
        #     $ #
######### ###   #
#....  ## $  $###
#....    $ $$ ##
#....  ##$  $ @#
#########  $  ##
        # $ $  #
        ### ## #
          #    #
          ######


';
		at: 6 put: '######  ###
#..  # ##@##
#..  ###   #
#..     $$ #
#..  # # $ #
#..### # $ #
#### $ #$  #
   #  $# $ #
   # $  $  #
   #  ##   #
   #########


';
		at: 7 put: '       #####
 #######   ##
## # @## $$ #
#    $      #
#  $  ###   #
### #####$###
# $  ### ..#
# $ $ $ ...#
#    ###...#
# $$ # #...#
#  ### #####
####


';
		at: 8 put: '  ####
  #  ###########
  #    $   $ $ #
  # $# $ #  $  #
  #  $ $  #    #
### $# #  #### #
#@#$ $ $  ##   #
#    $ #$#   # #
#   $    $ $ $ #
#####  #########
  #      #
  #      #
  #......#
  #......#
  #......#
  ########


';
		at: 9 put: '          #######
          #  ...#
      #####  ...#
      #      . .#
      #  ##  ...#
      ## ##  ...#
     ### ########
     # $$$ ##
 #####  $ $ #####
##   #$ $   #   #
#@ $  $    $  $ #
###### $$ $ #####
     #      #
     ########


';
		at: 10 put: ' ###  #############
##@####       #   #
# $$   $$  $ $ ...#
#  $$$#    $  #...#
# $   # $$ $$ #...#
###   #  $    #...#
#     # $ $ $ #...#
#    ###### ###...#
## #  #  $ $  #...#
#  ## # $$ $ $##..#
# ..# #  $      #.#
# ..# # $$$ $$$ #.#
##### #       # #.#
    # ######### #.#
    #           #.#
    ###############


';
		at: 11 put: '          ####
     #### #  #
   ### @###$ #
  ##      $  #
 ##  $ $$## ##
 #  #$##     #
 # # $ $$ # ###
 #   $ #  # $ #####
####    #  $$ #   #
#### ## $         #
#.    ###  ########
#.. ..# ####
#...#.#
#.....#
#######


';
		at: 12 put: '################
#              #
# # ######     #
# #  $ $ $ $#  #
# #   $@$   ## ##
# #  $ $ $###...#
# #   $ $  ##...#
# ###$$$ $ ##...#
#     # ## ##...#
#####   ## ##...#
    #####     ###
        #     #
        #######


';
		at: 13 put: '   #########
  ##   ##  #####
###     #  #    ###
#  $ #$ #  #  ... #
# # $#@$## # #.#. #
#  # #$  #    . . #
# $    $ # # #.#. #
#   ##  ##$ $ . . #
# $ #   #  #$#.#. #
## $  $   $  $... #
 #$ ######    ##  #
 #  #    ##########
 ####


';
		at: 14 put: '       #######
 #######     #
 #     # $@$ #
 #$$ #   #########
 # ###......##   #
 #   $......## # #
 # ###......     #
##   #### ### #$##
#  #$   #  $  # #
#  $ $$$  # $## #
#   $ $ ###$$ # #
#####     $   # #
    ### ###   # #
      #     #   #
      ########  #
             ####


';
		at: 15 put: '   ########
   #   #  #
   #  $   #
 ### #$   ####
 #  $  ##$   #
 #  # @ $ # $#
 #  #      $ ####
 ## ####$##     #
 # $#.....# #   #
 #  $..**. $# ###
##  #.....#   #
#   ### #######
# $$  #  #
#  #     #
######   #
     #####


';
		at: 16 put: '#####
#   ##
#    #  ####
# $  ####  #
#  $$ $   $#
###@ #$    ##
 #  ##  $ $ ##
 # $  ## ## .#
 #  #$##$  #.#
 ###   $..##.#
  #    #.*...#
  # $$ #.....#
  #  #########
  #  #
  ####


';
		at: 17 put: '   ##########
   #..  #   #
   #..      #
   #..  #  ####
  #######  #  ##
  #            #
  #  #  ##  #  #
#### ##  #### ##
#  $  ##### #  #
# # $  $  # $  #
# @$  $   #   ##
#### ## #######
   #    #
   ######


';
		at: 18 put: '     ###########
     #  .  #   #
     # #.    @ #
 ##### ##..# ####
##  # ..###     ###
# $ #...   $ #  $ #
#    .. ##  ## ## #
####$##$# $ #   # #
  ## #    #$ $$ # #
  #  $ # #  # $## #
  #               #
  #  ###########  #
  ####         ####


';
		at: 19 put: '  ######
  #   @####
##### $   #
#   ##    ####
# $ #  ##    #
# $ #  ##### #
## $  $    # #
## $ $ ### # #
## #  $  # # #
## # #$#   # #
## ###   # # ######
#  $  #### # #....#
#    $    $   ..#.#
####$  $# $   ....#
#       #  ## ....#
###################


';
		at: 20 put: '    ##########
#####        ####
#     #   $  #@ #
# #######$####  ###
# #    ## #  #$ ..#
# # $     #  #  #.#
# # $  #     #$ ..#
# #  ### ##     #.#
# ###  #  #  #$ ..#
# #    #  ####  #.#
# #$   $  $  #$ ..#
#    $ # $ $ #  #.#
#### $###    #$ ..#
   #    $$ ###....#
   #      ## ######
   ########


';
		at: 21 put: '#########
#       #
#       ####
## #### #  #
## #@##    #
# $$$ $  $$#
#  # ## $  #
#  # ##  $ ####
####  $$$ $#  #
 #   ##   ....#
 # #   # #.. .#
 #   # # ##...#
 ##### $  #...#
     ##   #####
      #####


';
		at: 22 put: '######     ####
#    #######  #####
#   $#  #  $  #   #
#  $  $  $ # $ $  #
##$ $   # @# $    #
#  $ ########### ##
# #   #.......# $#
# ##  # ......#  #
# #   $........$ #
# # $ #.... ..#  #
#  $ $####$#### $#
# $   ### $   $  ##
# $     $ $  $    #
## ###### $ ##### #
#         #       #
###################


';
		at: 23 put: '    #######
    #  #  ####
##### $#$ #  ##
#.. #  #  #   #
#.. # $#$ #  $####
#.  #     #$  #  #
#..   $#  # $    #
#..@#  #$ #$  #  #
#.. # $#     $#  #
#.. #  #$$#$  #  ##
#.. # $#  #  $#$  #
#.. #  #  #   #   #
##. ####  #####   #
 ####  ####   #####


';
		at: 24 put: '###############
#..........  .####
#..........$$.#  #
###########$ #   ##
#      $  $     $ #
## ####   #  $ #  #
#      #   ##  # ##
#  $#  # ##  ### ##
# $ #$###    ### ##
###  $ #  #  ### ##
###    $ ## #  # ##
 # $  #  $  $ $   #
 #  $  $#$$$  #   #
 #  #  $      #####
 # @##  #  #  #
 ##############


';
		at: 25 put: '####
#  ##############
#  #   ..#......#
#  # # ##### ...#
##$#    ........#
#   ##$######  ####
# $ #     ######@ #
##$ # $   ######  #
#  $ #$$$##       #
#      #    #$#$###
# #### #$$$$$    #
# #    $     #   #
# #   ##        ###
# ######$###### $ #
#        #    #   #
##########    #####


';
		at: 26 put: ' #######
 #  #  #####
##  #  #...###
#  $#  #...  #
# $ #$$ ...  #
#  $#  #... .#
#   # $########
##$       $ $ #
##  #  $$ #   #
 ######  ##$$@#
      #      ##
      ########


';
		at: 27 put: ' #################
 #...   #    #   ##
##.....  $## # #$ #
#......#  $  #    #
#......#  #  # #  #
######### $  $ $  #
  #     #$##$ ##$##
 ##   $    # $    #
 #  ## ### #  ##$ #
 # $ $$     $  $  #
 # $    $##$ ######
 #######  @ ##
       ######


';
		at: 28 put: '         #####
     #####   #
    ## $  $  ####
##### $  $ $ ##.#
#       $$  ##..#
#  ###### ###.. #
## #  #    #... #
# $   #    #... #
#@ #$ ## ####...#
####  $ $$  ##..#
   ##  $ $  $...#
    # $$  $ #  .#
    #   $ $  ####
    ######   #
         #####


';
		at: 29 put: '#####
#   ##
# $  #########
## # #       ######
## #   $#$#@  #   #
#  #      $ #   $ #
#  ### ######### ##
#  ## ..*..... # ##
## ## *.*..*.* # ##
# $########## ##$ #
#  $   $  $    $  #
#  #   #   #   #  #
###################


';
		at: 30 put: '       ###########
       #   #     #
#####  #     $ $ #
#   ##### $## # ##
# $ ##   # ## $  #
# $  @$$ # ##$$$ #
## ###   # ##    #
## #   ### #####$#
## #     $  #....#
#  ### ## $ #....##
# $   $ #   #..$. #
#  ## $ #  ##.... #
#####   ######...##
    #####    #####


';

		at: 31 put: '  ####
  #  #########
 ##  ##  #   #
 #  $# $@$   ####
 #$  $  # $ $#  ##
##  $## #$ $     #
#  #  # #   $$$  #
# $    $  $## ####
# $ $ #$#  #  #
##  ###  ###$ #
 #  #....     #
 ####......####
   #....####
   #...##
   #...#
   #####


';
		at: 32 put: '      ####
  #####  #
 ##     $#
## $  ## ###
#@$ $ # $  #
#### ##   $#
 #....#$ $ #
 #....#   $#
 #....  $$ ##
 #... # $   #
 ######$ $  #
      #   ###
      #$ ###
      #  #
      ####


';
		at: 33 put: '############
##     ##  #
##   $   $ #
#### ## $$ #
#   $ #    #
# $$$ # ####
#   # # $ ##
#  #  #  $ #
# $# $#    #
#   ..# ####
####.. $ #@#
#.....# $# #
##....#  $ #
###..##    #
############


';
		at: 34 put: ' #########
 #....   ##
 #.#.#  $ ##
##....# # @##
# ....#  #  ##
#     #$ ##$ #
## ###  $    #
 #$  $ $ $#  #
 # #  $ $ ## #
 #  ###  ##  #
 #    ## ## ##
 #  $ #  $  #
 ###$ $   ###
   #  #####
   ####


';
		at: 35 put: '############ ######
#   #    # ###....#
#   $$#   @  .....#
#   # ###   # ....#
## ## ###  #  ....#
 # $ $     # # ####
 #  $ $##  #      #
#### #  #### # ## #
#  # #$   ## #    #
# $  $  # ## #   ##
# # $ $    # #   #
#  $ ## ## # #####
# $$     $$  #
## ## ### $  #
 #    # #    #
 ###### ######


';
		at: 36 put: '            #####
#####  ######   #
#   ####  $ $ $ #
# $   ## ## ##  ##
#   $ $     $  $ #
### $  ## ##     ##
  # ##### #####$$ #
 ##$##### @##     #
 # $  ###$### $  ##
 # $  #   ###  ###
 # $$ $ #   $$ #
 #     #   ##  #
 #######.. .###
    #.........#
    #.........#
    ###########


';
		at: 37 put: '###########
#......   #########
#......   #  ##   #
#..### $    $     #
#... $ $ #   ##   #
#...#$#####    #  #
###    #   #$  #$ #
  #  $$ $ $  $##  #
  #  $   #$#$ ##$ #
  ### ## #    ##  #
   #  $ $ ## ######
   #    $  $  #
   ##   # #   #
    #####@#####
        ###


';
		at: 38 put: '      ####
####### @#
#     $  #
#   $## $#
##$#...# #
 # $...  #
 # #. .# ##
 #   # #$ #
 #$  $    #
 #  #######
 ####


';
		at: 39 put: '             ######
 #############....#
##   ##     ##....#
#  $$##  $ @##....#
#      $$ $#  ....#
#  $ ## $$ # # ...#
#  $ ## $  #  ....#
## ##### ### ##.###
##   $  $ ##   .  #
# $###  # ##### ###
#   $   #       #
#  $ #$ $ $###  #
# $$$# $   # ####
#    #  $$ #
######   ###
     #####


';
		at: 40 put: '    ############
    #          ##
    #  # #$$ $  #
    #$ #$#  ## @#
   ## ## # $ # ##
   #   $ #$  # #
   #   # $   # #
   ## $ $   ## #
   #  #  ##  $ #
   #    ## $$# #
######$$   #   #
#....#  ########
#.#... ##
#....   #
#....   #
#########


';
		at: 41 put: '           #####
          ##   ##
         ##     #
        ##  $$  #
       ## $$  $ #
       # $    $ #
####   #   $$ #####
#  ######## ##    #
#.            $$$@#
#.# ####### ##   ##
#.# #######. #$ $##
#........... #    #
##############  $ #
             ##  ##
              ####


';
		at: 42 put: '     ########
  ####      ######
  #    ## $ $   @#
  # ## ##$#$ $ $##
### ......#  $$ ##
#   ......#  #   #
# # ......#$  $  #
# #$...... $$# $ #
#   ### ###$  $ ##
###  $  $  $  $ #
  #  $  $  $  $ #
  ######   ######
       #####


';
		at: 43 put: '        #######
    #####  #  ####
    #   #   $    #
 #### #$$ ## ##  #
##      # #  ## ###
#  ### $#$  $  $  #
#...    # ##  #   #
#...#    @ # ### ##
#...#  ###  $  $  #
######## ##   #   #
          #########


';
		at: 44 put: ' #####
 #   #
 # # #######
 #      $@######
 # $ ##$ ###   #
 # #### $    $ #
 # ##### #  #$ ####
##  #### ##$      #
#  $#  $  # ## ## #
#         # #...# #
######  ###  ...  #
     #### # #...# #
          # ### # #
          #       #
          #########


';
		at: 45 put: '##### ####
#...# #  ####
#...###  $  #
#....## $  $###
##....##   $  #
###... ## $ $ #
# ##    #  $  #
#  ## # ### ####
# $ # #$  $    #
#  $ @ $    $  #
#   # $ $$ $ ###
#  ######  ###
# ##    ####
###


';
		at: 46 put: '##########
#        ####
# ###### #  ##
# # $ $ $  $ #
#       #$   #
###$  $$#  ###
  #  ## # $##
  ##$#   $ @#
   #  $ $ ###
   # #   $  #
   # ##   # #
  ##  ##### #
  #         #
  #.......###
  #.......#
  #########


';
		at: 47 put: '         ####
 #########  ##
##  $      $ #####
#   ## ##   ##...#
# #$$ $ $$#$##...#
# #   @   #   ...#
#  $# ###$$   ...#
# $  $$  $ ##....#
###$       #######
  #  #######
  ####


';
		at: 48 put: '  #########  
  #*.*#*.*#  
  #.*.*.*.#  
  #*.*.*.*#  
  #.*.*.*.#  
  #*.*.*.*#  
  ###   ###  
    #   #    
###### ######
#           #
# $ $ $ $ $ #
## $ $ $ $ ##
 #$ $ $ $ $# 
 #   $@$   # 
 #  #####  # 
 ####   ####


';
		at: 49 put: '       ####
       #  ##
       #   ##
       # $$ ##
     ###$  $ ##
  ####    $   #
###  # #####  #
#    # #....$ #
# #   $ ....# #
#  $ # #.*..# #
###  #### ### #
  #### @$  ##$##
     ### $     #
       #  ##   #
       ######### 


';
		at: 50 put: '      ############
     ##..    #   #
    ##..* $    $ #
   ##..*.# # # $##
   #..*.# # # $  #
####...#  #    # #
#  ## #          #
# @$ $ ###  #   ##
# $   $   # #   #
###$$   # # # # #
  #   $   # # #####
  # $# #####      #
  #$   #   #    # #
  #  ###   ##     #
  #  #      #    ##
  ####      ######


';
		at: 51 put: ' #########
 #       #
 # $ $$ $#
### #  $ #
#.#   $$ ##
#.###   $ #
#.#. $ ## ####
#...  $## $  #
#...$   $    #
#..###$### #@#
#..# #     ###
#### #######


';
		at: 52 put: '           ########
           #......#
   ####    #......#
   #  #########...#
   # $   $    #...#
   #  # # # # #   #
##### # # #@# #   #
#   # ### ### ## ##
#    $ # $ $ $ # #
# $$$  $   #     #
#   # ###$###$## #
### #  $   #     #
 ## $  # $ $ $ ###
 #  # ### ### ##  
 # $          #   
 #  ###########   
 ####


';
		at: 53 put: '##################  
#                ## 
# $#   $ ##  $    # 
#    $###    # $$ # 
#.###     $ $ ##  ##
#...#  #  #    #$  #
#..##$$#### $  #   #
#...#      $ ##  ###
#...$  ###  #    # #
##..  $#  ##   ##@ #
 ##.#              #
  ##################


';
		at: 54 put: '####################
#   #    #   #   #@#
# $      $   $   # #
## ###..## ###     #
#   #....#$#  $### #
# $ #....#  $  $ $ #
#   #....# # # $ $ #
#   ##..##   #$#   #
##$##    ##  #  #$##
#   $  $     #  #  #
#   #    #   #     #
####################


';
		at: 55 put: '####################
#    @##      #   ##
#    ##    $    $ ##
#  ###....# # #  ###
#   #....# # # $   #
### #...#  #       #
##  ##.#     $   $ #
##  $ $ ###  # # ###
## $       # # $   #
#### $  $# # # # $ #
####         # #  ##
####################


';
		at: 56 put: '####################
#  #  ##    #   @###
##    $    # $###  #
##$# $ ##$# $ $    #
#   $#    $      ###
# ##   $ ###  #....#
# # $# # # # #....##
#    $ $ #  #....###
##$ ###  $ #....####
#  # $        ######
#      # #    ######
####################


';
		at: 57 put: '####################
#@     ###   #  #  #
# # #  #  $  $     #
#####     # $ $#$# #
#.#..#    ##$ $    #
#.....    $   #   ##
#.....    ###$##$###
#.#..#    $    #   #
#####     #  #$  $ #
#####  #  $    $ $ #
#####  #  #  #  #  #
####################


';
		at: 58 put: '####################
##...   ## #    #  #
#....         $ ## #
#....# # #$###$    #
#...#    #       # #
##.#  #$ #     $## #
#  #  # $ $ ###  $ #
#     $  $ #  # ## #
## # ## #$$# $#  # #
#  #   $ $ #      ##
#    #     #  #   @#
####################


';
		at: 59 put: '####################
#   #  #@# ##  #####
# # #  $    $  #####
# #    ###### $  ###
#   #  #....#  $$  #
##$##$##....#      #
#      #....##$##$##
#  $$  #....#      #
# $  $  #  #  ###  #
#####  $   $    $  #
##### #    #  #   ##
####################


';
		at: 60 put: '####################
# #     #          #
#       $  ## ### ##
#####  ##   $  $   #
##..##  # # $ # #  #
#....  $     ##$# ##
#....  $#####   #$##
##..# #  #   #  $  #
###.# #  $   $  # @#
##  $  $ #   #  ####
##       ###########
####################


';

		at: 61 put: '####################
#     ###..###     #
# $$  ###..###  $@ #
#  # ##......#  $  #
#     #......#  $  #
####  ###..######$ #
#   $$$ #..#    #  #
# $#   $  $  $$ #$ #
#  #  ## $  ##  #  #
# $    $ ## $    $ #
#  #  ##    ##  #  #
####################


';
		at: 62 put: '####################
#    #  # #  #  #  #
# @# # ## $   $   ##
#### #    #  # $   #
#    # ## #$ ## ## #
#      $   $   $   #
#..###$$## $##$ ## #
#..#.#  # $   $ #  #
#....# $$   ##$ ####
#....#  #####      #
#...###        ##  #
####################


';
		at: 63 put: '####################
#....#       #  #  #
#....# # $  $      #
#.... ##  $# # $#$ #
#...#   $   $#  $  #
#..####  # $   $$  #
#      #### #### ###
#        #   #     #
# ##   #   $ # $ $ #
# ##    $ ## $  $  #
#     @#     #   # #
####################


';
		at: 64 put: '####################
#....###           #
#....##### #  #$# ##
#....###   #$  $   #
#....###    $  #$$##
##  #### $#  #$ $  #
##  ####  $  $  #  #
#@  ####$###$## $  #
##        #  #  $  #
##   ###  #  $  ####
########  #  #     #
####################


';
		at: 65 put: '####################
#     #     @#...###
#     #      ##...##
# # # ##$## ## ....#
#   $ #   $$$  ....#
###$### $$  ### ##.#
#     $  #    # ####
#  $  #  ###  # #  #
## #$##    $  $$   #
#   $ ##   #  # #  #
#     #    #  #    #
####################


';
		at: 66 put: '####################
#     #  #...#@    #
# #       ....#    #
#  $  #   #....#   #
# ##$#### ##....#  #
# $   $  #  #...#  #
# $$ #   #   # $$  #
###  $$$#   $$  $  #
# $  #  #    # $#  #
#   $#  #       $  #
#  #    #    #  #  #
####################


';
		at: 67 put: '####################
#####@###.##...##  #
#####$  ..#...#    #
####    ......#  $ #
###  $ #.....## # ##
##  $$# #####  $ $ #
## $# $    ##  $$  #
##  #  #    # $  $ #
##   $$ ### #$##   #
## $#      $ $  $ ##
###    #    #    ###
####################


';
		at: 68 put: '####################
#@     #   #       #
## ### ##  #### # ##
#    # #  $$       #
#  # # # $ # $ ## ##
#     $ #  #$$ #   #
#  ###  #      ## ##
#..#.# $ #  $ #    #
#..#.#  $ # ## $$  #
#....##   $$  $  # #
#.....##        #  #
####################


';
		at: 69 put: '####################
#  #      #   #   ##
# $# $ $ ##...$  $ #
#  $  # ##....# $  #
# ## $ ##....#   $ #
# $    #....## $   #
# $##  #...#       #
#   $$$##$##  ### ##
# # #  #   #  #    #
# $ #  $  ##       #
#    #    #@       #
####################


';
		at: 70 put: '####################
#  #  # #    #  #  #
#   $      $ $     #
## #  #$###$##  ## #
#   $     $  #  $  #
# ###$##$#   # $   #
# #   $ $  ###### $#
# $  $$ $  #@#.#...#
# #     #  # #.#...#
# ########## #.....#
#            #.....#
####################


';
		at: 71 put: '####################
#  #     #  ##    ##
# $#   $ #     ##  #
# $  $  #..#     $ #
# $ $  #....#   # ##
# $#  #......### $ #
#   #  #....#  #$  #
# $  ####..#   #   #
## $   ## # # $  $##
### $    $#@$ $#   #
####   #       #   #
####################


';
		at: 72 put: '####################
#      ....#    ####
#      ....        #
# # ##########     #
# #$   #      ###..#
#  $   #$$###   #..#
# $ ### $   $   #..#
# $ #   $ $ #  ##..#
#  #  $$ # $ ##   ##
#@## $#  $  $     ##
##       ##   #  ###
####################


';
		at: 73 put: '####################
#        #   #@ #  #
# $$  #$$# # #  ## #
#  # $ $ #$$ #     #
## #  #  # # #  #  #
#   ##       #     #
#   # $ #   #   #  #
# $ #$ #   #  $ #..#
##$ #  ####    #...#
#  $          #....#
#   #  #     #.....#
####################


';
		at: 74 put: '####################
#     #   #####    #
## $  #   ####  $  #
#### $$   #..#  #  #
#  $  $  ##..#### ##
# $   ###....   $$ #
#  #$#   ....# # $ #
# #  # $ ..###$#   #
# #   $ #..#   ##  #
#   $#  ####   # $##
# #  #    @#      ##
####################


';
		at: 75 put: '####################
#   #   #    #   #@#
#   $  $     # $ # #
##$# $### #    $$# #
#  #  #.###  #$ $  #
#  #$#....#  # ### #
# $  #.....##    # #
##$  #.#....#$$ $  #
#  ######..## #  # #
#  $         $ ### #
#   #   #        # #
####################


';
		at: 76 put: '####################
# # # #   #@##   # #
#             $    #
#  ##$# ##### $ # ##
##    ##.....#  #  #
##$##$#.....###$#$ #
#   # ##.....#  # ##
#  $    ##..##  #  #
# $ #   $   $  $$$ #
## $  $# #  #  $   #
#   ##   #  #      #
####################


';
		at: 77 put: '####################
#    ##   #    #   #
#  $  $     ## $   #
## #####  .###### ##
 # ##  ##....#### ##
## ##$ ###..##     #
#      #... .# $ $ #
# $ ## ## . ### ####
# # $    #.## # #
# $ $ #   .#### ##
# #  ## # ##  #  ##
#######  $##$   $ #
      ##      $ #@#
       #  ## ######
       #######


';
		at: 78 put: '       ###########
       #         #
       #    $ $  #
###### # $ ##### #
#    ##### $  ##$#
#       $ $      #
#          ## ## #
#    ##@##### ## #
#    ####   # ## ##
#....#      # $   #
#....#      #     #
######      #######


';
		at: 79 put: '#############
#           #
# ### $$    #
#   # $  $  #
#  $####$######
# $ ##        #####
#  $$ $        ...#
### ## $$#     ...#
  # ##   #     ...#
  #      #     ...#
  ###@#############
    ###


';
		at: 80 put: '  #################
###@##         ...#
#    #         ...#
# $  #         ...#
# $$ #         ...#
## $ ###$##########
 # ###  $ #
##   $  $ #
#  $ #  $ #
# $  #    #
#  $ #    #
#    #    #
###########


';
		at: 81 put: '              #####
     ##########   #
     #        #   #
     #  $ $    $$ #
     # ##### ## $ #
     #$$   #$## $ #
     # ### # ##$  #
###### ### $ $    #
#....        ##   #
#....        ######
#....        #
###########@##
          ###


';
		at: 82 put: '    ######
 ####    #
 #    ## #
 # $     #
### #### ########
#  $   $ ##  ...#
#   $$ $$    ...#
#    $  $##  ...#
##@## ## ##  ...#
 ###  $  ########
 #   $$  #
 #    #  #
 #########


';
		at: 83 put: '####### #########
#     # #   ##  #
# ### # #   $   #
# # $ ###   $   #
#   $$      ##$ #
#    ####   ##  #
#@############ ##
###..    #####$ #
  #..    ####   #
  #..       $$  #
  #..    #### $ #
  #..    #  #   #
  ########  #####


';
		at: 84 put: '#######
#     ##########
#     #    #  ##
# $   #   $ $  #
#  $  #  $ ##  #
# $$  ##$ $    #
## #  ## #######
## #  ##    ...#
#  #$       ...#
#   $$      ...#
#     ##@#  ...#
################


';
		at: 85 put: '############
#      #   ##
# $  $   #  ######
####  #####      #
 #..  #     #### #
 #.####  ####    #
 #....    #  $ ####
 # ...#   # $$$#  ##
###.#### ##  $@$   #
#     ##### $ #    #
# #.# $      $###$ #
# #.########  #  $ #
# #..        ##  $ #
# # ####### $ # #  #
#   #     #       ##
#####     ##########


';
		at: 86 put: '################
#       #@ #   #
# # # # # $  $$#
# #...# #$$$   #
#  ...# # $  $$##
# ##.## # ##    #
# #...     $    #
# ## ###  #######
#    # ####
######


';
		at: 87 put: '    #####
 ####   ## #####
 #  $    ###   #
 # $@$ $    $  #
 # #$######## ##
 # #  $  #     #
 # # $ $ # #   #
## #  $# # #####
#  ##    #     #
#    $ # ###   #
##### ##  #....#
#    $     ....#
#         #....#
################


';
		at: 88 put: '#############
#........####
#...#### #  #####
#...#  ###    $ #
#...$$     $ $  #
#  .#  $ $# $  ##
#...# #$#   $  #
#.# # $   $    #
#.  #$###$####$#
##  #   $ $    #
 #  #  $@$  #  #
 #  # #### $  $#
 #  #    ###   #
 #  # $$ # #####
 #  #    #
 #########


';
		at: 89 put: ' ##################
 #   $       ...#.##
 #       ####..... #
 # #######  #..... #
 # #    $ $ ##....##
 # #  $ # # ###...#
 # # $@$ $  ##### #
## #  $  $ $$   $ #
#  #$# $#   # $## #
# ##    ## ## $ # #
# # $# $ $  #     #
# #         #######
# ########$##   #
#        #  $   #
########    #####
       ###  #
         ####


';
		at: 90 put: '####################
#..#    #          #
#.$  $  #$$  $## $##
#.$#  ###  ## ##   #
#  # $ #  $$   $   #
# ###  # #  #$  ####
#  ## # $   #@ #   #
# $    $  ##.##  $ #
#  # $# $# $     ###
#  #  #  #   ###   #
#  ######## #      #
#           #  #.#.#
##$########$#   ...#
#    .*  #    ##.#.#
# .*...*   $  .....#
####################



';
		yourself! !

!SokobanWorld class methodsFor: 'mazes' stamp: 'rhi 9/9/2004 13:27'!
setMazesNamed: aSymbol

	self
		mazes: (self mazeSets at: aSymbol) value;
		mazeSetName: (self mazeSetNamesAt: aSymbol).! !

!SokobanWorld class methodsFor: 'private' stamp: 'rhi 7/17/2003 12:17'!
blockForFixed: aCharacter

	^ (self blocksForFixed at: aCharacter) value! !

!SokobanWorld class methodsFor: 'private' stamp: 'rhi 7/17/2003 12:17'!
blockForMovable: aCharacter

	^ (self blocksForMovable at: aCharacter) value! !

!SokobanWorld class methodsFor: 'private' stamp: 'rhi 7/17/2003 12:21'!
blocksForFixed

	^ IdentityDictionary new
		at: self box put: [nil];
		at: self boxAtGoal put: [SokobanGoal new];
		at: self free put: [nil];
		at: self goal put: [SokobanGoal new];
		at: self player put: [nil];
		at: self wall put: [SokobanWall new];
		yourself! !

!SokobanWorld class methodsFor: 'private' stamp: 'rhi 7/17/2003 12:21'!
blocksForMovable

	^ IdentityDictionary new
		at: self box put: [SokobanBox new];
		at: self boxAtGoal put: [SokobanBox new];
		at: self free put: [nil];
		at: self goal put: [nil];
		at: self player put: [SokobanPlayer new];
		at: self wall put: [nil];
		yourself! !

!SokobanWorld class methodsFor: 'private' stamp: 'rhi 7/17/2003 12:48'!
boxesFrom: aSokobanField

	| boxes |
	boxes := Set new.
	aSokobanField rows do: [:row |
		boxes addAll: (row select: [:block | block isSokobanBox])].
	^ boxes! !

!SokobanWorld class methodsFor: 'private' stamp: 'rhi 5/13/2007 19:46'!
fixedFrom: aString

	| maze field row string char block |
	self flag: 'TODO' "Refactor?!!!! ... see #movableFrom:".
	maze := self mazeFrom: aString.
	field := SokobanField new.
	1 to: maze size do: [:y |
		string := maze at: y.
		row := OrderedCollection new.
		1 to: string size do: [:x |
			char := string at: x.
			block := self blockForFixed: char.
			block isSokobanBlock ifTrue: [block location: x @ y].
			row add: block].
		field addRow: row].
	^ field! !

!SokobanWorld class methodsFor: 'private' stamp: 'rhi 5/13/2007 19:43'!
importHackMazesFromFile: aString
	"inspectIt: [self importHackMazesFromFile: './SokobanPuzzles/loma.txt']"
	"inspectIt: [self importHackMazesFromFile: './SokobanPuzzles/masmicroban.txt']"
	"inspectIt: [self importHackMazesFromFile: './SokobanPuzzles/massasquatch.txt']"
	"inspectIt: [self importHackMazesFromFile: './SokobanPuzzles/microban.txt']"
	"inspectIt: [self importHackMazesFromFile: './SokobanPuzzles/sasquatch.txt']"
	"inspectIt: [self importHackMazesFromFile: './SokobanPuzzles/sasquatchiii.txt']"
	"inspectIt: [self importHackMazesFromFile: './SokobanPuzzles/sasquatchiv.txt']"
	"inspectIt: [self importHackMazesFromFile: './SokobanPuzzles/sasquatchv.txt']"
	"inspectIt: [self importHackMazesFromFile: './SokobanPuzzles/sasquatchvi.txt']"

	| lines imported lastLineWasEmpty count maze beforeFirst code |
	self flag: #rhi. "Very bad, but good enough..."
	lines := (FileStream fileNamed: (FileDirectory pathFromURI: aString)) contentsOfEntireFile findTokens: String crlf.
	imported := IdentityDictionary new.
	lastLineWasEmpty := true.
	count := 0.
	lines do: [:line |
		(line withBlanksTrimmed isEmpty or: [#($; $') includes: line first])
			ifTrue: [lastLineWasEmpty := true]
			ifFalse: [
				lastLineWasEmpty ifTrue: [
					lastLineWasEmpty := false.
					count := count + 1].
				(imported at: count ifAbsentPut: [OrderedCollection new]) add: line]].
	"-=-=-=-=-=-=-=-=-=-="
	imported copy keysAndValuesDo: [:idx :coll |
		maze := WriteStream on: String new.
		beforeFirst := true.
		coll do: [:line |
			beforeFirst
				ifTrue: [beforeFirst := false]
				ifFalse: [maze nextPut: Character lf].
			maze nextPutAll: line].
		imported at: idx put: maze contents].
	"-=-=-=-=-=-=-=-=-=-="
	code := WriteStream with: '	^ IdentityDictionary new'.
	imported keysAndValuesDo: [:idx :str |
		code
			cr;
			nextPutAll: '		at: ';
			nextPutAll: idx printString;
			nextPutAll: ' put: ';
			nextPutAll: str printString;
			nextPut: $;].
	"-=-=-=-=-=-=-=-=-=-="
	^ code contents! !

!SokobanWorld class methodsFor: 'private' stamp: 'rhi 7/30/2003 12:44'!
mazeFrom: aString

	^ (self tokensFrom: aString) do: [:row |
		row replaceAll: self playerAtGoal with: self player]! !

!SokobanWorld class methodsFor: 'private' stamp: 'rhi 5/13/2007 19:46'!
movableFrom: aString

	| maze field row string char block |
	self flag: 'TODO' "Refactor?!!!! ... see #fixedFrom:".
	maze := self mazeFrom: aString.
	field := SokobanField new.
	1 to: maze size do: [:y |
		string := maze at: y.
		row := OrderedCollection new.
		1 to: string size do: [:x |
			char := string at: x.
			block := self blockForMovable: char.
			block isSokobanBlock ifTrue: [block location: x @ y].
			row add: block].
		field addRow: row].
	^ field! !

!SokobanWorld class methodsFor: 'private' stamp: 'rhi 7/17/2003 10:59'!
playerFrom: aSokobanField

	aSokobanField rows do: [:row |
		row do: [:block | block isSokobanPlayer ifTrue: [^ block]]].
	self error: 'Player missing...'.! !

!SokobanWorld class methodsFor: 'private' stamp: 'rhi 7/16/2003 21:17'!
rangeFrom: aString

	| maze |
	maze := self mazeFrom: aString.
	^ (maze inject: 0 into: [:longest :each | each size max: longest]) @ maze size! !

!SokobanWorld class methodsFor: 'private' stamp: 'rhi 7/30/2003 12:41'!
tokensFrom: aString

	^ aString findTokens: String crlf! !

!SokobanWorld class methodsFor: 'private' stamp: 'rhi 7/30/2003 12:43'!
wallsFrom: aString

	^ (self tokensFrom: aString) do: [:row |
		row
			replaceAll: self player with: self free;
			replaceAll: self box with: self free;
			replaceAll: self boxAtGoal with: self goal;
			replaceAll: self playerAtGoal with: self goal]! !

SokobanWorld initialize!
SokobanTheme initialize!
SokobanBlock initialize!
